/////////////////////////////////////////////////////////////////////
// D.A.L.L.A.S. Generated Level Script - DLL Source File
// 
// Filename:	ATC.cpp
// Version:	3
/////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "osiris_import.h"
#include "osiris_common.h"
#include "dallasfuncs.cpp"

#ifdef _MSC_VER		//Visual C++ Build
#define STDCALL		__stdcall
#define STDCALLPTR	*STDCALL
#else					//Non-Visual C++ Build
#define STDCALL __attribute__((stdcall))
#define STDCALLPTR	STDCALL*
#endif

#ifdef __cplusplus
extern "C"{
#endif
char		STDCALL InitializeDLL(tOSIRISModuleInit *func_list);
void		STDCALL ShutdownDLL(void);
int		STDCALL GetGOScriptID(char *name,ubyte is_door);
void		STDCALLPTR CreateInstance(int id);
void		STDCALL DestroyInstance(int id,void *ptr);
short	STDCALL CallInstanceEvent(int id,void *ptr,int event,tOSIRISEventInfo *data);
int		STDCALL GetTriggerScriptID(int trigger_room, int trigger_face );
int		STDCALL GetCOScriptList( int **list, int **id_list );
int		STDCALL SaveRestoreState( void *file_ptr, ubyte saving_state );
#ifdef __cplusplus
}
#endif

// =================
// Script ID Numbers
// =================
#define ID_LEVEL_0000			0x000

#define ID_CUSTOM_OBJECT_1817		0x001
#define ID_CUSTOM_OBJECT_1016		0x002
#define ID_CUSTOM_OBJECT_2018		0x003
#define ID_CUSTOM_OBJECT_080B		0x004
#define ID_CUSTOM_OBJECT_080A		0x005
#define ID_CUSTOM_OBJECT_1006		0x006

#define ID_TRIGGER_0000		0x007
#define ID_TRIGGER_0001		0x008
#define ID_TRIGGER_FFFFFFFF		0x009

// ========================
// Script Class Definitions
// ========================

class BaseScript {
public:
	BaseScript();
	~BaseScript();
	virtual short CallEvent(int event, tOSIRISEventInfo *data);
};

class LevelScript_0000 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_1817 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_1016 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_2018 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_080B : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_080A : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_1006 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class TriggerScript_0000 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class TriggerScript_0001 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class TriggerScript_FFFFFFFF : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

// ======================
// Global Action Counters
// ======================

#define MAX_ACTION_CTR_VALUE		100000

int ScriptActionCtr_000 = 0;
int ScriptActionCtr_005 = 0;
int ScriptActionCtr_008 = 0;
int ScriptActionCtr_009 = 0;
int ScriptActionCtr_010 = 0;
int ScriptActionCtr_011 = 0;
int ScriptActionCtr_012 = 0;
int ScriptActionCtr_013 = 0;
int ScriptActionCtr_014 = 0;
int ScriptActionCtr_015 = 0;
int ScriptActionCtr_016 = 0;
int ScriptActionCtr_001 = 0;
int ScriptActionCtr_003 = 0;
int ScriptActionCtr_006 = 0;
int ScriptActionCtr_002 = 0;
int ScriptActionCtr_007 = 0;
int ScriptActionCtr_004 = 0;
 
// ========================================
// Function to Clear Global Action Counters
// ========================================
void ClearGlobalActionCtrs(void)
{
	ScriptActionCtr_000 = 0;
	ScriptActionCtr_005 = 0;
	ScriptActionCtr_008 = 0;
	ScriptActionCtr_009 = 0;
	ScriptActionCtr_010 = 0;
	ScriptActionCtr_011 = 0;
	ScriptActionCtr_012 = 0;
	ScriptActionCtr_013 = 0;
	ScriptActionCtr_014 = 0;
	ScriptActionCtr_015 = 0;
	ScriptActionCtr_016 = 0;
	ScriptActionCtr_001 = 0;
	ScriptActionCtr_003 = 0;
	ScriptActionCtr_006 = 0;
	ScriptActionCtr_002 = 0;
	ScriptActionCtr_007 = 0;
	ScriptActionCtr_004 = 0;
}
 
// ========================================
// Function to Save Global Action Counters
// ========================================
void SaveGlobalActionCtrs(void *file_ptr)
{
	File_WriteInt(ScriptActionCtr_000,file_ptr);
	File_WriteInt(ScriptActionCtr_005,file_ptr);
	File_WriteInt(ScriptActionCtr_008,file_ptr);
	File_WriteInt(ScriptActionCtr_009,file_ptr);
	File_WriteInt(ScriptActionCtr_010,file_ptr);
	File_WriteInt(ScriptActionCtr_011,file_ptr);
	File_WriteInt(ScriptActionCtr_012,file_ptr);
	File_WriteInt(ScriptActionCtr_013,file_ptr);
	File_WriteInt(ScriptActionCtr_014,file_ptr);
	File_WriteInt(ScriptActionCtr_015,file_ptr);
	File_WriteInt(ScriptActionCtr_016,file_ptr);
	File_WriteInt(ScriptActionCtr_001,file_ptr);
	File_WriteInt(ScriptActionCtr_003,file_ptr);
	File_WriteInt(ScriptActionCtr_006,file_ptr);
	File_WriteInt(ScriptActionCtr_002,file_ptr);
	File_WriteInt(ScriptActionCtr_007,file_ptr);
	File_WriteInt(ScriptActionCtr_004,file_ptr);
}
 
// ===========================================
// Function to Restore Global Action Counters
// ===========================================
void RestoreGlobalActionCtrs(void *file_ptr)
{
	ScriptActionCtr_000=File_ReadInt(file_ptr);
	ScriptActionCtr_005=File_ReadInt(file_ptr);
	ScriptActionCtr_008=File_ReadInt(file_ptr);
	ScriptActionCtr_009=File_ReadInt(file_ptr);
	ScriptActionCtr_010=File_ReadInt(file_ptr);
	ScriptActionCtr_011=File_ReadInt(file_ptr);
	ScriptActionCtr_012=File_ReadInt(file_ptr);
	ScriptActionCtr_013=File_ReadInt(file_ptr);
	ScriptActionCtr_014=File_ReadInt(file_ptr);
	ScriptActionCtr_015=File_ReadInt(file_ptr);
	ScriptActionCtr_016=File_ReadInt(file_ptr);
	ScriptActionCtr_001=File_ReadInt(file_ptr);
	ScriptActionCtr_003=File_ReadInt(file_ptr);
	ScriptActionCtr_006=File_ReadInt(file_ptr);
	ScriptActionCtr_002=File_ReadInt(file_ptr);
	ScriptActionCtr_007=File_ReadInt(file_ptr);
	ScriptActionCtr_004=File_ReadInt(file_ptr);
}
 
 
// ===============================================================
// Start of Custom Script Block - DO NOT EDIT ANYTHING BEFORE THIS
// ===============================================================
/**{CUSTOM_SCRIPT_BLOCK_START}** DO NOT EDIT! **/

/**{CUSTOM_SCRIPT_BLOCK_END}**** DO NOT EDIT! **/
// ============================================================
// End of Custom Script Block - DO NOT EDIT ANYTHING AFTER THIS
// ============================================================
 
 
// =================
// Message File Data
// =================
 
#define MAX_SCRIPT_MESSAGES	256
#define MAX_MSG_FILEBUF_LEN	1024
#define NO_MESSAGE_STRING		"*Message Not Found*"
#define INV_MSGNAME_STRING	"*Message Name Invalid*"
#define WHITESPACE_CHARS	" \t\r\n"
 
// Structure for storing a script message
typedef struct {
	char *name;			// the name of the message
	char *message;		// the actual message text
} tScriptMessage;
 
// Global storage for level script messages
tScriptMessage *message_list[MAX_SCRIPT_MESSAGES];
int num_messages;
 
// ======================
// Message File Functions
// ======================
 
// Initializes the Message List
void InitMessageList(void)
{
	for(int j=0;j<MAX_SCRIPT_MESSAGES;j++)
		message_list[j]=NULL;
	num_messages=0;
}
 
// Clear the Message List
void ClearMessageList(void)
{
	for(int j=0;j<num_messages;j++) {
		free(message_list[j]->name);
		free(message_list[j]->message);
		free(message_list[j]);
		message_list[j]=NULL;
	}
	num_messages=0;
}
 
// Adds a message to the list
int AddMessageToList(char *name, char *msg)
{
	int pos;
 
	// Make sure there is room in the list
	if(num_messages>=MAX_SCRIPT_MESSAGES) return false;
 
	// Allocate memory for this message entry
	pos=num_messages;
	message_list[pos]=(tScriptMessage *)malloc(sizeof(tScriptMessage));
	if(message_list[pos]==NULL) return false;
 
	// Allocate memory for the message name
	message_list[pos]->name=(char *)malloc(strlen(name)+1);
	if(message_list[pos]->name==NULL) {
		free(message_list[pos]);
		return false;
	}
	strcpy(message_list[pos]->name,name);
 
	// Allocate memory for the message name
	message_list[pos]->message=(char *)malloc(strlen(msg)+1);
	if(message_list[pos]->message==NULL) {
		free(message_list[pos]->name);
		free(message_list[pos]);
		return false;
	}
	strcpy(message_list[pos]->message,msg);
	num_messages++;
 
	return true;
}
 
// Removes any whitespace padding from the end of a string
void RemoveTrailingWhitespace(char *s)
{
	int last_char_pos;
 
	last_char_pos=strlen(s)-1;
	while(last_char_pos>=0 && isspace(s[last_char_pos])) {
		s[last_char_pos]='\0';
		last_char_pos--;
	}
}
 
// Returns a pointer to the first non-whitespace char in given string
char *SkipInitialWhitespace(char *s)
{
	while((*s)!='\0' && isspace(*s)) 
		s++;
 
	return(s);
}
 
// Read in the Messages
int ReadMessageFile(char *filename)
{
	void *infile;
	char filebuffer[MAX_MSG_FILEBUF_LEN+1];
	char *line, *msg_start;
	int line_num;
	bool next_msgid_found;
 
	// Try to open the file for loading
	infile=File_Open(filename,"rt");
	if (!infile) return false;
 
	line_num=0;
	next_msgid_found=true;
 
	// Clear the message list
	ClearMessageList();
 
	// Read in and parse each line of the file
	while (!File_eof(infile)) {
 
		// Clear the buffer
		strcpy(filebuffer,"");
 
		// Read in a line from the file
		File_ReadString(filebuffer, MAX_MSG_FILEBUF_LEN, infile);
		line_num++;
 
		// Remove whitespace padding at start and end of line
		RemoveTrailingWhitespace(filebuffer);
		line=SkipInitialWhitespace(filebuffer);
 
		// If line is a comment, or empty, discard it
		if(strlen(line)==0 || strncmp(line,"//",2)==0)
			continue;
 
		if(!next_msgid_found) {		// Parse out the last message ID number
 
			// Grab the first keyword, make sure it's valid
			line=strtok(line,WHITESPACE_CHARS);
			if(line==NULL) continue;
 
			// Grab the second keyword, and assign it as the next message ID
			line=strtok(NULL,WHITESPACE_CHARS);
			if(line==NULL) continue;
 
			next_msgid_found=true;
		}
		else {	// Parse line as a message line
			
			// Find the start of message, and mark it
			msg_start=strchr(line,'=');
			if(msg_start==NULL) continue;
			msg_start[0]='\0';
			msg_start++;
			
			// Add the message to the list
			AddMessageToList(line,msg_start);
		}
	}
	File_Close(infile);
 
	return true;
}
 
// Find a message
char *GetMessage(char *name)
{
	// Make sure given name is valid
	if(name==NULL) return INV_MSGNAME_STRING;
 
	// Search message list for name
	for(int j=0;j<num_messages;j++)
		if(strcmp(message_list[j]->name,name)==0) return(message_list[j]->message);
 
	// Couldn't find it
	return NO_MESSAGE_STRING;
}
 
 
//======================
// Name List Arrays     
//======================
 
#define NUM_DOOR_NAMES		7
char *Door_names[NUM_DOOR_NAMES] = {
	"Blue Door",
	"Blue Door II",
	"Yellow Door",
	"Yellow Door II",
	"Yellow Door III",
	"Red Door",
	"Lab Door"
};
int Door_handles[NUM_DOOR_NAMES];
 
#define NUM_OBJECT_NAMES		7
char *Object_names[NUM_OBJECT_NAMES] = {
	"Reactor",
	"Key Blue",
	"Key Red",
	"Blue Door",
	"Blue Door II",
	"Red Door",
	"Quake_Explosion"
};
int Object_handles[NUM_OBJECT_NAMES];
 
#define NUM_ROOM_NAMES		12
char *Room_names[NUM_ROOM_NAMES] = {
	"16",
	"Reactor",
	"23",
	"30",
	"58",
	"60",
	"20",
	"26",
	"28",
	"1",
	"Energy - 1",
	"Reactor Center"
};
int Room_indexes[NUM_ROOM_NAMES];
 
#define NUM_TRIGGER_NAMES		2
char *Trigger_names[NUM_TRIGGER_NAMES] = {
	"Reactor_Temperature",
	"GB_NoWaterReactor"
};
int Trigger_indexes[NUM_TRIGGER_NAMES];
int Trigger_faces[NUM_TRIGGER_NAMES];
int Trigger_rooms[NUM_TRIGGER_NAMES];
 
#define NUM_SOUND_NAMES		3
char *Sound_names[NUM_SOUND_NAMES] = {
	"ReactorDrone",
	"Powerup pickup",
	"AmbExplosionFarD"
};
int Sound_indexes[NUM_SOUND_NAMES];
 
#define NUM_TEXTURE_NAMES		4
char *Texture_names[NUM_TEXTURE_NAMES] = {
	"PondRipple1",
	"DeletedTexture",
	"TFZ_Ice - Ice Slates",
	"P-MonTempAbov"
};
int Texture_indexes[NUM_TEXTURE_NAMES];
 
#define NUM_PATH_NAMES		0
char **Path_names=NULL;
int *Path_indexes=NULL;
 
#define NUM_MATCEN_NAMES		0
char **Matcen_names=NULL;
int *Matcen_indexes=NULL;
 
#define NUM_GOAL_NAMES		0
char **Goal_names=NULL;
int *Goal_indexes=NULL;
 
#define NUM_MESSAGE_NAMES		10
char *Message_names[NUM_MESSAGE_NAMES] = {
	"GB_KeyBlue",
	"Key_Blue",
	"GB_KeyRed",
	"Key_Red",
	"GB_KeyYellow",
	"Key_Yellow",
	"GB_ReactorMeltdown",
	"GB_ReactorCountdown",
	"GB_NoWaterReactor",
	"Empty"
};
char *Message_strings[NUM_MESSAGE_NAMES];
 
// ===============
// InitializeDLL()
// ===============
char STDCALL InitializeDLL(tOSIRISModuleInit *func_list)
{
	osicommon_Initialize((tOSIRISModuleInit *)func_list);
 
	ClearGlobalActionCtrs();
	dfInit();
	InitMessageList();
 
	// Build the filename of the message file
	char filename[_MAX_PATH+1];
	char english_filename[_MAX_PATH+1];
	int lang_type;
	if(func_list->script_identifier!=NULL) {
		_splitpath(func_list->script_identifier,NULL,NULL,filename,NULL);
		sprintf(english_filename,"%s.msg",filename);
		lang_type=Game_GetLanguage();
		if(lang_type==LANGUAGE_FRENCH) strcat(filename,"_FRN");
		else if(lang_type==LANGUAGE_GERMAN) strcat(filename,"_GER");
		else if(lang_type==LANGUAGE_ITALIAN) strcat(filename,"_ITN");
		else if(lang_type==LANGUAGE_SPANISH) strcat(filename,"_SPN");
		else if(lang_type==LANGUAGE_POLISH) strcat(filename,"_POL");
		strcat(filename,".msg");
	}
	else {
		strcpy(filename,"ATC.msg");
		lang_type=LANGUAGE_ENGLISH;
	}
	if(!ReadMessageFile(filename)) {
		if(lang_type == LANGUAGE_ENGLISH) {
			mprintf(0,"ERROR: Could not load message file - %s\n",filename);
		}
		else if(!ReadMessageFile(english_filename)) {
			mprintf(0,"ERROR: Could not load message file - %s\n",english_filename);
		}
	}
 
	int j;
 
	// Do Door Index lookups
	for(j=0;j<NUM_DOOR_NAMES;j++) 
		Door_handles[j]=Scrpt_FindDoorName(Door_names[j]);
 
	// Do Object Index lookups
	for(j=0;j<NUM_OBJECT_NAMES;j++) 
		Object_handles[j]=Scrpt_FindObjectName(Object_names[j]);
 
	// Do Room Index lookups
	for(j=0;j<NUM_ROOM_NAMES;j++) 
		Room_indexes[j]=Scrpt_FindRoomName(Room_names[j]);
 
	// Do Trigger Index lookups
	for(j=0;j<NUM_TRIGGER_NAMES;j++) {
		Trigger_indexes[j]=Scrpt_FindTriggerName(Trigger_names[j]);
		Trigger_faces[j]=Scrpt_GetTriggerFace(Trigger_indexes[j]);
		Trigger_rooms[j]=Scrpt_GetTriggerRoom(Trigger_indexes[j]);
	}
 
	// Do Sound Index lookups
	for(j=0;j<NUM_SOUND_NAMES;j++) 
		Sound_indexes[j]=Scrpt_FindSoundName(Sound_names[j]);
 
	// Do Texture Index lookups
	for(j=0;j<NUM_TEXTURE_NAMES;j++) 
		Texture_indexes[j]=Scrpt_FindTextureName(Texture_names[j]);
 
	// Do Path Index lookups
	for(j=0;j<NUM_PATH_NAMES;j++) 
		Path_indexes[j]=Scrpt_FindPathName(Path_names[j]);
 
	// Do Matcen Index lookups
	for(j=0;j<NUM_MATCEN_NAMES;j++) 
		Matcen_indexes[j]=Scrpt_FindMatcenName(Matcen_names[j]);
 
	// Do Goal Index lookups
	for(j=0;j<NUM_GOAL_NAMES;j++) 
		Goal_indexes[j]=Scrpt_FindLevelGoalName(Goal_names[j]);
 
	// Do Message Name lookups
	for(j=0;j<NUM_MESSAGE_NAMES;j++) 
		Message_strings[j]=GetMessage(Message_names[j]);
 
	return 1;
}

// =============
// ShutdownDLL()
// =============
void STDCALL ShutdownDLL(void)
{
	ClearMessageList();
}

// ===============
// GetGOScriptID()
// ===============
int STDCALL GetGOScriptID(char *name,ubyte isdoor)
{
	return -1;
}

// ================
// CreateInstance()
// ================
void STDCALLPTR CreateInstance(int id)
{
	switch(id) {
		case ID_LEVEL_0000:
			return new LevelScript_0000;
			break;
		case ID_CUSTOM_OBJECT_1817:
			return new CustomObjectScript_1817;
			break;
		case ID_CUSTOM_OBJECT_1016:
			return new CustomObjectScript_1016;
			break;
		case ID_CUSTOM_OBJECT_2018:
			return new CustomObjectScript_2018;
			break;
		case ID_CUSTOM_OBJECT_080B:
			return new CustomObjectScript_080B;
			break;
		case ID_CUSTOM_OBJECT_080A:
			return new CustomObjectScript_080A;
			break;
		case ID_CUSTOM_OBJECT_1006:
			return new CustomObjectScript_1006;
			break;
		case ID_TRIGGER_0000:
			return new TriggerScript_0000;
			break;
		case ID_TRIGGER_0001:
			return new TriggerScript_0001;
			break;
		case ID_TRIGGER_FFFFFFFF:
			return new TriggerScript_FFFFFFFF;
			break;
		default:
			mprintf(0,"SCRIPT: Illegal ID (%d)\n",id);
			break;
	}
	return NULL;
}

// =================
// DestroyInstance()
// =================
void STDCALL DestroyInstance(int id,void *ptr)
{
	switch(id) {
		case ID_LEVEL_0000:
			delete ((LevelScript_0000 *)ptr);
		case ID_CUSTOM_OBJECT_1817:
			delete ((CustomObjectScript_1817 *)ptr);
			break;
		case ID_CUSTOM_OBJECT_1016:
			delete ((CustomObjectScript_1016 *)ptr);
			break;
		case ID_CUSTOM_OBJECT_2018:
			delete ((CustomObjectScript_2018 *)ptr);
			break;
		case ID_CUSTOM_OBJECT_080B:
			delete ((CustomObjectScript_080B *)ptr);
			break;
		case ID_CUSTOM_OBJECT_080A:
			delete ((CustomObjectScript_080A *)ptr);
			break;
		case ID_CUSTOM_OBJECT_1006:
			delete ((CustomObjectScript_1006 *)ptr);
			break;
		case ID_TRIGGER_0000:
			delete ((TriggerScript_0000 *)ptr);
			break;
		case ID_TRIGGER_0001:
			delete ((TriggerScript_0001 *)ptr);
			break;
		case ID_TRIGGER_FFFFFFFF:
			delete ((TriggerScript_FFFFFFFF *)ptr);
			break;
		default:
			mprintf(0,"SCRIPT: Illegal ID (%d)\n",id);
			break;
	}
}

// ===================
// CallInstanceEvent()
// ===================
short STDCALL CallInstanceEvent(int id,void *ptr,int event,tOSIRISEventInfo *data)
{
	switch(id) {
		case ID_LEVEL_0000:
		case ID_CUSTOM_OBJECT_1817:
		case ID_CUSTOM_OBJECT_1016:
		case ID_CUSTOM_OBJECT_2018:
		case ID_CUSTOM_OBJECT_080B:
		case ID_CUSTOM_OBJECT_080A:
		case ID_CUSTOM_OBJECT_1006:
		case ID_TRIGGER_0000:
		case ID_TRIGGER_0001:
		case ID_TRIGGER_FFFFFFFF:
			return ((BaseScript *)ptr)->CallEvent(event,data);
			break;
		default:
			mprintf(0,"SCRIPT: Illegal ID (%d)\n",id);
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

// ==================
// SaveRestoreState()
// ==================
int STDCALL SaveRestoreState( void *file_ptr, ubyte saving_state )
{
	return 0;
}

// ====================
// GetTriggerScriptID()
// ====================
int	STDCALL GetTriggerScriptID(int trigger_room,int trigger_face)
{
	if(trigger_room==Trigger_rooms[0] && trigger_face==Trigger_faces[0])
		return ID_TRIGGER_0000;
 
	if(trigger_room==Trigger_rooms[1] && trigger_face==Trigger_faces[1])
		return ID_TRIGGER_0001;
 
	if(trigger_room==-1 && trigger_face==-1)
		return ID_TRIGGER_FFFFFFFF;
 
	return -1;
}

// =================
// GetCOScriptList()
// =================
int	STDCALL GetCOScriptList( int **list, int **id_list )
{
	static int cust_handle_list[6];
	static int cust_id_list[6] = { 
		ID_CUSTOM_OBJECT_1817,
		ID_CUSTOM_OBJECT_1016,
		ID_CUSTOM_OBJECT_2018,
		ID_CUSTOM_OBJECT_080B,
		ID_CUSTOM_OBJECT_080A,
		ID_CUSTOM_OBJECT_1006
	};
 
	// Fill in the custom handle list
	cust_handle_list[0]=Object_handles[1];
	cust_handle_list[1]=Object_handles[2];
	cust_handle_list[2]=Object_handles[0];
	cust_handle_list[3]=Object_handles[3];
	cust_handle_list[4]=Object_handles[4];
	cust_handle_list[5]=Object_handles[5];

	*list = cust_handle_list;
	*id_list = cust_id_list;

	return 6;
}

//=======================
// Script Implementation 
//=======================

BaseScript::BaseScript()
{
}

BaseScript::~BaseScript()
{
}

short BaseScript::CallEvent(int event,tOSIRISEventInfo *data)
{
	mprintf(0,"BaseScript::CallEvent()\n");
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short LevelScript_0000::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_SAVESTATE:
			{
				tOSIRISEVTSAVESTATE *event_data=&data->evt_savestate;
	
				SaveGlobalActionCtrs(event_data->fileptr);
				dfSave(event_data->fileptr);
#ifdef ENABLE_CUSTOM_SAVE_AND_RESTORE
				dsCustomSave(event_data->fileptr);
#endif
			}
			break;
		case EVT_RESTORESTATE:
			{
				tOSIRISEVTRESTORESTATE *event_data=&data->evt_restorestate;
	
				RestoreGlobalActionCtrs(event_data->fileptr);
				dfRestore(event_data->fileptr);
#ifdef ENABLE_CUSTOM_SAVE_AND_RESTORE
				dsCustomRestore(event_data->fileptr);
#endif
			}
			break;
		case EVT_LEVELSTART:
			{
				tOSIRISEVTLEVELSTART *event_data=&data->evt_levelstart;
 
				ClearGlobalActionCtrs();
				dfInit();
 
				// Script 000: [Level Start] Variables Initiated
				if((ScriptActionCtr_000 < 1) && (1))
				{
					aPortalRenderSet(1, 0, Room_indexes[0], 1);
					aPortalRenderSet(1, 0, Room_indexes[1], 1);
					aPortalRenderSet(1, 1, Room_indexes[1], 1);
					aPortalRenderSet(1, 2, Room_indexes[1], 1);
					aPortalRenderSet(1, 3, Room_indexes[1], 1);
					aPortalRenderSet(1, 1, Room_indexes[2], 1);
					aPortalRenderSet(1, 0, Room_indexes[3], 1);
					aPortalRenderSet(1, 1, Room_indexes[3], 1);
					aPortalRenderSet(1, 1, Room_indexes[4], 1);
					aPortalRenderSet(1, 1, Room_indexes[5], 1);
					aPortalRenderSet(1, 2, Room_indexes[5], 1);
					aPortalRenderSet(1, 3, Room_indexes[5], 1);
					aPortalRenderSet(1, 4, Room_indexes[5], 1);
					aSoundPlayObject(Sound_indexes[0], Object_handles[0], 1.000000f);
					aRoomSetFaceTexture(Room_indexes[6], 230, Texture_indexes[0]);
					aRoomSetFaceTexture(-1, 324, Texture_indexes[1]);
					aRoomSetWind(Room_indexes[7], -1.000000f, 0.000000f, 0.000000f, 12.000000f);
					aRoomSetWind(Room_indexes[8], -1.000000f, 0.000000f, 0.000000f, 6.000000f);
					aUserFlagSet(3, 0);
					aDoorLockUnlock(1, Door_handles[0]);
					aDoorLockUnlock(1, Door_handles[1]);
					aDoorLockUnlock(0, Door_handles[2]);
					aDoorLockUnlock(0, Door_handles[3]);
					aDoorLockUnlock(0, Door_handles[4]);
					aDoorLockUnlock(0, Door_handles[5]);
					aDoorLockUnlock(0, Door_handles[6]);
					aLightningTurnOn(qRandomValue(3.000000f, 9.000000f), 1.000000f);
					aRainTurnOn(1.000000f);
					aSnowTurnOn(1.000000f);
					
					// Increment the script action counter
					if(ScriptActionCtr_000 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_000++;
				}
 
				// Script 005: [Level Start] Introduction Cinematic
				if((ScriptActionCtr_005 < 1) && (1==true))
				{
					
					// Increment the script action counter
					if(ScriptActionCtr_005 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_005++;
				}
			}
			break;
		case EVT_TIMER:
			{
				tOSIRISEVTTIMER *event_data=&data->evt_timer;
 
				// Script 003: [Reactor] Countdown
				if(event_data->id==0)
				{
					aMiscViewerShake(100.000000f);
					aSoundPlay2D(Sound_indexes[2], 1.000000f);
					aObjFireWeapon("ImpactMortarExplosion", -1, Object_handles[6]);
					aObjFireWeapon("ImpactMortarExplosion", -1, Object_handles[6]);
					aObjFireWeapon("ImpactMortarExplosion", -1, Object_handles[6]);
					aRoomSetFaceTexture(Room_indexes[6], 230, Texture_indexes[1]);
					aRoomSetFaceTexture(-1, 324, Texture_indexes[0]);
					aRoomSetFaceTexture(Room_indexes[9], 142, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 143, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 144, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 145, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 146, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 147, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 148, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 149, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 150, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 151, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 152, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 153, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 154, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 155, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 156, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 157, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 158, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 159, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 160, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 161, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 162, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[9], 163, Texture_indexes[2]);
					aRoomSetFaceTexture(Room_indexes[1], 245, Texture_indexes[3]);
					aShowHUDMessage(Message_strings[7]);
					aRoomSetFuelcen(0, Room_indexes[10]);
					aRoomSetLightingPulse(Room_indexes[1], 6.000000f, 2.000000f);
					aRoomSetLightingPulse(Room_indexes[11], 6.000000f, 2.000000f);
					aSetLevelTimer(qRandomValue(50.000000f, 70.000000f), 1);
					aTimerShow(1);
					
					// Increment the script action counter
					if(ScriptActionCtr_003 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_003++;
				}
 
				// Script 002: [Reactor] Shockwave
				if(event_data->id==1)
				{
					aSoundPlaySteamingText("VoxMineSupernova.osf", 1.000000f);
					aMiscShakeArea(Object_handles[0], 100.000000f, 2000.000000f);
					aMiscShakeArea(Object_handles[0], 100.000000f, 2000.000000f);
					aRoomSetFog(Room_indexes[11], 1.000000f, 1.000000f, 1.000000f, 1.000000f);
					aObjDestroy(Object_handles[0]);
					aSetLevelTimer(9.000000f, 2);
					aFadeWhiteAndEndlevel(10.000000f, Message_strings[9]);
					
					// Increment the script action counter
					if(ScriptActionCtr_002 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_002++;
				}
 
				// Script 004: [Reactor] Failed Level
				if((ScriptActionCtr_004 < 1) && (event_data->id==2))
				{
					aFailLevel();
					
					// Increment the script action counter
					if(ScriptActionCtr_004 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_004++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_1817::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 008: [Key] Blue Found
				if((ScriptActionCtr_008 < 1) && (qObjIsPlayer(event_data->it_handle)==1))
				{
					aSoundPlayObject(Sound_indexes[1], data->me_handle, 1.000000f);
					aShowHUDMessageObj(Message_strings[0], event_data->it_handle);
					aAddObjectToInventoryNamed(data->me_handle, event_data->it_handle, Message_strings[1], 0);
					
					// Increment the script action counter
					if(ScriptActionCtr_008 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_008++;
				}
			}
			break;
		case EVT_USE:
			{
				tOSIRISEVTUSE *event_data=&data->evt_use;
 
				// Script 011: [Key] Blue Used
				if(1)
				{
					aAddObjectToInventoryNamed(data->me_handle, event_data->it_handle, Message_strings[1], 0);
					
					// Increment the script action counter
					if(ScriptActionCtr_011 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_011++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_1016::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 009: [Key] Red Found
				if((ScriptActionCtr_009 < 1) && (qObjIsPlayer(event_data->it_handle)==1))
				{
					aSoundPlayObject(Sound_indexes[1], data->me_handle, 1.000000f);
					aShowHUDMessageObj(Message_strings[2], event_data->it_handle);
					aAddObjectToInventoryNamed(data->me_handle, event_data->it_handle, Message_strings[3], 0);
					
					// Increment the script action counter
					if(ScriptActionCtr_009 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_009++;
				}
			}
			break;
		case EVT_USE:
			{
				tOSIRISEVTUSE *event_data=&data->evt_use;
 
				// Script 012: [Key] Red Used
				if(1)
				{
					aAddObjectToInventoryNamed(data->me_handle, event_data->it_handle, Message_strings[3], 0);
					
					// Increment the script action counter
					if(ScriptActionCtr_012 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_012++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_2018::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 010: [Key] Yellow Found
				if((ScriptActionCtr_010 < 1) && (qObjIsPlayer(event_data->it_handle)==1))
				{
					aSoundPlayObject(Sound_indexes[1], data->me_handle, 1.000000f);
					aShowHUDMessageObj(Message_strings[4], event_data->it_handle);
					aAddObjectToInventoryNamed(data->me_handle, event_data->it_handle, Message_strings[5], 0);
					
					// Increment the script action counter
					if(ScriptActionCtr_010 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_010++;
				}
			}
			break;
		case EVT_USE:
			{
				tOSIRISEVTUSE *event_data=&data->evt_use;
 
				// Script 013: [Key] Yellow Used
				if(1)
				{
					aAddObjectToInventoryNamed(data->me_handle, event_data->it_handle, Message_strings[5], 0);
					
					// Increment the script action counter
					if(ScriptActionCtr_013 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_013++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_080B::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 014: [Door] Blue
				if(qObjIsPlayerOrPlayerWeapon(event_data->it_handle)==1)
				{
					if(qHasObjectInInventory(event_data->it_handle, Object_handles[1])==1)
					{
						aDoorActivate(data->me_handle);
					}
					
					// Increment the script action counter
					if(ScriptActionCtr_014 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_014++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_080A::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 015: [Door] Blue II
				if(qObjIsPlayerOrPlayerWeapon(event_data->it_handle)==1)
				{
					if(qHasObjectInInventory(event_data->it_handle, Object_handles[1])==1)
					{
						aDoorActivate(data->me_handle);
					}
					
					// Increment the script action counter
					if(ScriptActionCtr_015 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_015++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_1006::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 016: [Door] Red
				if(qObjIsPlayerOrPlayerWeapon(event_data->it_handle)==1)
				{
					if(qHasObjectInInventory(event_data->it_handle, Object_handles[2])==1)
					{
						aDoorActivate(data->me_handle);
					}
					
					// Increment the script action counter
					if(ScriptActionCtr_016 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_016++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short TriggerScript_0000::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 001: [Reactor] Meltdown Sequence
				if((ScriptActionCtr_001 < 1) && (qObjIsPlayerWeapon(event_data->it_handle)==1))
				{
					aShowHUDMessage(Message_strings[6]);
					aSetLevelTimer(qRandomValue(5.000000f, 10.000000f), 0);
					
					// Increment the script action counter
					if(ScriptActionCtr_001 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_001++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short TriggerScript_0001::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 006: [Reactor] Guidebot Water Loss Comment
				if((ScriptActionCtr_006 < 1) && (qObjIsPlayer(event_data->it_handle)==1))
				{
					if(qUserFlag(6)==1)
					{
						aShowHUDMessage(Message_strings[8]);
					}
					
					// Increment the script action counter
					if(ScriptActionCtr_006 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_006++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short TriggerScript_FFFFFFFF::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 007: [Reactor] Survived Level
				if((ScriptActionCtr_007 < 1) && (qObjIsPlayer(event_data->it_handle)==1))
				{
					if(qUserFlag(7)==1)
					{
						aEndLevel();
					}
					else {
						aFailLevel();
					}
					
					// Increment the script action counter
					if(ScriptActionCtr_007 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_007++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

 
 
/*********************************************************
Script Save Block: DO NOT TOUCH ANYTHING IN THIS BLOCK!!! 
**********************************************************
$$SCRIPT_BLOCK_START
 
VERSION		3
NEXT_ID		17
 
// UserType value blocks
$$UTYPE_VALS_START UserVar
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START UserFlag
3:Has_Lab_Key
4:Cloaked_Flag_1
5:Cloaked_Flag_2
6:Is_Reactor_Countdown
7:Is_All_Hostages_Rescued
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START SpewHandle
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START TimerID
0:Reactor_Meltdown_Timer
1:Reactor_Countdown_Timer
2:Reactor_End_Timer
3:Cloak_Energy_Drain
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START SavedObjectSlot
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START GoalID
$$UTYPE_VALS_END
 
 
// Name Lists
$$DOOR_LIST_START
Blue Door
Blue Door II
Yellow Door
Yellow Door II
Yellow Door III
Red Door
Lab Door
$$DOOR_LIST_END
 
$$OBJECT_LIST_START
Reactor
Key Blue
Key Red
Blue Door
Blue Door II
Red Door
Quake_Explosion
$$OBJECT_LIST_END
 
$$ROOM_LIST_START
16
Reactor
23
30
58
60
20
26
28
1
Energy - 1
Reactor Center
$$ROOM_LIST_END
 
$$TRIGGER_LIST_START
Reactor_Temperature
GB_NoWaterReactor
$$TRIGGER_LIST_END
 
$$SOUND_LIST_START
ReactorDrone
Powerup pickup
AmbExplosionFarD
$$SOUND_LIST_END
 
$$TEXTURE_LIST_START
PondRipple1
DeletedTexture
TFZ_Ice - Ice Slates
P-MonTempAbov
$$TEXTURE_LIST_END
 
$$SPECNAME_LIST_START
ImpactMortarExplosion
VoxMineSupernova.osf
$$SPECNAME_LIST_END
 
$$PATH_LIST_START
$$PATH_LIST_END
 
$$MATCEN_LIST_START
$$MATCEN_LIST_END
 
$$GOAL_LIST_START
$$GOAL_LIST_END
 
$$STRM_AUDIO_LIST_START
$$STRM_AUDIO_LIST_END
 
 
// Script Tree Dump
00:0:[Level Start] Variables Initiated 
	$$CHILD_BLOCK_START
	01:2:0 
	02:6 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aPortalRenderSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:4:0:PortalNum 
			10:2:0:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aPortalRenderSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:4:0:PortalNum 
			10:2:1:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aPortalRenderSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:4:1:PortalNum 
			10:2:1:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aPortalRenderSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:4:2:PortalNum 
			10:2:1:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aPortalRenderSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:4:3:PortalNum 
			10:2:1:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aPortalRenderSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:4:1:PortalNum 
			10:2:2:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aPortalRenderSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:4:0:PortalNum 
			10:2:3:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aPortalRenderSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:4:1:PortalNum 
			10:2:3:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aPortalRenderSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:4:1:PortalNum 
			10:2:4:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aPortalRenderSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:4:1:PortalNum 
			10:2:5:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aPortalRenderSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:4:2:PortalNum 
			10:2:5:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aPortalRenderSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:4:3:PortalNum 
			10:2:5:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aPortalRenderSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:4:4:PortalNum 
			10:2:5:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aSoundPlayObject 
			$$CHILD_BLOCK_START
			10:12:0:Sound 
			10:1:0:0:Object 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:6:Room 
			10:4:230:FaceNum 
			10:14:0:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:-1:Room 
			10:4:324:FaceNum 
			10:14:1:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetWind 
			$$CHILD_BLOCK_START
			10:2:7:Room 
			10:6:-1.000000:X 
			10:6:0.000000:Y 
			10:6:0.000000:Z 
			10:6:12.000000:Speed 
			$$CHILD_BLOCK_END
		08:aRoomSetWind 
			$$CHILD_BLOCK_START
			10:2:8:Room 
			10:6:-1.000000:X 
			10:6:0.000000:Y 
			10:6:0.000000:Z 
			10:6:6.000000:Speed 
			$$CHILD_BLOCK_END
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:3:UserFlag 
			10:5:0:True/False 
			$$CHILD_BLOCK_END
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:1:Lock/Unlock 
			10:0:0:0:DoorName 
			$$CHILD_BLOCK_END
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:1:Lock/Unlock 
			10:0:0:1:DoorName 
			$$CHILD_BLOCK_END
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:0:Lock/Unlock 
			10:0:0:2:DoorName 
			$$CHILD_BLOCK_END
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:0:Lock/Unlock 
			10:0:0:3:DoorName 
			$$CHILD_BLOCK_END
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:0:Lock/Unlock 
			10:0:0:4:DoorName 
			$$CHILD_BLOCK_END
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:0:Lock/Unlock 
			10:0:0:5:DoorName 
			$$CHILD_BLOCK_END
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:0:Lock/Unlock 
			10:0:0:6:DoorName 
			$$CHILD_BLOCK_END
		08:aLightningTurnOn 
			$$CHILD_BLOCK_START
			06:qRandomValue:Seconds 
				$$CHILD_BLOCK_START
				10:6:3.000000:LowerLimit 
				10:6:9.000000:UpperLimit 
				$$CHILD_BLOCK_END
			10:9:1.000000:Probability 
			$$CHILD_BLOCK_END
		08:aRainTurnOn 
			$$CHILD_BLOCK_START
			10:9:1.000000:Density 
			$$CHILD_BLOCK_END
		08:aSnowTurnOn 
			$$CHILD_BLOCK_START
			10:9:1.000000:Density 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:5:[Level Start] Introduction Cinematic 
	$$CHILD_BLOCK_START
	01:2:0 
	02:6 
	03:0 
		$$CHILD_BLOCK_START
		05:1 
			$$CHILD_BLOCK_START
			10:5:1:Literal 
			07:0:6 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:DO NOTHING 
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:8:[Key] Blue Found 
	$$CHILD_BLOCK_START
	01:1:1 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayer:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aSoundPlayObject 
			$$CHILD_BLOCK_START
			10:12:1:Sound 
			10:1:2:-1:Object 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		08:aShowHUDMessageObj 
			$$CHILD_BLOCK_START
			10:8:GB_KeyBlue:Message 
			10:1:1:-1:PlayerObject 
			$$CHILD_BLOCK_END
		08:aAddObjectToInventoryNamed 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			10:1:1:-1:PlayerObject 
			10:8:Key_Blue:ItemName 
			10:5:0:Spewable 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:9:[Key] Red Found 
	$$CHILD_BLOCK_START
	01:1:2 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayer:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aSoundPlayObject 
			$$CHILD_BLOCK_START
			10:12:1:Sound 
			10:1:2:-1:Object 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		08:aShowHUDMessageObj 
			$$CHILD_BLOCK_START
			10:8:GB_KeyRed:Message 
			10:1:1:-1:PlayerObject 
			$$CHILD_BLOCK_END
		08:aAddObjectToInventoryNamed 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			10:1:1:-1:PlayerObject 
			10:8:Key_Red:ItemName 
			10:5:0:Spewable 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:10:[Key] Yellow Found 
	$$CHILD_BLOCK_START
	01:1:0 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayer:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aSoundPlayObject 
			$$CHILD_BLOCK_START
			10:12:1:Sound 
			10:1:2:-1:Object 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		08:aShowHUDMessageObj 
			$$CHILD_BLOCK_START
			10:8:GB_KeyYellow:Message 
			10:1:1:-1:PlayerObject 
			$$CHILD_BLOCK_END
		08:aAddObjectToInventoryNamed 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			10:1:1:-1:PlayerObject 
			10:8:Key_Yellow:ItemName 
			10:5:0:Spewable 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:11:[Key] Blue Used 
	$$CHILD_BLOCK_START
	01:1:1 
	02:25 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aAddObjectToInventoryNamed 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			10:1:1:-1:PlayerObject 
			10:8:Key_Blue:ItemName 
			10:5:0:Spewable 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:12:[Key] Red Used 
	$$CHILD_BLOCK_START
	01:1:2 
	02:25 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aAddObjectToInventoryNamed 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			10:1:1:-1:PlayerObject 
			10:8:Key_Red:ItemName 
			10:5:0:Spewable 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:13:[Key] Yellow Used 
	$$CHILD_BLOCK_START
	01:1:0 
	02:25 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aAddObjectToInventoryNamed 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			10:1:1:-1:PlayerObject 
			10:8:Key_Yellow:ItemName 
			10:5:0:Spewable 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:14:[Door] Blue 
	$$CHILD_BLOCK_START
	01:1:3 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayerOrPlayerWeapon:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qHasObjectInInventory:Bool 
					$$CHILD_BLOCK_START
					10:1:1:-1:Player 
					10:1:0:1:Object 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:1:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aDoorActivate 
				$$CHILD_BLOCK_START
				10:0:2:-1:Door 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:15:[Door] Blue II 
	$$CHILD_BLOCK_START
	01:1:4 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayerOrPlayerWeapon:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qHasObjectInInventory:Bool 
					$$CHILD_BLOCK_START
					10:1:1:-1:Player 
					10:1:0:1:Object 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:1:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aDoorActivate 
				$$CHILD_BLOCK_START
				10:0:2:-1:Door 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:16:[Door] Red 
	$$CHILD_BLOCK_START
	01:1:5 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayerOrPlayerWeapon:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qHasObjectInInventory:Bool 
					$$CHILD_BLOCK_START
					10:1:1:-1:Player 
					10:1:0:2:Object 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:1:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aDoorActivate 
				$$CHILD_BLOCK_START
				10:0:2:-1:Door 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:1:[Reactor] Meltdown Sequence 
	$$CHILD_BLOCK_START
	01:0:0 
	02:1 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayerWeapon:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aShowHUDMessage 
			$$CHILD_BLOCK_START
			10:8:GB_ReactorMeltdown:Message 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			06:qRandomValue:Time 
				$$CHILD_BLOCK_START
				10:6:5.000000:LowerLimit 
				10:6:10.000000:UpperLimit 
				$$CHILD_BLOCK_END
			10:10:0:0:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:3:[Reactor] Countdown 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:0:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aMiscViewerShake 
			$$CHILD_BLOCK_START
			10:6:100.000000:Amount 
			$$CHILD_BLOCK_END
		08:aSoundPlay2D 
			$$CHILD_BLOCK_START
			10:12:2:Sound 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		08:aObjFireWeapon 
			$$CHILD_BLOCK_START
			10:13:0:WeaponName 
			10:4:-1:GunNum 
			10:1:0:6:Object 
			$$CHILD_BLOCK_END
		08:aObjFireWeapon 
			$$CHILD_BLOCK_START
			10:13:0:WeaponName 
			10:4:-1:GunNum 
			10:1:0:6:Object 
			$$CHILD_BLOCK_END
		08:aObjFireWeapon 
			$$CHILD_BLOCK_START
			10:13:0:WeaponName 
			10:4:-1:GunNum 
			10:1:0:6:Object 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:6:Room 
			10:4:230:FaceNum 
			10:14:1:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:-1:Room 
			10:4:324:FaceNum 
			10:14:0:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:142:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:143:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:144:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:145:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:146:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:147:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:148:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:149:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:150:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:151:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:152:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:153:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:154:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:155:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:156:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:157:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:158:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:159:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:160:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:161:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:162:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:9:Room 
			10:4:163:FaceNum 
			10:14:2:Texture 
			$$CHILD_BLOCK_END
		08:aRoomSetFaceTexture 
			$$CHILD_BLOCK_START
			10:2:1:Room 
			10:4:245:FaceNum 
			10:14:3:Texture 
			$$CHILD_BLOCK_END
		08:aShowHUDMessage 
			$$CHILD_BLOCK_START
			10:8:GB_ReactorCountdown:Message 
			$$CHILD_BLOCK_END
		08:aRoomSetFuelcen 
			$$CHILD_BLOCK_START
			10:10:0:0:On/Off 
			10:2:10:Room 
			$$CHILD_BLOCK_END
		08:aRoomSetLightingPulse 
			$$CHILD_BLOCK_START
			10:2:1:Room 
			10:6:6.000000:PulseTime 
			10:6:2.000000:PulseOffset 
			$$CHILD_BLOCK_END
		08:aRoomSetLightingPulse 
			$$CHILD_BLOCK_START
			10:2:11:Room 
			10:6:6.000000:PulseTime 
			10:6:2.000000:PulseOffset 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			06:qRandomValue:Time 
				$$CHILD_BLOCK_START
				10:6:50.000000:LowerLimit 
				10:6:70.000000:UpperLimit 
				$$CHILD_BLOCK_END
			10:10:0:1:TimerID 
			$$CHILD_BLOCK_END
		08:aTimerShow 
			$$CHILD_BLOCK_START
			10:10:0:1:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:6:[Reactor] Guidebot Water Loss Comment 
	$$CHILD_BLOCK_START
	01:0:1 
	02:1 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayer:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserFlag:Bool 
					$$CHILD_BLOCK_START
					10:10:0:6:UserFlag 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:1:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aShowHUDMessage 
				$$CHILD_BLOCK_START
				10:8:GB_NoWaterReactor:Message 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:2:[Reactor] Shockwave 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:1:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aSoundPlaySteamingText 
			$$CHILD_BLOCK_START
			10:13:1:SoundName 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		08:aMiscShakeArea 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:6:100.000000:Amount 
			10:6:2000.000000:Dist 
			$$CHILD_BLOCK_END
		08:aMiscShakeArea 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:6:100.000000:Amount 
			10:6:2000.000000:Dist 
			$$CHILD_BLOCK_END
		08:aRoomSetFog 
			$$CHILD_BLOCK_START
			10:2:11:Room 
			10:6:1.000000:Red 
			10:6:1.000000:Green 
			10:6:1.000000:Blue 
			10:6:1.000000:Depth 
			$$CHILD_BLOCK_END
		08:aObjDestroy 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:9.000000:Time 
			10:10:0:2:TimerID 
			$$CHILD_BLOCK_END
		08:aFadeWhiteAndEndlevel 
			$$CHILD_BLOCK_START
			10:6:10.000000:Time 
			10:8:Empty:Text 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:7:[Reactor] Survived Level 
	$$CHILD_BLOCK_START
	01:0:-1 
	02:1 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayer:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserFlag:Bool 
					$$CHILD_BLOCK_START
					10:10:0:7:UserFlag 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:1:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aEndLevel 
			$$CHILD_BLOCK_END
		04:1:0:1 
			$$CHILD_BLOCK_START
			08:aFailLevel 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:4:[Reactor] Failed Level 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:2:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aFailLevel 
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
 
$$SCRIPT_BLOCK_END
*********************************************************/
