/////////////////////////////////////////////////////////////////////
// D.A.L.L.A.S. Generated Level Script - DLL Source File
// 
// Filename:	genova.cpp
// Version:	3
/////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "osiris_import.h"
#include "osiris_common.h"
#include "dallasfuncs.cpp"

#ifdef _MSC_VER		//Visual C++ Build
#define STDCALL		__stdcall
#define STDCALLPTR	*STDCALL
#else					//Non-Visual C++ Build
#define STDCALL __attribute__((stdcall))
#define STDCALLPTR	STDCALL*
#endif

#ifdef __cplusplus
extern "C"{
#endif
char		STDCALL InitializeDLL(tOSIRISModuleInit *func_list);
void		STDCALL ShutdownDLL(void);
int		STDCALL GetGOScriptID(char *name,ubyte is_door);
void		STDCALLPTR CreateInstance(int id);
void		STDCALL DestroyInstance(int id,void *ptr);
short	STDCALL CallInstanceEvent(int id,void *ptr,int event,tOSIRISEventInfo *data);
int		STDCALL GetTriggerScriptID(int trigger_room, int trigger_face );
int		STDCALL GetCOScriptList( int **list, int **id_list );
int		STDCALL SaveRestoreState( void *file_ptr, ubyte saving_state );
#ifdef __cplusplus
}
#endif

// =================
// Script ID Numbers
// =================
#define ID_LEVEL_0000			0x000

#define ID_CUSTOM_OBJECT_1835		0x001
#define ID_CUSTOM_OBJECT_1028		0x002
#define ID_CUSTOM_OBJECT_FFFFFFFF		0x003

#define ID_TRIGGER_0000		0x004

// ========================
// Script Class Definitions
// ========================

class BaseScript {
public:
	BaseScript();
	~BaseScript();
	virtual short CallEvent(int event, tOSIRISEventInfo *data);
};

class LevelScript_0000 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_1835 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_1028 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_FFFFFFFF : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class TriggerScript_0000 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

// ======================
// Global Action Counters
// ======================

#define MAX_ACTION_CTR_VALUE		100000

int ScriptActionCtr_000 = 0;
int ScriptActionCtr_001 = 0;
int ScriptActionCtr_002 = 0;
int ScriptActionCtr_003 = 0;
int ScriptActionCtr_004 = 0;
int ScriptActionCtr_005 = 0;
int ScriptActionCtr_006 = 0;
int ScriptActionCtr_007 = 0;
int ScriptActionCtr_009 = 0;
int ScriptActionCtr_010 = 0;
int ScriptActionCtr_008 = 0;
int ScriptActionCtr_011 = 0;
int ScriptActionCtr_012 = 0;
int ScriptActionCtr_013 = 0;
int ScriptActionCtr_014 = 0;
 
// ========================================
// Function to Clear Global Action Counters
// ========================================
void ClearGlobalActionCtrs(void)
{
	ScriptActionCtr_000 = 0;
	ScriptActionCtr_001 = 0;
	ScriptActionCtr_002 = 0;
	ScriptActionCtr_003 = 0;
	ScriptActionCtr_004 = 0;
	ScriptActionCtr_005 = 0;
	ScriptActionCtr_006 = 0;
	ScriptActionCtr_007 = 0;
	ScriptActionCtr_009 = 0;
	ScriptActionCtr_010 = 0;
	ScriptActionCtr_008 = 0;
	ScriptActionCtr_011 = 0;
	ScriptActionCtr_012 = 0;
	ScriptActionCtr_013 = 0;
	ScriptActionCtr_014 = 0;
}
 
// ========================================
// Function to Save Global Action Counters
// ========================================
void SaveGlobalActionCtrs(void *file_ptr)
{
	File_WriteInt(ScriptActionCtr_000,file_ptr);
	File_WriteInt(ScriptActionCtr_001,file_ptr);
	File_WriteInt(ScriptActionCtr_002,file_ptr);
	File_WriteInt(ScriptActionCtr_003,file_ptr);
	File_WriteInt(ScriptActionCtr_004,file_ptr);
	File_WriteInt(ScriptActionCtr_005,file_ptr);
	File_WriteInt(ScriptActionCtr_006,file_ptr);
	File_WriteInt(ScriptActionCtr_007,file_ptr);
	File_WriteInt(ScriptActionCtr_009,file_ptr);
	File_WriteInt(ScriptActionCtr_010,file_ptr);
	File_WriteInt(ScriptActionCtr_008,file_ptr);
	File_WriteInt(ScriptActionCtr_011,file_ptr);
	File_WriteInt(ScriptActionCtr_012,file_ptr);
	File_WriteInt(ScriptActionCtr_013,file_ptr);
	File_WriteInt(ScriptActionCtr_014,file_ptr);
}
 
// ===========================================
// Function to Restore Global Action Counters
// ===========================================
void RestoreGlobalActionCtrs(void *file_ptr)
{
	ScriptActionCtr_000=File_ReadInt(file_ptr);
	ScriptActionCtr_001=File_ReadInt(file_ptr);
	ScriptActionCtr_002=File_ReadInt(file_ptr);
	ScriptActionCtr_003=File_ReadInt(file_ptr);
	ScriptActionCtr_004=File_ReadInt(file_ptr);
	ScriptActionCtr_005=File_ReadInt(file_ptr);
	ScriptActionCtr_006=File_ReadInt(file_ptr);
	ScriptActionCtr_007=File_ReadInt(file_ptr);
	ScriptActionCtr_009=File_ReadInt(file_ptr);
	ScriptActionCtr_010=File_ReadInt(file_ptr);
	ScriptActionCtr_008=File_ReadInt(file_ptr);
	ScriptActionCtr_011=File_ReadInt(file_ptr);
	ScriptActionCtr_012=File_ReadInt(file_ptr);
	ScriptActionCtr_013=File_ReadInt(file_ptr);
	ScriptActionCtr_014=File_ReadInt(file_ptr);
}
 
 
// ===============================================================
// Start of Custom Script Block - DO NOT EDIT ANYTHING BEFORE THIS
// ===============================================================
/**{CUSTOM_SCRIPT_BLOCK_START}** DO NOT EDIT! **/
 
// Enter your custom script code here
 
/**{CUSTOM_SCRIPT_BLOCK_END}**** DO NOT EDIT! **/
// ============================================================
// End of Custom Script Block - DO NOT EDIT ANYTHING AFTER THIS
// ============================================================
 
 
// =================
// Message File Data
// =================
 
#define MAX_SCRIPT_MESSAGES	256
#define MAX_MSG_FILEBUF_LEN	1024
#define NO_MESSAGE_STRING		"*Message Not Found*"
#define INV_MSGNAME_STRING	"*Message Name Invalid*"
#define WHITESPACE_CHARS	" \t\r\n"
 
// Structure for storing a script message
typedef struct {
	char *name;			// the name of the message
	char *message;		// the actual message text
} tScriptMessage;
 
// Global storage for level script messages
tScriptMessage *message_list[MAX_SCRIPT_MESSAGES];
int num_messages;
 
// ======================
// Message File Functions
// ======================
 
// Initializes the Message List
void InitMessageList(void)
{
	for(int j=0;j<MAX_SCRIPT_MESSAGES;j++)
		message_list[j]=NULL;
	num_messages=0;
}
 
// Clear the Message List
void ClearMessageList(void)
{
	for(int j=0;j<num_messages;j++) {
		free(message_list[j]->name);
		free(message_list[j]->message);
		free(message_list[j]);
		message_list[j]=NULL;
	}
	num_messages=0;
}
 
// Adds a message to the list
int AddMessageToList(char *name, char *msg)
{
	int pos;
 
	// Make sure there is room in the list
	if(num_messages>=MAX_SCRIPT_MESSAGES) return false;
 
	// Allocate memory for this message entry
	pos=num_messages;
	message_list[pos]=(tScriptMessage *)malloc(sizeof(tScriptMessage));
	if(message_list[pos]==NULL) return false;
 
	// Allocate memory for the message name
	message_list[pos]->name=(char *)malloc(strlen(name)+1);
	if(message_list[pos]->name==NULL) {
		free(message_list[pos]);
		return false;
	}
	strcpy(message_list[pos]->name,name);
 
	// Allocate memory for the message name
	message_list[pos]->message=(char *)malloc(strlen(msg)+1);
	if(message_list[pos]->message==NULL) {
		free(message_list[pos]->name);
		free(message_list[pos]);
		return false;
	}
	strcpy(message_list[pos]->message,msg);
	num_messages++;
 
	return true;
}
 
// Removes any whitespace padding from the end of a string
void RemoveTrailingWhitespace(char *s)
{
	int last_char_pos;
 
	last_char_pos=strlen(s)-1;
	while(last_char_pos>=0 && isspace(s[last_char_pos])) {
		s[last_char_pos]='\0';
		last_char_pos--;
	}
}
 
// Returns a pointer to the first non-whitespace char in given string
char *SkipInitialWhitespace(char *s)
{
	while((*s)!='\0' && isspace(*s)) 
		s++;
 
	return(s);
}
 
// Read in the Messages
int ReadMessageFile(char *filename)
{
	void *infile;
	char filebuffer[MAX_MSG_FILEBUF_LEN+1];
	char *line, *msg_start;
	int line_num;
	bool next_msgid_found;
 
	// Try to open the file for loading
	infile=File_Open(filename,"rt");
	if (!infile) return false;
 
	line_num=0;
	next_msgid_found=true;
 
	// Clear the message list
	ClearMessageList();
 
	// Read in and parse each line of the file
	while (!File_eof(infile)) {
 
		// Clear the buffer
		strcpy(filebuffer,"");
 
		// Read in a line from the file
		File_ReadString(filebuffer, MAX_MSG_FILEBUF_LEN, infile);
		line_num++;
 
		// Remove whitespace padding at start and end of line
		RemoveTrailingWhitespace(filebuffer);
		line=SkipInitialWhitespace(filebuffer);
 
		// If line is a comment, or empty, discard it
		if(strlen(line)==0 || strncmp(line,"//",2)==0)
			continue;
 
		if(!next_msgid_found) {		// Parse out the last message ID number
 
			// Grab the first keyword, make sure it's valid
			line=strtok(line,WHITESPACE_CHARS);
			if(line==NULL) continue;
 
			// Grab the second keyword, and assign it as the next message ID
			line=strtok(NULL,WHITESPACE_CHARS);
			if(line==NULL) continue;
 
			next_msgid_found=true;
		}
		else {	// Parse line as a message line
			
			// Find the start of message, and mark it
			msg_start=strchr(line,'=');
			if(msg_start==NULL) continue;
			msg_start[0]='\0';
			msg_start++;
			
			// Add the message to the list
			AddMessageToList(line,msg_start);
		}
	}
	File_Close(infile);
 
	return true;
}
 
// Find a message
char *GetMessage(char *name)
{
	// Make sure given name is valid
	if(name==NULL) return INV_MSGNAME_STRING;
 
	// Search message list for name
	for(int j=0;j<num_messages;j++)
		if(strcmp(message_list[j]->name,name)==0) return(message_list[j]->message);
 
	// Couldn't find it
	return NO_MESSAGE_STRING;
}
 
 
//======================
// Name List Arrays     
//======================
 
#define NUM_DOOR_NAMES		1
char *Door_names[NUM_DOOR_NAMES] = {
	"mine_shaft"
};
int Door_handles[NUM_DOOR_NAMES];
 
#define NUM_OBJECT_NAMES		24
char *Object_names[NUM_OBJECT_NAMES] = {
	"DeadTunnSpew1",
	"boss1",
	"BegScratch1",
	"BegScratch2",
	"toastybot",
	"V",
	"V2",
	"V1",
	"Psmoke1",
	"light2",
	"shaker",
	"trapped_weapon",
	"bars1",
	"bars2",
	"hub_light2",
	"hub_light4",
	"hub_light1",
	"hub_light3",
	"LeftLight3",
	"RightLight3",
	"LeftLight2",
	"RightLight2",
	"LeftLight1",
	"RightLight1"
};
int Object_handles[NUM_OBJECT_NAMES];
 
#define NUM_ROOM_NAMES		6
char *Room_names[NUM_ROOM_NAMES] = {
	"nrgy_1",
	"nrgy_2",
	"hub",
	"deadtunn1",
	"hub_low",
	"hub_high"
};
int Room_indexes[NUM_ROOM_NAMES];
 
#define NUM_TRIGGER_NAMES		1
char *Trigger_names[NUM_TRIGGER_NAMES] = {
	"firestarter"
};
int Trigger_indexes[NUM_TRIGGER_NAMES];
int Trigger_faces[NUM_TRIGGER_NAMES];
int Trigger_rooms[NUM_TRIGGER_NAMES];
 
#define NUM_SOUND_NAMES		5
char *Sound_names[NUM_SOUND_NAMES] = {
	"EnvSteamEmitA",
	"DefaultBuildingExplode",
	"DebrisExplosion",
	"RbtHellionDeath",
	"EnvBreakerSnapB"
};
int Sound_indexes[NUM_SOUND_NAMES];
 
#define NUM_TEXTURE_NAMES		0
char **Texture_names=NULL;
int *Texture_indexes=NULL;
 
#define NUM_PATH_NAMES		0
char **Path_names=NULL;
int *Path_indexes=NULL;
 
#define NUM_MATCEN_NAMES		0
char **Matcen_names=NULL;
int *Matcen_indexes=NULL;
 
#define NUM_GOAL_NAMES		0
char **Goal_names=NULL;
int *Goal_indexes=NULL;
 
#define NUM_MESSAGE_NAMES		9
char *Message_names[NUM_MESSAGE_NAMES] = {
	"GBgenmissing",
	"GBgennote",
	"laserpower",
	"powerget",
	"fusemsg",
	"fuseget",
	"laserfocus",
	"lensget",
	"pwr_shortage"
};
char *Message_strings[NUM_MESSAGE_NAMES];
 
// ===============
// InitializeDLL()
// ===============
char STDCALL InitializeDLL(tOSIRISModuleInit *func_list)
{
	osicommon_Initialize((tOSIRISModuleInit *)func_list);
 
	ClearGlobalActionCtrs();
	dfInit();
	InitMessageList();
 
	// Build the filename of the message file
	char filename[_MAX_PATH+1];
	char english_filename[_MAX_PATH+1];
	int lang_type;
	if(func_list->script_identifier!=NULL) {
		_splitpath(func_list->script_identifier,NULL,NULL,filename,NULL);
		sprintf(english_filename,"%s.msg",filename);
		lang_type=Game_GetLanguage();
		if(lang_type==LANGUAGE_FRENCH) strcat(filename,"_FRN");
		else if(lang_type==LANGUAGE_GERMAN) strcat(filename,"_GER");
		else if(lang_type==LANGUAGE_ITALIAN) strcat(filename,"_ITN");
		else if(lang_type==LANGUAGE_SPANISH) strcat(filename,"_SPN");
		else if(lang_type==LANGUAGE_POLISH) strcat(filename,"_POL");
		strcat(filename,".msg");
	}
	else {
		strcpy(filename,"genova.msg");
		lang_type=LANGUAGE_ENGLISH;
	}
	if(!ReadMessageFile(filename)) {
		if(lang_type == LANGUAGE_ENGLISH) {
			mprintf(0,"ERROR: Could not load message file - %s\n",filename);
		}
		else if(!ReadMessageFile(english_filename)) {
			mprintf(0,"ERROR: Could not load message file - %s\n",english_filename);
		}
	}
 
	int j;
 
	// Do Door Index lookups
	for(j=0;j<NUM_DOOR_NAMES;j++) 
		Door_handles[j]=Scrpt_FindDoorName(Door_names[j]);
 
	// Do Object Index lookups
	for(j=0;j<NUM_OBJECT_NAMES;j++) 
		Object_handles[j]=Scrpt_FindObjectName(Object_names[j]);
 
	// Do Room Index lookups
	for(j=0;j<NUM_ROOM_NAMES;j++) 
		Room_indexes[j]=Scrpt_FindRoomName(Room_names[j]);
 
	// Do Trigger Index lookups
	for(j=0;j<NUM_TRIGGER_NAMES;j++) {
		Trigger_indexes[j]=Scrpt_FindTriggerName(Trigger_names[j]);
		Trigger_faces[j]=Scrpt_GetTriggerFace(Trigger_indexes[j]);
		Trigger_rooms[j]=Scrpt_GetTriggerRoom(Trigger_indexes[j]);
	}
 
	// Do Sound Index lookups
	for(j=0;j<NUM_SOUND_NAMES;j++) 
		Sound_indexes[j]=Scrpt_FindSoundName(Sound_names[j]);
 
	// Do Texture Index lookups
	for(j=0;j<NUM_TEXTURE_NAMES;j++) 
		Texture_indexes[j]=Scrpt_FindTextureName(Texture_names[j]);
 
	// Do Path Index lookups
	for(j=0;j<NUM_PATH_NAMES;j++) 
		Path_indexes[j]=Scrpt_FindPathName(Path_names[j]);
 
	// Do Matcen Index lookups
	for(j=0;j<NUM_MATCEN_NAMES;j++) 
		Matcen_indexes[j]=Scrpt_FindMatcenName(Matcen_names[j]);
 
	// Do Goal Index lookups
	for(j=0;j<NUM_GOAL_NAMES;j++) 
		Goal_indexes[j]=Scrpt_FindLevelGoalName(Goal_names[j]);
 
	// Do Message Name lookups
	for(j=0;j<NUM_MESSAGE_NAMES;j++) 
		Message_strings[j]=GetMessage(Message_names[j]);
 
	return 1;
}

// =============
// ShutdownDLL()
// =============
void STDCALL ShutdownDLL(void)
{
	ClearMessageList();
}

// ===============
// GetGOScriptID()
// ===============
int STDCALL GetGOScriptID(char *name,ubyte isdoor)
{
	return -1;
}

// ================
// CreateInstance()
// ================
void STDCALLPTR CreateInstance(int id)
{
	switch(id) {
		case ID_LEVEL_0000:
			return new LevelScript_0000;
			break;
		case ID_CUSTOM_OBJECT_1835:
			return new CustomObjectScript_1835;
			break;
		case ID_CUSTOM_OBJECT_1028:
			return new CustomObjectScript_1028;
			break;
		case ID_CUSTOM_OBJECT_FFFFFFFF:
			return new CustomObjectScript_FFFFFFFF;
			break;
		case ID_TRIGGER_0000:
			return new TriggerScript_0000;
			break;
		default:
			mprintf(0,"SCRIPT: Illegal ID (%d)\n",id);
			break;
	}
	return NULL;
}

// =================
// DestroyInstance()
// =================
void STDCALL DestroyInstance(int id,void *ptr)
{
	switch(id) {
		case ID_LEVEL_0000:
			delete ((LevelScript_0000 *)ptr);
		case ID_CUSTOM_OBJECT_1835:
			delete ((CustomObjectScript_1835 *)ptr);
			break;
		case ID_CUSTOM_OBJECT_1028:
			delete ((CustomObjectScript_1028 *)ptr);
			break;
		case ID_CUSTOM_OBJECT_FFFFFFFF:
			delete ((CustomObjectScript_FFFFFFFF *)ptr);
			break;
		case ID_TRIGGER_0000:
			delete ((TriggerScript_0000 *)ptr);
			break;
		default:
			mprintf(0,"SCRIPT: Illegal ID (%d)\n",id);
			break;
	}
}

// ===================
// CallInstanceEvent()
// ===================
short STDCALL CallInstanceEvent(int id,void *ptr,int event,tOSIRISEventInfo *data)
{
	switch(id) {
		case ID_LEVEL_0000:
		case ID_CUSTOM_OBJECT_1835:
		case ID_CUSTOM_OBJECT_1028:
		case ID_CUSTOM_OBJECT_FFFFFFFF:
		case ID_TRIGGER_0000:
			return ((BaseScript *)ptr)->CallEvent(event,data);
			break;
		default:
			mprintf(0,"SCRIPT: Illegal ID (%d)\n",id);
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

// ==================
// SaveRestoreState()
// ==================
int STDCALL SaveRestoreState( void *file_ptr, ubyte saving_state )
{
	return 0;
}

// ====================
// GetTriggerScriptID()
// ====================
int	STDCALL GetTriggerScriptID(int trigger_room,int trigger_face)
{
	if(trigger_room==Trigger_rooms[0] && trigger_face==Trigger_faces[0])
		return ID_TRIGGER_0000;
 
	return -1;
}

// =================
// GetCOScriptList()
// =================
int	STDCALL GetCOScriptList( int **list, int **id_list )
{
	static int cust_handle_list[3];
	static int cust_id_list[3] = { 
		ID_CUSTOM_OBJECT_1835,
		ID_CUSTOM_OBJECT_1028,
		ID_CUSTOM_OBJECT_FFFFFFFF
	};
 
	// Fill in the custom handle list
	cust_handle_list[0]=Object_handles[11];
	cust_handle_list[1]=Object_handles[1];
	cust_handle_list[2]=0xffffffff;

	*list = cust_handle_list;
	*id_list = cust_id_list;

	return 3;
}

//=======================
// Script Implementation 
//=======================

BaseScript::BaseScript()
{
}

BaseScript::~BaseScript()
{
}

short BaseScript::CallEvent(int event,tOSIRISEventInfo *data)
{
	mprintf(0,"BaseScript::CallEvent()\n");
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short LevelScript_0000::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_SAVESTATE:
			{
				tOSIRISEVTSAVESTATE *event_data=&data->evt_savestate;
	
				SaveGlobalActionCtrs(event_data->fileptr);
				dfSave(event_data->fileptr);
#ifdef ENABLE_CUSTOM_SAVE_AND_RESTORE
				dsCustomSave(event_data->fileptr);
#endif
			}
			break;
		case EVT_RESTORESTATE:
			{
				tOSIRISEVTRESTORESTATE *event_data=&data->evt_restorestate;
	
				RestoreGlobalActionCtrs(event_data->fileptr);
				dfRestore(event_data->fileptr);
#ifdef ENABLE_CUSTOM_SAVE_AND_RESTORE
				dsCustomRestore(event_data->fileptr);
#endif
			}
			break;
		case EVT_INTERVAL:
			{
				tOSIRISEVTINTERVAL *event_data=&data->evt_interval;
 
				// Script 009: Start the fire sequence
				if((ScriptActionCtr_009 < 1) && (qObjGetDistance(qPlayerClosest(Object_handles[9], -1, 0), Object_handles[9])<=80.000000f))
				{
					aSetLevelTimer(2.000000f, 5, 0, -1);
					aShowHUDMessage(0, 255, 0, Message_strings[0]);
					aObjGhostSet(0, Object_handles[2]);
					aObjGhostSet(0, Object_handles[3]);
					
					// Increment the script action counter
					if(ScriptActionCtr_009 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_009++;
				}
 
				// Script 013: Energy Center 1 No Power MSG
				if(qRoomHasPlayer(Room_indexes[0])==1)
				{
					aShowHUDMessage(0, 255, 0, Message_strings[8]);
					
					// Increment the script action counter
					if(ScriptActionCtr_013 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_013++;
				}
 
				// Script 014: Energy Center 2 No Power MSG
				if(qRoomHasPlayer(Room_indexes[1])==1)
				{
					aShowHUDMessage(0, 255, 0, Message_strings[8]);
					
					// Increment the script action counter
					if(ScriptActionCtr_014 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_014++;
				}
			}
			break;
		case EVT_LEVELSTART:
			{
				tOSIRISEVTLEVELSTART *event_data=&data->evt_levelstart;
 
				ClearGlobalActionCtrs();
				dfInit();
 
				// Script 000: Level Start
				if(1)
				{
					aUserVarSet(0, 10.000000f);
					aUserVarSet(1, 0.000000f);
					aUserVarSet(2, 2.000000f);
					aObjHide(Object_handles[0]);
					aSetLevelTimer(qUserVarValue(0), 0, 0, -1);
					aAIFlags(1, 16384, Object_handles[1]);
					aAIFlags(1, 16384, Object_handles[2]);
					aAIFlags(1, 16384, Object_handles[3]);
					aAIFlags(1, 16384, Object_handles[4]);
					aObjGhostSet(1, Object_handles[2]);
					aObjGhostSet(1, Object_handles[3]);
					aObjGhostSet(1, Object_handles[1]);
					aUserVarSet(3, 0.000000f);
					aPhysFlags(0, 512, Object_handles[5]);
					aPhysFlags(0, 512, Object_handles[6]);
					aPhysFlags(0, 512, Object_handles[7]);
					aRoomSetLightingFlicker(1, Room_indexes[0]);
					aRoomSetLightingFlicker(1, Room_indexes[1]);
					aRoomFogSetState(0, Room_indexes[2]);
					
					// Increment the script action counter
					if(ScriptActionCtr_000 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_000++;
				}
			}
			break;
		case EVT_TIMER:
			{
				tOSIRISEVTTIMER *event_data=&data->evt_timer;
 
				// Script 001: Random Spewer System
				if(event_data->id==0)
				{
					if(qUserVarValue(1)==2.000000f)
					{
						aUserVarSet(1, 0.000000f);
						aUserVarAdd(1.000000f, 0);
						aUserVarAdd(0.250000f, 2);
					}
					if(qUserVarValue(1)==1.000000f)
					{
						aUserVarInc(1);
						aUserVarAdd(0.700000f, 0);
						aUserVarSub(0.300000f, 2);
					}
					if(qUserVarValue(1)==0.000000f)
					{
						aUserVarInc(1);
						aUserVarSub(1.300000f, 0);
						aUserVarAdd(0.300000f, 2);
					}
					aSoundPlayObject(Sound_indexes[0], Object_handles[8], 1.000000f);
					aTurnOnSpew(Object_handles[8], 0, 7, 0.000000f, 0.000000f, 65664, 0, 0.800000f, 0.150000f, 3.000000f, 2.500000f, 20.000000f, 1, -1);
					CreateRandomSparksWrapperfromObject(20, 15, Object_handles[9], 0.800000f);
					aSetLevelTimer(qUserVarValue(0), 0, 0, -1);
					
					// Increment the script action counter
					if(ScriptActionCtr_001 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_001++;
				}
 
				// Script 002: Toasty bot script
				if((ScriptActionCtr_002 < 1) && (event_data->id==5))
				{
					aMiscShakeArea(Object_handles[10], 75.000000f, 2000.000000f);
					aSoundPlay2D(Sound_indexes[1], 1.000000f);
					aTurnOnSpew(Object_handles[0], 0, 5, 0.000000f, 0.000000f, 67584, 0, 3.000000f, 0.150000f, 10.000000f, 35.000000f, 140.000000f, 1, -1);
					aRoomSetWind(Room_indexes[3], 1.000000f, 0.000000f, 0.000000f, 10.000000f);
					aObjSetLightingColor(Object_handles[10], 1.000000f, 0.700000f, 0.500000f);
					aObjSetLightingDist(Object_handles[10], 120.000000f);
					aSetLevelTimer(11.000000f, 2, 0, -1);
					aSetObjectOnFire(Object_handles[4], 5.000000f, 1.000000f);
					aAIFlags(0, 16384, Object_handles[3]);
					aAIFlags(0, 16384, Object_handles[2]);
					aAIFlags(0, 16384, Object_handles[4]);
					
					// Increment the script action counter
					if(ScriptActionCtr_002 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_002++;
				}
 
				// Script 003: Turn off toastybot light
				if(event_data->id==2)
				{
					aRoomSetWind(Room_indexes[3], 1.000000f, 0.000000f, 0.000000f, 0.000000f);
					aObjSetLightingDist(Object_handles[10], 0.000000f);
					aSoundPlay2D(Sound_indexes[2], 1.000000f);
					
					// Increment the script action counter
					if(ScriptActionCtr_003 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_003++;
				}
 
				// Script 005: Trap effects
				if(event_data->id==3)
				{
					if(qUserVarValueInt(3)==5)
					{
						aObjSetLightingDist(Object_handles[14], 70.000000f);
						aObjSetLightingDist(Object_handles[15], 70.000000f);
						aObjSetLightingDist(Object_handles[16], 70.000000f);
						aObjSetLightingDist(Object_handles[17], 70.000000f);
						aObjSetLightingColor(Object_handles[14], 0.000000f, 1.000000f, 0.000000f);
						aObjSetLightingColor(Object_handles[15], 0.000000f, 1.000000f, 0.000000f);
						aObjSetLightingColor(Object_handles[16], 0.000000f, 1.000000f, 0.000000f);
						aObjSetLightingColor(Object_handles[17], 0.000000f, 1.000000f, 0.000000f);
						aRoomSetLightingFlicker(1, Room_indexes[2]);
						aRoomSetLightingFlicker(1, Room_indexes[4]);
						aRoomSetLightingFlicker(1, Room_indexes[4]);
						aObjGhostSet(0, Object_handles[1]);
						aAIFlags(0, 16384, Object_handles[1]);
						aCloakObject(Object_handles[1], 4.000000f);
						aEnableVirusInfection(1, Object_handles[1]);
					}
					if(qUserVarValueInt(3)==4)
					{
						aObjSetLightingDist(Object_handles[14], 0.000000f);
						aObjSetLightingDist(Object_handles[15], 0.000000f);
						aUserVarInc(3);
						aSetLevelTimer(18.000000f, 3, 0, -1);
						aSoundPlay2D(Sound_indexes[3], 1.000000f);
					}
					if(qUserVarValueInt(3)==3)
					{
						aObjSetLightingDist(Object_handles[17], 0.000000f);
						aObjSetLightingDist(Object_handles[16], 0.000000f);
						aUserVarInc(3);
						aSoundPlay2D(Sound_indexes[4], 1.000000f);
						aSetLevelTimer(1.000000f, 3, 0, -1);
					}
					if(qUserVarValueInt(3)==2)
					{
						aObjSetLightingDist(Object_handles[18], 0.000000f);
						aObjSetLightingDist(Object_handles[19], 0.000000f);
						aUserVarInc(3);
						aSoundPlay2D(Sound_indexes[4], 0.900000f);
						aSetLevelTimer(1.000000f, 3, 0, -1);
					}
					if(qUserVarValueInt(3)==1)
					{
						aObjSetLightingDist(Object_handles[20], 0.000000f);
						aObjSetLightingDist(Object_handles[21], 0.000000f);
						aUserVarInc(3);
						aSoundPlay2D(Sound_indexes[4], 0.800000f);
						aSetLevelTimer(1.000000f, 3, 0, -1);
					}
					if(qUserVarValueInt(3)==0)
					{
						aObjSetLightingDist(Object_handles[22], 0.000000f);
						aObjSetLightingDist(Object_handles[23], 0.000000f);
						aUserVarInc(3);
						aSoundPlay2D(Sound_indexes[4], 0.600000f);
						aRoomFogSetState(1, Room_indexes[2]);
						aRoomChangeFog(Room_indexes[2], 0.000000f, 0.000000f, 0.000000f, 125.000000f, 17.000000f);
						aSetLevelTimer(1.000000f, 3, 0, -1);
					}
					
					// Increment the script action counter
					if(ScriptActionCtr_005 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_005++;
				}
 
				// Script 007: Lights On
				if(event_data->id==4)
				{
					if(qUserVarValue(5)!=80.000000f)
					{
						aUserVarAdd(1.000000f, 5);
						aObjSetLightingDist(Object_handles[14], qUserVarValue(5));
						aObjSetLightingDist(Object_handles[15], qUserVarValue(5));
						aObjSetLightingDist(Object_handles[16], qUserVarValue(5));
						aObjSetLightingDist(Object_handles[17], qUserVarValue(5));
						aObjSetLightingDist(Object_handles[22], qUserVarValue(5));
						aObjSetLightingDist(Object_handles[20], qUserVarValue(5));
						aObjSetLightingDist(Object_handles[18], qUserVarValue(5));
						aObjSetLightingDist(Object_handles[23], qUserVarValue(5));
						aObjSetLightingDist(Object_handles[21], qUserVarValue(5));
						aObjSetLightingDist(Object_handles[19], qUserVarValue(5));
						aSetLevelTimer(0.100000f, 4, 0, -1);
						aRoomFogSetState(0, Room_indexes[2]);
					}
					
					// Increment the script action counter
					if(ScriptActionCtr_007 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_007++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_1835::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 004: Player picked up trapped weapon
				if((ScriptActionCtr_004 < 1) && (1))
				{
					aObjPlayAnim(Object_handles[12], 0.000000f, 2.000000f, 2.000000f, 0);
					aObjPlayAnim(Object_handles[13], 0.000000f, 2.000000f, 2.000000f, 0);
					aSetLevelTimer(4.000000f, 3, 0, -1);
					
					// Increment the script action counter
					if(ScriptActionCtr_004 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_004++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_1028::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_DESTROY:
			{
				tOSIRISEVTDESTROY *event_data=&data->evt_destroy;
 
				// If destroy event is due to level ending, don't run scripts
				if(!event_data->is_dying) break;
 
				// Script 006: Miniboss 1 killed
				if(1)
				{
					aRoomSetLightingFlicker(0, Room_indexes[4]);
					aRoomSetLightingFlicker(0, Room_indexes[5]);
					aRoomSetLightingFlicker(0, Room_indexes[2]);
					aObjSetLightingColor(Object_handles[14], 1.000000f, 1.000000f, 0.500000f);
					aObjSetLightingColor(Object_handles[15], 1.000000f, 1.000000f, 0.500000f);
					aObjSetLightingColor(Object_handles[16], 1.000000f, 1.000000f, 0.500000f);
					aObjSetLightingColor(Object_handles[17], 1.000000f, 1.000000f, 0.500000f);
					aObjSetLightingDist(Object_handles[16], 0.000000f);
					aObjSetLightingDist(Object_handles[14], 0.000000f);
					aObjSetLightingDist(Object_handles[17], 0.000000f);
					aObjSetLightingDist(Object_handles[15], 0.000000f);
					aObjPlayAnim(Object_handles[12], 2.000000f, 4.000000f, 2.000000f, 0);
					aObjPlayAnim(Object_handles[13], 2.000000f, 4.000000f, 2.000000f, 0);
					aDoorLockUnlock(0, Door_handles[0]);
					aRoomChangeFog(Room_indexes[2], 0.000000f, 0.000000f, 0.000000f, 5000.000000f, 10.000000f);
					aSetLevelTimer(10.000000f, 4, 0, -1);
					
					// Increment the script action counter
					if(ScriptActionCtr_006 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_006++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_FFFFFFFF::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 008: Get power box for laser
				if(qObjIsPlayer(event_data->it_handle)==true)
				{
					aAddObjectToInventoryNamed(data->me_handle, event_data->it_handle, Message_strings[2], 0);
					aAddGameMessage(Message_strings[3], Message_strings[3], 0, 242, 148);
					
					// Increment the script action counter
					if(ScriptActionCtr_008 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_008++;
				}
 
				// Script 011: Get fuse for laser
				if(qObjIsPlayer(event_data->it_handle)==true)
				{
					aAddObjectToInventoryNamed(data->me_handle, event_data->it_handle, Message_strings[4], 0);
					aAddGameMessage(Message_strings[5], Message_strings[5], 0, 242, 148);
					
					// Increment the script action counter
					if(ScriptActionCtr_011 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_011++;
				}
 
				// Script 012: Get lens for laser
				if(qObjIsPlayer(event_data->it_handle)==true)
				{
					aAddObjectToInventoryNamed(data->me_handle, event_data->it_handle, Message_strings[6], 0);
					aAddGameMessage(Message_strings[7], Message_strings[7], 0, 242, 148);
					
					// Increment the script action counter
					if(ScriptActionCtr_012 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_012++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short TriggerScript_0000::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 010: Guide bot spots generator
				if((ScriptActionCtr_010 < 1) && (1))
				{
					aShowHUDMessage(0, 255, 0, Message_strings[1]);
					
					// Increment the script action counter
					if(ScriptActionCtr_010 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_010++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

 
 
/*********************************************************
Script Save Block: DO NOT TOUCH ANYTHING IN THIS BLOCK!!! 
**********************************************************
$$SCRIPT_BLOCK_START
 
VERSION		3
NEXT_ID		15
 
// UserType value blocks
$$UTYPE_VALS_START UserVar
0:RSStimer
1:RSScontrol
2:RSSlifetime
3:LightCounter
5:globalDIST
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START UserFlag
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START SpewHandle
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START TimerID
0:RSS1
1:RSS2
2:turnofftoasty
3:TrapLightFX
4:LightsOn
5:firedelay
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START SavedObjectSlot
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START GoalID
$$UTYPE_VALS_END
 
 
// Name Lists
$$DOOR_LIST_START
mine_shaft
$$DOOR_LIST_END
 
$$OBJECT_LIST_START
DeadTunnSpew1
boss1
BegScratch1
BegScratch2
toastybot
V
V2
V1
Psmoke1
light2
shaker
trapped_weapon
bars1
bars2
hub_light2
hub_light4
hub_light1
hub_light3
LeftLight3
RightLight3
LeftLight2
RightLight2
LeftLight1
RightLight1
$$OBJECT_LIST_END
 
$$ROOM_LIST_START
nrgy_1
nrgy_2
hub
deadtunn1
hub_low
hub_high
$$ROOM_LIST_END
 
$$TRIGGER_LIST_START
firestarter
$$TRIGGER_LIST_END
 
$$SOUND_LIST_START
EnvSteamEmitA
DefaultBuildingExplode
DebrisExplosion
RbtHellionDeath
EnvBreakerSnapB
$$SOUND_LIST_END
 
$$TEXTURE_LIST_START
$$TEXTURE_LIST_END
 
$$SPECNAME_LIST_START
$$SPECNAME_LIST_END
 
$$PATH_LIST_START
$$PATH_LIST_END
 
$$MATCEN_LIST_START
$$MATCEN_LIST_END
 
$$GOAL_LIST_START
$$GOAL_LIST_END
 
$$STRM_AUDIO_LIST_START
$$STRM_AUDIO_LIST_END
 
 
// Script Tree Dump
00:0:Level Start 
	$$CHILD_BLOCK_START
	01:2:0 
	02:6 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aUserVarSet 
			$$CHILD_BLOCK_START
			10:10:0:0:UserVar 
			10:6:10.000000:value 
			$$CHILD_BLOCK_END
		08:aUserVarSet 
			$$CHILD_BLOCK_START
			10:10:0:1:UserVar 
			10:6:0.000000:value 
			$$CHILD_BLOCK_END
		08:aUserVarSet 
			$$CHILD_BLOCK_START
			10:10:0:2:UserVar 
			10:6:2.000000:value 
			$$CHILD_BLOCK_END
		08:aObjHide 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			06:qUserVarValue:Time 
				$$CHILD_BLOCK_START
				10:10:0:0:UserVar 
				$$CHILD_BLOCK_END
			10:10:0:0:TimerID 
			10:10:0:0:Repetition 
			10:4:-1:Repeat Count 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:1:Set/Clear 
			10:15:16384:AIFlags 
			10:1:0:1:Object 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:1:Set/Clear 
			10:15:16384:AIFlags 
			10:1:0:2:Object 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:1:Set/Clear 
			10:15:16384:AIFlags 
			10:1:0:3:Object 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:1:Set/Clear 
			10:15:16384:AIFlags 
			10:1:0:4:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:2:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:3:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:1:Object 
			$$CHILD_BLOCK_END
		08:aUserVarSet 
			$$CHILD_BLOCK_START
			10:10:0:3:UserVar 
			10:6:0.000000:value 
			$$CHILD_BLOCK_END
		08:aPhysFlags 
			$$CHILD_BLOCK_START
			10:10:0:0:Set/Clear 
			10:15:512:PhysicsFlags 
			10:1:0:5:Object 
			$$CHILD_BLOCK_END
		08:aPhysFlags 
			$$CHILD_BLOCK_START
			10:10:0:0:Set/Clear 
			10:15:512:PhysicsFlags 
			10:1:0:6:Object 
			$$CHILD_BLOCK_END
		08:aPhysFlags 
			$$CHILD_BLOCK_START
			10:10:0:0:Set/Clear 
			10:15:512:PhysicsFlags 
			10:1:0:7:Object 
			$$CHILD_BLOCK_END
		08:aRoomSetLightingFlicker 
			$$CHILD_BLOCK_START
			10:10:0:1:On/Off 
			10:2:0:Room 
			$$CHILD_BLOCK_END
		08:aRoomSetLightingFlicker 
			$$CHILD_BLOCK_START
			10:10:0:1:On/Off 
			10:2:1:Room 
			$$CHILD_BLOCK_END
		08:aRoomFogSetState 
			$$CHILD_BLOCK_START
			10:10:0:0:On/Off 
			10:2:2:Room 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:1:Random Spewer System 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:0:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserVarValue:Float 
					$$CHILD_BLOCK_START
					10:10:0:1:UserVar 
					$$CHILD_BLOCK_END
				07:1:0 
				10:6:2.000000:Literal 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aUserVarSet 
				$$CHILD_BLOCK_START
				10:10:0:1:UserVar 
				10:6:0.000000:value 
				$$CHILD_BLOCK_END
			08:aUserVarAdd 
				$$CHILD_BLOCK_START
				10:6:1.000000:value 
				10:10:0:0:UserVar 
				$$CHILD_BLOCK_END
			08:aUserVarAdd 
				$$CHILD_BLOCK_START
				10:6:0.250000:value 
				10:10:0:2:UserVar 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserVarValue:Float 
					$$CHILD_BLOCK_START
					10:10:0:1:UserVar 
					$$CHILD_BLOCK_END
				07:1:0 
				10:6:1.000000:Literal 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aUserVarInc 
				$$CHILD_BLOCK_START
				10:10:0:1:UserVar 
				$$CHILD_BLOCK_END
			08:aUserVarAdd 
				$$CHILD_BLOCK_START
				10:6:0.700000:value 
				10:10:0:0:UserVar 
				$$CHILD_BLOCK_END
			08:aUserVarSub 
				$$CHILD_BLOCK_START
				10:6:0.300000:value 
				10:10:0:2:UserVar 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserVarValue:Float 
					$$CHILD_BLOCK_START
					10:10:0:1:UserVar 
					$$CHILD_BLOCK_END
				07:1:0 
				10:6:0.000000:Literal 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aUserVarInc 
				$$CHILD_BLOCK_START
				10:10:0:1:UserVar 
				$$CHILD_BLOCK_END
			08:aUserVarSub 
				$$CHILD_BLOCK_START
				10:6:1.300000:value 
				10:10:0:0:UserVar 
				$$CHILD_BLOCK_END
			08:aUserVarAdd 
				$$CHILD_BLOCK_START
				10:6:0.300000:value 
				10:10:0:2:UserVar 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		08:aSoundPlayObject 
			$$CHILD_BLOCK_START
			10:12:0:Sound 
			10:1:0:8:Object 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		08:aTurnOnSpew 
			$$CHILD_BLOCK_START
			10:1:0:8:Object 
			10:4:0:GunNum 
			10:10:0:7:Fireball 
			10:6:0.000000:Mass 
			10:6:0.000000:Drag 
			10:15:65664:PhysicsFlags 
			10:5:0:IsRealObject 
			10:6:0.800000:BlobLifetime 
			10:6:0.150000:BlobInterval 
			10:6:3.000000:SpewLife 
			10:6:2.500000:BlobSize 
			10:6:20.000000:BlobSpeed 
			10:5:1:Randomize 
			10:10:0:-1:SpewHandle 
			$$CHILD_BLOCK_END
		08:CreateRandomSparksWrapperfromObject 
			$$CHILD_BLOCK_START
			10:4:20:Sparks 
			10:10:0:15:Fireball 
			10:1:0:9:Object 
			10:6:0.800000:Force scalar 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			06:qUserVarValue:Time 
				$$CHILD_BLOCK_START
				10:10:0:0:UserVar 
				$$CHILD_BLOCK_END
			10:10:0:0:TimerID 
			10:10:0:0:Repetition 
			10:4:-1:Repeat Count 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:2:Toasty bot script 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:5:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aMiscShakeArea 
			$$CHILD_BLOCK_START
			10:1:0:10:Object 
			10:6:75.000000:Amount 
			10:6:2000.000000:Dist 
			$$CHILD_BLOCK_END
		08:aSoundPlay2D 
			$$CHILD_BLOCK_START
			10:12:1:Sound 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		08:aTurnOnSpew 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:4:0:GunNum 
			10:10:0:5:Fireball 
			10:6:0.000000:Mass 
			10:6:0.000000:Drag 
			10:15:67584:PhysicsFlags 
			10:5:0:IsRealObject 
			10:6:3.000000:BlobLifetime 
			10:6:0.150000:BlobInterval 
			10:6:10.000000:SpewLife 
			10:6:35.000000:BlobSize 
			10:6:140.000000:BlobSpeed 
			10:5:1:Randomize 
			10:10:0:-1:SpewHandle 
			$$CHILD_BLOCK_END
		08:aRoomSetWind 
			$$CHILD_BLOCK_START
			10:2:3:Room 
			10:6:1.000000:X 
			10:6:0.000000:Y 
			10:6:0.000000:Z 
			10:6:10.000000:Speed 
			$$CHILD_BLOCK_END
		08:aObjSetLightingColor 
			$$CHILD_BLOCK_START
			10:1:0:10:Object 
			10:6:1.000000:Red 
			10:6:0.700000:Green 
			10:6:0.500000:Blue 
			$$CHILD_BLOCK_END
		08:aObjSetLightingDist 
			$$CHILD_BLOCK_START
			10:1:0:10:Object 
			10:6:120.000000:Distance 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:11.000000:Time 
			10:10:0:2:TimerID 
			10:10:0:0:Repetition 
			10:4:-1:Repeat Count 
			$$CHILD_BLOCK_END
		08:aSetObjectOnFire 
			$$CHILD_BLOCK_START
			10:1:0:4:Object 
			10:6:5.000000:Seconds 
			10:6:1.000000:Damage 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:0:Set/Clear 
			10:15:16384:AIFlags 
			10:1:0:3:Object 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:0:Set/Clear 
			10:15:16384:AIFlags 
			10:1:0:2:Object 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:0:Set/Clear 
			10:15:16384:AIFlags 
			10:1:0:4:Object 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:3:Turn off toastybot light 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:2:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aRoomSetWind 
			$$CHILD_BLOCK_START
			10:2:3:Room 
			10:6:1.000000:X 
			10:6:0.000000:Y 
			10:6:0.000000:Z 
			10:6:0.000000:Speed 
			$$CHILD_BLOCK_END
		08:aObjSetLightingDist 
			$$CHILD_BLOCK_START
			10:1:0:10:Object 
			10:6:0.000000:Distance 
			$$CHILD_BLOCK_END
		08:aSoundPlay2D 
			$$CHILD_BLOCK_START
			10:12:2:Sound 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:4:Player picked up trapped weapon 
	$$CHILD_BLOCK_START
	01:1:11 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aObjPlayAnim 
			$$CHILD_BLOCK_START
			10:1:0:12:Object 
			10:6:0.000000:StartFrame 
			10:6:2.000000:EndFrame 
			10:6:2.000000:CycleTime 
			10:5:0:Looping 
			$$CHILD_BLOCK_END
		08:aObjPlayAnim 
			$$CHILD_BLOCK_START
			10:1:0:13:Object 
			10:6:0.000000:StartFrame 
			10:6:2.000000:EndFrame 
			10:6:2.000000:CycleTime 
			10:5:0:Looping 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:4.000000:Time 
			10:10:0:3:TimerID 
			10:10:0:0:Repetition 
			10:4:-1:Repeat Count 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:5:Trap effects 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:3:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserVarValueInt:Integer 
					$$CHILD_BLOCK_START
					10:10:0:3:UserVar 
					$$CHILD_BLOCK_END
				07:1:0 
				10:4:5:Integer 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:14:Object 
				10:6:70.000000:Distance 
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:15:Object 
				10:6:70.000000:Distance 
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:16:Object 
				10:6:70.000000:Distance 
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:17:Object 
				10:6:70.000000:Distance 
				$$CHILD_BLOCK_END
			08:aObjSetLightingColor 
				$$CHILD_BLOCK_START
				10:1:0:14:Object 
				10:6:0.000000:Red 
				10:6:1.000000:Green 
				10:6:0.000000:Blue 
				$$CHILD_BLOCK_END
			08:aObjSetLightingColor 
				$$CHILD_BLOCK_START
				10:1:0:15:Object 
				10:6:0.000000:Red 
				10:6:1.000000:Green 
				10:6:0.000000:Blue 
				$$CHILD_BLOCK_END
			08:aObjSetLightingColor 
				$$CHILD_BLOCK_START
				10:1:0:16:Object 
				10:6:0.000000:Red 
				10:6:1.000000:Green 
				10:6:0.000000:Blue 
				$$CHILD_BLOCK_END
			08:aObjSetLightingColor 
				$$CHILD_BLOCK_START
				10:1:0:17:Object 
				10:6:0.000000:Red 
				10:6:1.000000:Green 
				10:6:0.000000:Blue 
				$$CHILD_BLOCK_END
			08:aRoomSetLightingFlicker 
				$$CHILD_BLOCK_START
				10:10:0:1:On/Off 
				10:2:2:Room 
				$$CHILD_BLOCK_END
			08:aRoomSetLightingFlicker 
				$$CHILD_BLOCK_START
				10:10:0:1:On/Off 
				10:2:4:Room 
				$$CHILD_BLOCK_END
			08:aRoomSetLightingFlicker 
				$$CHILD_BLOCK_START
				10:10:0:1:On/Off 
				10:2:4:Room 
				$$CHILD_BLOCK_END
			08:aObjGhostSet 
				$$CHILD_BLOCK_START
				10:10:0:0:Ghost/Unghost 
				10:1:0:1:Object 
				$$CHILD_BLOCK_END
			08:aAIFlags 
				$$CHILD_BLOCK_START
				10:10:0:0:Set/Clear 
				10:15:16384:AIFlags 
				10:1:0:1:Object 
				$$CHILD_BLOCK_END
			08:aCloakObject 
				$$CHILD_BLOCK_START
				10:1:0:1:Object 
				10:6:4.000000:Time 
				$$CHILD_BLOCK_END
			08:aEnableVirusInfection 
				$$CHILD_BLOCK_START
				10:10:0:1:Enable/Disable 
				10:1:0:1:Object 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserVarValueInt:Integer 
					$$CHILD_BLOCK_START
					10:10:0:3:UserVar 
					$$CHILD_BLOCK_END
				07:1:0 
				10:4:4:Integer 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:14:Object 
				10:6:0.000000:Distance 
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:15:Object 
				10:6:0.000000:Distance 
				$$CHILD_BLOCK_END
			08:aUserVarInc 
				$$CHILD_BLOCK_START
				10:10:0:3:UserVar 
				$$CHILD_BLOCK_END
			08:aSetLevelTimer 
				$$CHILD_BLOCK_START
				10:6:18.000000:Time 
				10:10:0:3:TimerID 
				10:10:0:0:Repetition 
				10:4:-1:Repeat Count 
				$$CHILD_BLOCK_END
			08:aSoundPlay2D 
				$$CHILD_BLOCK_START
				10:12:3:Sound 
				10:9:1.000000:Volume 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserVarValueInt:Integer 
					$$CHILD_BLOCK_START
					10:10:0:3:UserVar 
					$$CHILD_BLOCK_END
				07:1:0 
				10:4:3:Integer 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:17:Object 
				10:6:0.000000:Distance 
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:16:Object 
				10:6:0.000000:Distance 
				$$CHILD_BLOCK_END
			08:aUserVarInc 
				$$CHILD_BLOCK_START
				10:10:0:3:UserVar 
				$$CHILD_BLOCK_END
			08:aSoundPlay2D 
				$$CHILD_BLOCK_START
				10:12:4:Sound 
				10:9:1.000000:Volume 
				$$CHILD_BLOCK_END
			08:aSetLevelTimer 
				$$CHILD_BLOCK_START
				10:6:1.000000:Time 
				10:10:0:3:TimerID 
				10:10:0:0:Repetition 
				10:4:-1:Repeat Count 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserVarValueInt:Integer 
					$$CHILD_BLOCK_START
					10:10:0:3:UserVar 
					$$CHILD_BLOCK_END
				07:1:0 
				10:4:2:Integer 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:18:Object 
				10:6:0.000000:Distance 
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:19:Object 
				10:6:0.000000:Distance 
				$$CHILD_BLOCK_END
			08:aUserVarInc 
				$$CHILD_BLOCK_START
				10:10:0:3:UserVar 
				$$CHILD_BLOCK_END
			08:aSoundPlay2D 
				$$CHILD_BLOCK_START
				10:12:4:Sound 
				10:9:0.900000:Volume 
				$$CHILD_BLOCK_END
			08:aSetLevelTimer 
				$$CHILD_BLOCK_START
				10:6:1.000000:Time 
				10:10:0:3:TimerID 
				10:10:0:0:Repetition 
				10:4:-1:Repeat Count 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserVarValueInt:Integer 
					$$CHILD_BLOCK_START
					10:10:0:3:UserVar 
					$$CHILD_BLOCK_END
				07:1:0 
				10:4:1:Integer 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:20:Object 
				10:6:0.000000:Distance 
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:21:Object 
				10:6:0.000000:Distance 
				$$CHILD_BLOCK_END
			08:aUserVarInc 
				$$CHILD_BLOCK_START
				10:10:0:3:UserVar 
				$$CHILD_BLOCK_END
			08:aSoundPlay2D 
				$$CHILD_BLOCK_START
				10:12:4:Sound 
				10:9:0.800000:Volume 
				$$CHILD_BLOCK_END
			08:aSetLevelTimer 
				$$CHILD_BLOCK_START
				10:6:1.000000:Time 
				10:10:0:3:TimerID 
				10:10:0:0:Repetition 
				10:4:-1:Repeat Count 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserVarValueInt:Integer 
					$$CHILD_BLOCK_START
					10:10:0:3:UserVar 
					$$CHILD_BLOCK_END
				07:1:0 
				10:4:0:Integer 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:22:Object 
				10:6:0.000000:Distance 
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:23:Object 
				10:6:0.000000:Distance 
				$$CHILD_BLOCK_END
			08:aUserVarInc 
				$$CHILD_BLOCK_START
				10:10:0:3:UserVar 
				$$CHILD_BLOCK_END
			08:aSoundPlay2D 
				$$CHILD_BLOCK_START
				10:12:4:Sound 
				10:9:0.600000:Volume 
				$$CHILD_BLOCK_END
			08:aRoomFogSetState 
				$$CHILD_BLOCK_START
				10:10:0:1:On/Off 
				10:2:2:Room 
				$$CHILD_BLOCK_END
			08:aRoomChangeFog 
				$$CHILD_BLOCK_START
				10:2:2:Room 
				10:6:0.000000:Red 
				10:6:0.000000:Green 
				10:6:0.000000:Blue 
				10:6:125.000000:Depth 
				10:6:17.000000:Time 
				$$CHILD_BLOCK_END
			08:aSetLevelTimer 
				$$CHILD_BLOCK_START
				10:6:1.000000:Time 
				10:10:0:3:TimerID 
				10:10:0:0:Repetition 
				10:4:-1:Repeat Count 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:6:Miniboss 1 killed 
	$$CHILD_BLOCK_START
	01:1:1 
	02:4 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aRoomSetLightingFlicker 
			$$CHILD_BLOCK_START
			10:10:0:0:On/Off 
			10:2:4:Room 
			$$CHILD_BLOCK_END
		08:aRoomSetLightingFlicker 
			$$CHILD_BLOCK_START
			10:10:0:0:On/Off 
			10:2:5:Room 
			$$CHILD_BLOCK_END
		08:aRoomSetLightingFlicker 
			$$CHILD_BLOCK_START
			10:10:0:0:On/Off 
			10:2:2:Room 
			$$CHILD_BLOCK_END
		08:aObjSetLightingColor 
			$$CHILD_BLOCK_START
			10:1:0:14:Object 
			10:6:1.000000:Red 
			10:6:1.000000:Green 
			10:6:0.500000:Blue 
			$$CHILD_BLOCK_END
		08:aObjSetLightingColor 
			$$CHILD_BLOCK_START
			10:1:0:15:Object 
			10:6:1.000000:Red 
			10:6:1.000000:Green 
			10:6:0.500000:Blue 
			$$CHILD_BLOCK_END
		08:aObjSetLightingColor 
			$$CHILD_BLOCK_START
			10:1:0:16:Object 
			10:6:1.000000:Red 
			10:6:1.000000:Green 
			10:6:0.500000:Blue 
			$$CHILD_BLOCK_END
		08:aObjSetLightingColor 
			$$CHILD_BLOCK_START
			10:1:0:17:Object 
			10:6:1.000000:Red 
			10:6:1.000000:Green 
			10:6:0.500000:Blue 
			$$CHILD_BLOCK_END
		08:aObjSetLightingDist 
			$$CHILD_BLOCK_START
			10:1:0:16:Object 
			10:6:0.000000:Distance 
			$$CHILD_BLOCK_END
		08:aObjSetLightingDist 
			$$CHILD_BLOCK_START
			10:1:0:14:Object 
			10:6:0.000000:Distance 
			$$CHILD_BLOCK_END
		08:aObjSetLightingDist 
			$$CHILD_BLOCK_START
			10:1:0:17:Object 
			10:6:0.000000:Distance 
			$$CHILD_BLOCK_END
		08:aObjSetLightingDist 
			$$CHILD_BLOCK_START
			10:1:0:15:Object 
			10:6:0.000000:Distance 
			$$CHILD_BLOCK_END
		08:aObjPlayAnim 
			$$CHILD_BLOCK_START
			10:1:0:12:Object 
			10:6:2.000000:StartFrame 
			10:6:4.000000:EndFrame 
			10:6:2.000000:CycleTime 
			10:5:0:Looping 
			$$CHILD_BLOCK_END
		08:aObjPlayAnim 
			$$CHILD_BLOCK_START
			10:1:0:13:Object 
			10:6:2.000000:StartFrame 
			10:6:4.000000:EndFrame 
			10:6:2.000000:CycleTime 
			10:5:0:Looping 
			$$CHILD_BLOCK_END
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:0:Lock/Unlock 
			10:0:0:0:DoorName 
			$$CHILD_BLOCK_END
		08:aRoomChangeFog 
			$$CHILD_BLOCK_START
			10:2:2:Room 
			10:6:0.000000:Red 
			10:6:0.000000:Green 
			10:6:0.000000:Blue 
			10:6:5000.000000:Depth 
			10:6:10.000000:Time 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:10.000000:Time 
			10:10:0:4:TimerID 
			10:10:0:0:Repetition 
			10:4:-1:Repeat Count 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:7:Lights On 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:4:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserVarValue:Float 
					$$CHILD_BLOCK_START
					10:10:0:5:UserVar 
					$$CHILD_BLOCK_END
				07:1:1 
				10:6:80.000000:Literal 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aUserVarAdd 
				$$CHILD_BLOCK_START
				10:6:1.000000:value 
				10:10:0:5:UserVar 
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:14:Object 
				06:qUserVarValue:Distance 
					$$CHILD_BLOCK_START
					10:10:0:5:UserVar 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:15:Object 
				06:qUserVarValue:Distance 
					$$CHILD_BLOCK_START
					10:10:0:5:UserVar 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:16:Object 
				06:qUserVarValue:Distance 
					$$CHILD_BLOCK_START
					10:10:0:5:UserVar 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:17:Object 
				06:qUserVarValue:Distance 
					$$CHILD_BLOCK_START
					10:10:0:5:UserVar 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:22:Object 
				06:qUserVarValue:Distance 
					$$CHILD_BLOCK_START
					10:10:0:5:UserVar 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:20:Object 
				06:qUserVarValue:Distance 
					$$CHILD_BLOCK_START
					10:10:0:5:UserVar 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:18:Object 
				06:qUserVarValue:Distance 
					$$CHILD_BLOCK_START
					10:10:0:5:UserVar 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:23:Object 
				06:qUserVarValue:Distance 
					$$CHILD_BLOCK_START
					10:10:0:5:UserVar 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:21:Object 
				06:qUserVarValue:Distance 
					$$CHILD_BLOCK_START
					10:10:0:5:UserVar 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			08:aObjSetLightingDist 
				$$CHILD_BLOCK_START
				10:1:0:19:Object 
				06:qUserVarValue:Distance 
					$$CHILD_BLOCK_START
					10:10:0:5:UserVar 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			08:aSetLevelTimer 
				$$CHILD_BLOCK_START
				10:6:0.100000:Time 
				10:10:0:4:TimerID 
				10:10:0:0:Repetition 
				10:4:-1:Repeat Count 
				$$CHILD_BLOCK_END
			08:aRoomFogSetState 
				$$CHILD_BLOCK_START
				10:10:0:0:On/Off 
				10:2:2:Room 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:9:Start the fire sequence 
	$$CHILD_BLOCK_START
	01:2:0 
	02:5 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjGetDistance:Float 
				$$CHILD_BLOCK_START
				06:qPlayerClosest:Object1 
					$$CHILD_BLOCK_START
					10:1:0:9:Object 
					10:10:0:-1:UserVar 
					10:10:0:0:On/Off 
					$$CHILD_BLOCK_END
				10:1:0:9:Object2 
				$$CHILD_BLOCK_END
			07:1:5 
			10:6:80.000000:Literal 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:2.000000:Time 
			10:10:0:5:TimerID 
			10:10:0:0:Repetition 
			10:4:-1:Repeat Count 
			$$CHILD_BLOCK_END
		08:aShowHUDMessage 
			$$CHILD_BLOCK_START
			10:4:0:Red 
			10:4:255:Green 
			10:4:0:Blue 
			10:8:GBgenmissing:Message 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:0:Ghost/Unghost 
			10:1:0:2:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:0:Ghost/Unghost 
			10:1:0:3:Object 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:10:Guide bot spots generator 
	$$CHILD_BLOCK_START
	01:0:0 
	02:1 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aShowHUDMessage 
			$$CHILD_BLOCK_START
			10:4:0:Red 
			10:4:255:Green 
			10:4:0:Blue 
			10:8:GBgennote:Message 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:8:Get power box for laser 
	$$CHILD_BLOCK_START
	01:1:-2 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:1 
			$$CHILD_BLOCK_START
			06:qObjIsPlayer:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:0:6 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aAddObjectToInventoryNamed 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			10:1:1:-1:PlayerObject 
			10:8:laserpower:ItemName 
			10:5:0:Spewable 
			$$CHILD_BLOCK_END
		08:aAddGameMessage 
			$$CHILD_BLOCK_START
			10:8:powerget:GameMessage 
			10:8:powerget:HUDMessage 
			10:4:0:Red 
			10:4:242:Green 
			10:4:148:Blue 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:11:Get fuse for laser 
	$$CHILD_BLOCK_START
	01:1:-2 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:1 
			$$CHILD_BLOCK_START
			06:qObjIsPlayer:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:0:6 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aAddObjectToInventoryNamed 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			10:1:1:-1:PlayerObject 
			10:8:fusemsg:ItemName 
			10:5:0:Spewable 
			$$CHILD_BLOCK_END
		08:aAddGameMessage 
			$$CHILD_BLOCK_START
			10:8:fuseget:GameMessage 
			10:8:fuseget:HUDMessage 
			10:4:0:Red 
			10:4:242:Green 
			10:4:148:Blue 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:12:Get lens for laser 
	$$CHILD_BLOCK_START
	01:1:-2 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:1 
			$$CHILD_BLOCK_START
			06:qObjIsPlayer:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:0:6 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aAddObjectToInventoryNamed 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			10:1:1:-1:PlayerObject 
			10:8:laserfocus:ItemName 
			10:5:0:Spewable 
			$$CHILD_BLOCK_END
		08:aAddGameMessage 
			$$CHILD_BLOCK_START
			10:8:lensget:GameMessage 
			10:8:lensget:HUDMessage 
			10:4:0:Red 
			10:4:242:Green 
			10:4:148:Blue 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:13:Energy Center 1 No Power MSG 
	$$CHILD_BLOCK_START
	01:2:0 
	02:5 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qRoomHasPlayer:Bool 
				$$CHILD_BLOCK_START
				10:2:0:Room 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aShowHUDMessage 
			$$CHILD_BLOCK_START
			10:4:0:Red 
			10:4:255:Green 
			10:4:0:Blue 
			10:8:pwr_shortage:Message 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:14:Energy Center 2 No Power MSG 
	$$CHILD_BLOCK_START
	01:2:0 
	02:5 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qRoomHasPlayer:Bool 
				$$CHILD_BLOCK_START
				10:2:1:Room 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aShowHUDMessage 
			$$CHILD_BLOCK_START
			10:4:0:Red 
			10:4:255:Green 
			10:4:0:Blue 
			10:8:pwr_shortage:Message 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
 
$$SCRIPT_BLOCK_END
*********************************************************/
