/////////////////////////////////////////////////////////////////////
// D.A.L.L.A.S. Generated Level Script - DLL Source File
// 
// Filename:	MN0019_SE.cpp
// Version:	3
/////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "osiris_import.h"
#include "osiris_common.h"
#include "dallasfuncs.cpp"

#ifdef _MSC_VER		//Visual C++ Build
#define STDCALL		__stdcall
#define STDCALLPTR	*STDCALL
#else					//Non-Visual C++ Build
#define STDCALL __attribute__((stdcall))
#define STDCALLPTR	STDCALL*
#endif

#ifdef __cplusplus
extern "C"{
#endif
char		STDCALL InitializeDLL(tOSIRISModuleInit *func_list);
void		STDCALL ShutdownDLL(void);
int		STDCALL GetGOScriptID(char *name,ubyte is_door);
void		STDCALLPTR CreateInstance(int id);
void		STDCALL DestroyInstance(int id,void *ptr);
short	STDCALL CallInstanceEvent(int id,void *ptr,int event,tOSIRISEventInfo *data);
int		STDCALL GetTriggerScriptID(int trigger_room, int trigger_face );
int		STDCALL GetCOScriptList( int **list, int **id_list );
int		STDCALL SaveRestoreState( void *file_ptr, ubyte saving_state );
#ifdef __cplusplus
}
#endif

// =================
// Script ID Numbers
// =================
#define ID_LEVEL_0000			0x000

#define ID_CUSTOM_OBJECT_09FF		0x001
#define ID_CUSTOM_OBJECT_1804		0x002
#define ID_CUSTOM_OBJECT_0806		0x003
#define ID_CUSTOM_OBJECT_09FE		0x004
#define ID_CUSTOM_OBJECT_206E		0x005
#define ID_CUSTOM_OBJECT_1159		0x006
#define ID_CUSTOM_OBJECT_08F8		0x007
#define ID_CUSTOM_OBJECT_1160		0x008
#define ID_CUSTOM_OBJECT_0A22		0x009
#define ID_CUSTOM_OBJECT_0943		0x00a
#define ID_CUSTOM_OBJECT_0947		0x00b
#define ID_CUSTOM_OBJECT_2011		0x00c
#define ID_CUSTOM_OBJECT_1814		0x00d

#define ID_TRIGGER_0000		0x00e
#define ID_TRIGGER_0001		0x00f

// ========================
// Script Class Definitions
// ========================

class BaseScript {
public:
	BaseScript();
	~BaseScript();
	virtual short CallEvent(int event, tOSIRISEventInfo *data);
};

class LevelScript_0000 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_09FF : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_1804 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_0806 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_09FE : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_206E : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_1159 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_08F8 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_1160 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_0A22 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_0943 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_0947 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_2011 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_1814 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class TriggerScript_0000 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class TriggerScript_0001 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

// ======================
// Global Action Counters
// ======================

#define MAX_ACTION_CTR_VALUE		100000

int ScriptActionCtr_005 = 0;
int ScriptActionCtr_010 = 0;
int ScriptActionCtr_027 = 0;
int ScriptActionCtr_029 = 0;
int ScriptActionCtr_030 = 0;
int ScriptActionCtr_032 = 0;
int ScriptActionCtr_031 = 0;
int ScriptActionCtr_000 = 0;
int ScriptActionCtr_033 = 0;
int ScriptActionCtr_009 = 0;
int ScriptActionCtr_011 = 0;
int ScriptActionCtr_003 = 0;
int ScriptActionCtr_004 = 0;
int ScriptActionCtr_026 = 0;
int ScriptActionCtr_028 = 0;
int ScriptActionCtr_007 = 0;
int ScriptActionCtr_008 = 0;
int ScriptActionCtr_023 = 0;
int ScriptActionCtr_024 = 0;
int ScriptActionCtr_034 = 0;
int ScriptActionCtr_022 = 0;
int ScriptActionCtr_012 = 0;
int ScriptActionCtr_019 = 0;
int ScriptActionCtr_002 = 0;
int ScriptActionCtr_001 = 0;
int ScriptActionCtr_015 = 0;
int ScriptActionCtr_016 = 0;
int ScriptActionCtr_017 = 0;
int ScriptActionCtr_025 = 0;
int ScriptActionCtr_006 = 0;
int ScriptActionCtr_021 = 0;
 
// ========================================
// Function to Clear Global Action Counters
// ========================================
void ClearGlobalActionCtrs(void)
{
	ScriptActionCtr_005 = 0;
	ScriptActionCtr_010 = 0;
	ScriptActionCtr_027 = 0;
	ScriptActionCtr_029 = 0;
	ScriptActionCtr_030 = 0;
	ScriptActionCtr_032 = 0;
	ScriptActionCtr_031 = 0;
	ScriptActionCtr_000 = 0;
	ScriptActionCtr_033 = 0;
	ScriptActionCtr_009 = 0;
	ScriptActionCtr_011 = 0;
	ScriptActionCtr_003 = 0;
	ScriptActionCtr_004 = 0;
	ScriptActionCtr_026 = 0;
	ScriptActionCtr_028 = 0;
	ScriptActionCtr_007 = 0;
	ScriptActionCtr_008 = 0;
	ScriptActionCtr_023 = 0;
	ScriptActionCtr_024 = 0;
	ScriptActionCtr_034 = 0;
	ScriptActionCtr_022 = 0;
	ScriptActionCtr_012 = 0;
	ScriptActionCtr_019 = 0;
	ScriptActionCtr_002 = 0;
	ScriptActionCtr_001 = 0;
	ScriptActionCtr_015 = 0;
	ScriptActionCtr_016 = 0;
	ScriptActionCtr_017 = 0;
	ScriptActionCtr_025 = 0;
	ScriptActionCtr_006 = 0;
	ScriptActionCtr_021 = 0;
}
 
// ========================================
// Function to Save Global Action Counters
// ========================================
void SaveGlobalActionCtrs(void *file_ptr)
{
	File_WriteInt(ScriptActionCtr_005,file_ptr);
	File_WriteInt(ScriptActionCtr_010,file_ptr);
	File_WriteInt(ScriptActionCtr_027,file_ptr);
	File_WriteInt(ScriptActionCtr_029,file_ptr);
	File_WriteInt(ScriptActionCtr_030,file_ptr);
	File_WriteInt(ScriptActionCtr_032,file_ptr);
	File_WriteInt(ScriptActionCtr_031,file_ptr);
	File_WriteInt(ScriptActionCtr_000,file_ptr);
	File_WriteInt(ScriptActionCtr_033,file_ptr);
	File_WriteInt(ScriptActionCtr_009,file_ptr);
	File_WriteInt(ScriptActionCtr_011,file_ptr);
	File_WriteInt(ScriptActionCtr_003,file_ptr);
	File_WriteInt(ScriptActionCtr_004,file_ptr);
	File_WriteInt(ScriptActionCtr_026,file_ptr);
	File_WriteInt(ScriptActionCtr_028,file_ptr);
	File_WriteInt(ScriptActionCtr_007,file_ptr);
	File_WriteInt(ScriptActionCtr_008,file_ptr);
	File_WriteInt(ScriptActionCtr_023,file_ptr);
	File_WriteInt(ScriptActionCtr_024,file_ptr);
	File_WriteInt(ScriptActionCtr_034,file_ptr);
	File_WriteInt(ScriptActionCtr_022,file_ptr);
	File_WriteInt(ScriptActionCtr_012,file_ptr);
	File_WriteInt(ScriptActionCtr_019,file_ptr);
	File_WriteInt(ScriptActionCtr_002,file_ptr);
	File_WriteInt(ScriptActionCtr_001,file_ptr);
	File_WriteInt(ScriptActionCtr_015,file_ptr);
	File_WriteInt(ScriptActionCtr_016,file_ptr);
	File_WriteInt(ScriptActionCtr_017,file_ptr);
	File_WriteInt(ScriptActionCtr_025,file_ptr);
	File_WriteInt(ScriptActionCtr_006,file_ptr);
	File_WriteInt(ScriptActionCtr_021,file_ptr);
}
 
// ===========================================
// Function to Restore Global Action Counters
// ===========================================
void RestoreGlobalActionCtrs(void *file_ptr)
{
	ScriptActionCtr_005=File_ReadInt(file_ptr);
	ScriptActionCtr_010=File_ReadInt(file_ptr);
	ScriptActionCtr_027=File_ReadInt(file_ptr);
	ScriptActionCtr_029=File_ReadInt(file_ptr);
	ScriptActionCtr_030=File_ReadInt(file_ptr);
	ScriptActionCtr_032=File_ReadInt(file_ptr);
	ScriptActionCtr_031=File_ReadInt(file_ptr);
	ScriptActionCtr_000=File_ReadInt(file_ptr);
	ScriptActionCtr_033=File_ReadInt(file_ptr);
	ScriptActionCtr_009=File_ReadInt(file_ptr);
	ScriptActionCtr_011=File_ReadInt(file_ptr);
	ScriptActionCtr_003=File_ReadInt(file_ptr);
	ScriptActionCtr_004=File_ReadInt(file_ptr);
	ScriptActionCtr_026=File_ReadInt(file_ptr);
	ScriptActionCtr_028=File_ReadInt(file_ptr);
	ScriptActionCtr_007=File_ReadInt(file_ptr);
	ScriptActionCtr_008=File_ReadInt(file_ptr);
	ScriptActionCtr_023=File_ReadInt(file_ptr);
	ScriptActionCtr_024=File_ReadInt(file_ptr);
	ScriptActionCtr_034=File_ReadInt(file_ptr);
	ScriptActionCtr_022=File_ReadInt(file_ptr);
	ScriptActionCtr_012=File_ReadInt(file_ptr);
	ScriptActionCtr_019=File_ReadInt(file_ptr);
	ScriptActionCtr_002=File_ReadInt(file_ptr);
	ScriptActionCtr_001=File_ReadInt(file_ptr);
	ScriptActionCtr_015=File_ReadInt(file_ptr);
	ScriptActionCtr_016=File_ReadInt(file_ptr);
	ScriptActionCtr_017=File_ReadInt(file_ptr);
	ScriptActionCtr_025=File_ReadInt(file_ptr);
	ScriptActionCtr_006=File_ReadInt(file_ptr);
	ScriptActionCtr_021=File_ReadInt(file_ptr);
}
 
 
// ===============================================================
// Start of Custom Script Block - DO NOT EDIT ANYTHING BEFORE THIS
// ===============================================================
/**{CUSTOM_SCRIPT_BLOCK_START}** DO NOT EDIT! **/
 
// Enter your custom script code here
 
/**{CUSTOM_SCRIPT_BLOCK_END}**** DO NOT EDIT! **/
// ============================================================
// End of Custom Script Block - DO NOT EDIT ANYTHING AFTER THIS
// ============================================================
 
 
// =================
// Message File Data
// =================
 
#define MAX_SCRIPT_MESSAGES	256
#define MAX_MSG_FILEBUF_LEN	1024
#define NO_MESSAGE_STRING		"*Message Not Found*"
#define INV_MSGNAME_STRING	"*Message Name Invalid*"
#define WHITESPACE_CHARS	" \t\r\n"
 
// Structure for storing a script message
typedef struct {
	char *name;			// the name of the message
	char *message;		// the actual message text
} tScriptMessage;
 
// Global storage for level script messages
tScriptMessage *message_list[MAX_SCRIPT_MESSAGES];
int num_messages;
 
// ======================
// Message File Functions
// ======================
 
// Initializes the Message List
void InitMessageList(void)
{
	for(int j=0;j<MAX_SCRIPT_MESSAGES;j++)
		message_list[j]=NULL;
	num_messages=0;
}
 
// Clear the Message List
void ClearMessageList(void)
{
	for(int j=0;j<num_messages;j++) {
		free(message_list[j]->name);
		free(message_list[j]->message);
		free(message_list[j]);
		message_list[j]=NULL;
	}
	num_messages=0;
}
 
// Adds a message to the list
int AddMessageToList(char *name, char *msg)
{
	int pos;
 
	// Make sure there is room in the list
	if(num_messages>=MAX_SCRIPT_MESSAGES) return false;
 
	// Allocate memory for this message entry
	pos=num_messages;
	message_list[pos]=(tScriptMessage *)malloc(sizeof(tScriptMessage));
	if(message_list[pos]==NULL) return false;
 
	// Allocate memory for the message name
	message_list[pos]->name=(char *)malloc(strlen(name)+1);
	if(message_list[pos]->name==NULL) {
		free(message_list[pos]);
		return false;
	}
	strcpy(message_list[pos]->name,name);
 
	// Allocate memory for the message name
	message_list[pos]->message=(char *)malloc(strlen(msg)+1);
	if(message_list[pos]->message==NULL) {
		free(message_list[pos]->name);
		free(message_list[pos]);
		return false;
	}
	strcpy(message_list[pos]->message,msg);
	num_messages++;
 
	return true;
}
 
// Removes any whitespace padding from the end of a string
void RemoveTrailingWhitespace(char *s)
{
	int last_char_pos;
 
	last_char_pos=strlen(s)-1;
	while(last_char_pos>=0 && isspace(s[last_char_pos])) {
		s[last_char_pos]='\0';
		last_char_pos--;
	}
}
 
// Returns a pointer to the first non-whitespace char in given string
char *SkipInitialWhitespace(char *s)
{
	while((*s)!='\0' && isspace(*s)) 
		s++;
 
	return(s);
}
 
// Read in the Messages
int ReadMessageFile(char *filename)
{
	void *infile;
	char filebuffer[MAX_MSG_FILEBUF_LEN+1];
	char *line, *msg_start;
	int line_num;
	bool next_msgid_found;
 
	// Try to open the file for loading
	infile=File_Open(filename,"rt");
	if (!infile) return false;
 
	line_num=0;
	next_msgid_found=true;
 
	// Clear the message list
	ClearMessageList();
 
	// Read in and parse each line of the file
	while (!File_eof(infile)) {
 
		// Clear the buffer
		strcpy(filebuffer,"");
 
		// Read in a line from the file
		File_ReadString(filebuffer, MAX_MSG_FILEBUF_LEN, infile);
		line_num++;
 
		// Remove whitespace padding at start and end of line
		RemoveTrailingWhitespace(filebuffer);
		line=SkipInitialWhitespace(filebuffer);
 
		// If line is a comment, or empty, discard it
		if(strlen(line)==0 || strncmp(line,"//",2)==0)
			continue;
 
		if(!next_msgid_found) {		// Parse out the last message ID number
 
			// Grab the first keyword, make sure it's valid
			line=strtok(line,WHITESPACE_CHARS);
			if(line==NULL) continue;
 
			// Grab the second keyword, and assign it as the next message ID
			line=strtok(NULL,WHITESPACE_CHARS);
			if(line==NULL) continue;
 
			next_msgid_found=true;
		}
		else {	// Parse line as a message line
			
			// Find the start of message, and mark it
			msg_start=strchr(line,'=');
			if(msg_start==NULL) continue;
			msg_start[0]='\0';
			msg_start++;
			
			// Add the message to the list
			AddMessageToList(line,msg_start);
		}
	}
	File_Close(infile);
 
	return true;
}
 
// Find a message
char *GetMessage(char *name)
{
	// Make sure given name is valid
	if(name==NULL) return INV_MSGNAME_STRING;
 
	// Search message list for name
	for(int j=0;j<num_messages;j++)
		if(strcmp(message_list[j]->name,name)==0) return(message_list[j]->message);
 
	// Couldn't find it
	return NO_MESSAGE_STRING;
}
 
 
//======================
// Name List Arrays     
//======================
 
#define NUM_DOOR_NAMES		5
char *Door_names[NUM_DOOR_NAMES] = {
	"Door - Bay",
	"Door - Level 1 BA",
	"Exit Door",
	"Airlock Door 2",
	"Airlock Door 1"
};
int Door_handles[NUM_DOOR_NAMES];
 
#define NUM_OBJECT_NAMES		33
char *Object_names[NUM_OBJECT_NAMES] = {
	"Mercury Core Boss",
	"Entrance Turret",
	"Swatter_1",
	"Turret_1",
	"Turret_2",
	"Lance_1",
	"Lance_2",
	"Flak_1",
	"Flak_2",
	"Flak_3",
	"Level 1 Key",
	"Reactor Key",
	"Air 1",
	"Air 2",
	"Air 3",
	"Air 4",
	"Air 5",
	"Air 6",
	"Warp_1",
	"Warp_2",
	"Warp_3",
	"Warp_4",
	"Door - Bay",
	"Reactor",
	"Airlock Door 1",
	"Cloaking Device",
	"Airlock Door 2",
	"Switch - L1BA",
	"BS Container 1",
	"Mega Container 1",
	"EMD Container 1",
	"4pack Container 1",
	"Mystery Death"
};
int Object_handles[NUM_OBJECT_NAMES];
 
#define NUM_ROOM_NAMES		6
char *Room_names[NUM_ROOM_NAMES] = {
	"Tunnel_Entrance",
	"Tunnel_Entrance 2",
	"Airlock 1",
	"Airlock Zone",
	"Reactor Chamber",
	"Relay_1"
};
int Room_indexes[NUM_ROOM_NAMES];
 
#define NUM_TRIGGER_NAMES		2
char *Trigger_names[NUM_TRIGGER_NAMES] = {
	"Vacuum_Main",
	"Vacuum_Back"
};
int Trigger_indexes[NUM_TRIGGER_NAMES];
int Trigger_faces[NUM_TRIGGER_NAMES];
int Trigger_rooms[NUM_TRIGGER_NAMES];
 
#define NUM_SOUND_NAMES		4
char *Sound_names[NUM_SOUND_NAMES] = {
	"Powerup pickup",
	"AmbSwitch31",
	"RbtMercuryMatcenSpawn",
	"RbtMercuryDeath"
};
int Sound_indexes[NUM_SOUND_NAMES];
 
#define NUM_TEXTURE_NAMES		0
char **Texture_names=NULL;
int *Texture_indexes=NULL;
 
#define NUM_PATH_NAMES		2
char *Path_names[NUM_PATH_NAMES] = {
	"Introduction_Camera",
	"Introduction_Player"
};
int Path_indexes[NUM_PATH_NAMES];
 
#define NUM_MATCEN_NAMES		1
char *Matcen_names[NUM_MATCEN_NAMES] = {
	"Matcen 1"
};
int Matcen_indexes[NUM_MATCEN_NAMES];
 
#define NUM_GOAL_NAMES		2
char *Goal_names[NUM_GOAL_NAMES] = {
	"Destroy the Reactor",
	"Escape Alive"
};
int Goal_indexes[NUM_GOAL_NAMES];
 
#define NUM_MESSAGE_NAMES		12
char *Message_names[NUM_MESSAGE_NAMES] = {
	"Introduction",
	"Cloaking_Device",
	"Cloaked_No_Energy_Left",
	"L1BA_1",
	"L1BA_2",
	"Mystery_Death",
	"Key_Level_Two",
	"Key_Reactor",
	"Reactor_Invulnerability",
	"GB_Self_Destruct",
	"Empty",
	"Supervisor_See"
};
char *Message_strings[NUM_MESSAGE_NAMES];
 
// ===============
// InitializeDLL()
// ===============
char STDCALL InitializeDLL(tOSIRISModuleInit *func_list)
{
	osicommon_Initialize((tOSIRISModuleInit *)func_list);
 
	ClearGlobalActionCtrs();
	dfInit();
	InitMessageList();
 
	// Build the filename of the message file
	char filename[_MAX_PATH+1];
	char english_filename[_MAX_PATH+1];
	int lang_type;
	if(func_list->script_identifier!=NULL) {
		_splitpath(func_list->script_identifier,NULL,NULL,filename,NULL);
		sprintf(english_filename,"%s.msg",filename);
		lang_type=Game_GetLanguage();
		if(lang_type==LANGUAGE_FRENCH) strcat(filename,"_FRN");
		else if(lang_type==LANGUAGE_GERMAN) strcat(filename,"_GER");
		else if(lang_type==LANGUAGE_ITALIAN) strcat(filename,"_ITN");
		else if(lang_type==LANGUAGE_SPANISH) strcat(filename,"_SPN");
		else if(lang_type==LANGUAGE_POLISH) strcat(filename,"_POL");
		strcat(filename,".msg");
	}
	else {
		strcpy(filename,"MN0019_SE.msg");
		lang_type=LANGUAGE_ENGLISH;
	}
	if(!ReadMessageFile(filename)) {
		if(lang_type == LANGUAGE_ENGLISH) {
			mprintf(0,"ERROR: Could not load message file - %s\n",filename);
		}
		else if(!ReadMessageFile(english_filename)) {
			mprintf(0,"ERROR: Could not load message file - %s\n",english_filename);
		}
	}
 
	int j;
 
	// Do Door Index lookups
	for(j=0;j<NUM_DOOR_NAMES;j++) 
		Door_handles[j]=Scrpt_FindDoorName(Door_names[j]);
 
	// Do Object Index lookups
	for(j=0;j<NUM_OBJECT_NAMES;j++) 
		Object_handles[j]=Scrpt_FindObjectName(Object_names[j]);
 
	// Do Room Index lookups
	for(j=0;j<NUM_ROOM_NAMES;j++) 
		Room_indexes[j]=Scrpt_FindRoomName(Room_names[j]);
 
	// Do Trigger Index lookups
	for(j=0;j<NUM_TRIGGER_NAMES;j++) {
		Trigger_indexes[j]=Scrpt_FindTriggerName(Trigger_names[j]);
		Trigger_faces[j]=Scrpt_GetTriggerFace(Trigger_indexes[j]);
		Trigger_rooms[j]=Scrpt_GetTriggerRoom(Trigger_indexes[j]);
	}
 
	// Do Sound Index lookups
	for(j=0;j<NUM_SOUND_NAMES;j++) 
		Sound_indexes[j]=Scrpt_FindSoundName(Sound_names[j]);
 
	// Do Texture Index lookups
	for(j=0;j<NUM_TEXTURE_NAMES;j++) 
		Texture_indexes[j]=Scrpt_FindTextureName(Texture_names[j]);
 
	// Do Path Index lookups
	for(j=0;j<NUM_PATH_NAMES;j++) 
		Path_indexes[j]=Scrpt_FindPathName(Path_names[j]);
 
	// Do Matcen Index lookups
	for(j=0;j<NUM_MATCEN_NAMES;j++) 
		Matcen_indexes[j]=Scrpt_FindMatcenName(Matcen_names[j]);
 
	// Do Goal Index lookups
	for(j=0;j<NUM_GOAL_NAMES;j++) 
		Goal_indexes[j]=Scrpt_FindLevelGoalName(Goal_names[j]);
 
	// Do Message Name lookups
	for(j=0;j<NUM_MESSAGE_NAMES;j++) 
		Message_strings[j]=GetMessage(Message_names[j]);
 
	return 1;
}

// =============
// ShutdownDLL()
// =============
void STDCALL ShutdownDLL(void)
{
	ClearMessageList();
}

// ===============
// GetGOScriptID()
// ===============
int STDCALL GetGOScriptID(char *name,ubyte isdoor)
{
	return -1;
}

// ================
// CreateInstance()
// ================
void STDCALLPTR CreateInstance(int id)
{
	switch(id) {
		case ID_LEVEL_0000:
			return new LevelScript_0000;
			break;
		case ID_CUSTOM_OBJECT_09FF:
			return new CustomObjectScript_09FF;
			break;
		case ID_CUSTOM_OBJECT_1804:
			return new CustomObjectScript_1804;
			break;
		case ID_CUSTOM_OBJECT_0806:
			return new CustomObjectScript_0806;
			break;
		case ID_CUSTOM_OBJECT_09FE:
			return new CustomObjectScript_09FE;
			break;
		case ID_CUSTOM_OBJECT_206E:
			return new CustomObjectScript_206E;
			break;
		case ID_CUSTOM_OBJECT_1159:
			return new CustomObjectScript_1159;
			break;
		case ID_CUSTOM_OBJECT_08F8:
			return new CustomObjectScript_08F8;
			break;
		case ID_CUSTOM_OBJECT_1160:
			return new CustomObjectScript_1160;
			break;
		case ID_CUSTOM_OBJECT_0A22:
			return new CustomObjectScript_0A22;
			break;
		case ID_CUSTOM_OBJECT_0943:
			return new CustomObjectScript_0943;
			break;
		case ID_CUSTOM_OBJECT_0947:
			return new CustomObjectScript_0947;
			break;
		case ID_CUSTOM_OBJECT_2011:
			return new CustomObjectScript_2011;
			break;
		case ID_CUSTOM_OBJECT_1814:
			return new CustomObjectScript_1814;
			break;
		case ID_TRIGGER_0000:
			return new TriggerScript_0000;
			break;
		case ID_TRIGGER_0001:
			return new TriggerScript_0001;
			break;
		default:
			mprintf(0,"SCRIPT: Illegal ID (%d)\n",id);
			break;
	}
	return NULL;
}

// =================
// DestroyInstance()
// =================
void STDCALL DestroyInstance(int id,void *ptr)
{
	switch(id) {
		case ID_LEVEL_0000:
			delete ((LevelScript_0000 *)ptr);
		case ID_CUSTOM_OBJECT_09FF:
			delete ((CustomObjectScript_09FF *)ptr);
			break;
		case ID_CUSTOM_OBJECT_1804:
			delete ((CustomObjectScript_1804 *)ptr);
			break;
		case ID_CUSTOM_OBJECT_0806:
			delete ((CustomObjectScript_0806 *)ptr);
			break;
		case ID_CUSTOM_OBJECT_09FE:
			delete ((CustomObjectScript_09FE *)ptr);
			break;
		case ID_CUSTOM_OBJECT_206E:
			delete ((CustomObjectScript_206E *)ptr);
			break;
		case ID_CUSTOM_OBJECT_1159:
			delete ((CustomObjectScript_1159 *)ptr);
			break;
		case ID_CUSTOM_OBJECT_08F8:
			delete ((CustomObjectScript_08F8 *)ptr);
			break;
		case ID_CUSTOM_OBJECT_1160:
			delete ((CustomObjectScript_1160 *)ptr);
			break;
		case ID_CUSTOM_OBJECT_0A22:
			delete ((CustomObjectScript_0A22 *)ptr);
			break;
		case ID_CUSTOM_OBJECT_0943:
			delete ((CustomObjectScript_0943 *)ptr);
			break;
		case ID_CUSTOM_OBJECT_0947:
			delete ((CustomObjectScript_0947 *)ptr);
			break;
		case ID_CUSTOM_OBJECT_2011:
			delete ((CustomObjectScript_2011 *)ptr);
			break;
		case ID_CUSTOM_OBJECT_1814:
			delete ((CustomObjectScript_1814 *)ptr);
			break;
		case ID_TRIGGER_0000:
			delete ((TriggerScript_0000 *)ptr);
			break;
		case ID_TRIGGER_0001:
			delete ((TriggerScript_0001 *)ptr);
			break;
		default:
			mprintf(0,"SCRIPT: Illegal ID (%d)\n",id);
			break;
	}
}

// ===================
// CallInstanceEvent()
// ===================
short STDCALL CallInstanceEvent(int id,void *ptr,int event,tOSIRISEventInfo *data)
{
	switch(id) {
		case ID_LEVEL_0000:
		case ID_CUSTOM_OBJECT_09FF:
		case ID_CUSTOM_OBJECT_1804:
		case ID_CUSTOM_OBJECT_0806:
		case ID_CUSTOM_OBJECT_09FE:
		case ID_CUSTOM_OBJECT_206E:
		case ID_CUSTOM_OBJECT_1159:
		case ID_CUSTOM_OBJECT_08F8:
		case ID_CUSTOM_OBJECT_1160:
		case ID_CUSTOM_OBJECT_0A22:
		case ID_CUSTOM_OBJECT_0943:
		case ID_CUSTOM_OBJECT_0947:
		case ID_CUSTOM_OBJECT_2011:
		case ID_CUSTOM_OBJECT_1814:
		case ID_TRIGGER_0000:
		case ID_TRIGGER_0001:
			return ((BaseScript *)ptr)->CallEvent(event,data);
			break;
		default:
			mprintf(0,"SCRIPT: Illegal ID (%d)\n",id);
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

// ==================
// SaveRestoreState()
// ==================
int STDCALL SaveRestoreState( void *file_ptr, ubyte saving_state )
{
	return 0;
}

// ====================
// GetTriggerScriptID()
// ====================
int	STDCALL GetTriggerScriptID(int trigger_room,int trigger_face)
{
	if(trigger_room==Trigger_rooms[0] && trigger_face==Trigger_faces[0])
		return ID_TRIGGER_0000;
 
	if(trigger_room==Trigger_rooms[1] && trigger_face==Trigger_faces[1])
		return ID_TRIGGER_0001;
 
	return -1;
}

// =================
// GetCOScriptList()
// =================
int	STDCALL GetCOScriptList( int **list, int **id_list )
{
	static int cust_handle_list[13];
	static int cust_id_list[13] = { 
		ID_CUSTOM_OBJECT_09FF,
		ID_CUSTOM_OBJECT_1804,
		ID_CUSTOM_OBJECT_0806,
		ID_CUSTOM_OBJECT_09FE,
		ID_CUSTOM_OBJECT_206E,
		ID_CUSTOM_OBJECT_1159,
		ID_CUSTOM_OBJECT_08F8,
		ID_CUSTOM_OBJECT_1160,
		ID_CUSTOM_OBJECT_0A22,
		ID_CUSTOM_OBJECT_0943,
		ID_CUSTOM_OBJECT_0947,
		ID_CUSTOM_OBJECT_2011,
		ID_CUSTOM_OBJECT_1814
	};
 
	// Fill in the custom handle list
	cust_handle_list[0]=Object_handles[25];
	cust_handle_list[1]=Object_handles[24];
	cust_handle_list[2]=Object_handles[26];
	cust_handle_list[3]=Object_handles[27];
	cust_handle_list[4]=Object_handles[28];
	cust_handle_list[5]=Object_handles[29];
	cust_handle_list[6]=Object_handles[30];
	cust_handle_list[7]=Object_handles[31];
	cust_handle_list[8]=Object_handles[32];
	cust_handle_list[9]=Object_handles[10];
	cust_handle_list[10]=Object_handles[11];
	cust_handle_list[11]=Object_handles[23];
	cust_handle_list[12]=Object_handles[0];

	*list = cust_handle_list;
	*id_list = cust_id_list;

	return 13;
}

//=======================
// Script Implementation 
//=======================

BaseScript::BaseScript()
{
}

BaseScript::~BaseScript()
{
}

short BaseScript::CallEvent(int event,tOSIRISEventInfo *data)
{
	mprintf(0,"BaseScript::CallEvent()\n");
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short LevelScript_0000::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_SAVESTATE:
			{
				tOSIRISEVTSAVESTATE *event_data=&data->evt_savestate;
	
				SaveGlobalActionCtrs(event_data->fileptr);
				dfSave(event_data->fileptr);
#ifdef ENABLE_CUSTOM_SAVE_AND_RESTORE
				dsCustomSave(event_data->fileptr);
#endif
			}
			break;
		case EVT_RESTORESTATE:
			{
				tOSIRISEVTRESTORESTATE *event_data=&data->evt_restorestate;
	
				RestoreGlobalActionCtrs(event_data->fileptr);
				dfRestore(event_data->fileptr);
#ifdef ENABLE_CUSTOM_SAVE_AND_RESTORE
				dsCustomRestore(event_data->fileptr);
#endif
			}
			break;
		case EVT_INTERVAL:
			{
				tOSIRISEVTINTERVAL *event_data=&data->evt_interval;
 
				// Script 001: [Reactor] Countdown
				if((ScriptActionCtr_001 < 1) && (qObjShields(Object_handles[23])<=2500.000000f))
				{
					aSoundPlaySteamingText("VOXSelfDestruct.osf", 0.500000f);
					aMiscViewerShake(qRandomValue(50.000000f, 100.000000f));
					aObjSetShields(Object_handles[23], 7500.000000f);
					aObjMakeInvuln(Object_handles[23], 85);
					aObjSpark(Object_handles[23], 100.000000f, 85.000000f);
					aSetObjectOnFire(Object_handles[23], 85.000000f, 0.000000f);
					aShowColoredHUDMessage(255, 0, 0, Message_strings[9]);
					aRoomSetFog(Room_indexes[4], 0.000000f, 1.000000f, 0.000000f, 1500.000000f);
					aDoorActivate(Door_handles[2]);
					aSetLevelTimer(qRandomValue(77.000000f, 90.000000f), 0);
					aTimerShow(0);
					aRoomSetFuelcen(0, Room_indexes[5]);
					aGoalCompleted(Goal_indexes[0], 1);
					aGoalEnableDisable(1, Goal_indexes[1]);
					
					// Increment the script action counter
					if(ScriptActionCtr_001 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_001++;
				}
 
				// Script 016: [Reactor] End Level 1
				if((ScriptActionCtr_016 < 1) && ((qUserFlag(3)==1) && (qObjOnTerrain(qPlayerClosest(Object_handles[24], 1))==1)))
				{
					aGoalCompleted(Goal_indexes[1], 1);
					aEndLevel();
					
					// Increment the script action counter
					if(ScriptActionCtr_016 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_016++;
				}
 
				// Script 021: [Mercury Boss] Death Sequence
				if((ScriptActionCtr_021 < 1) && (qObjShields(Object_handles[0])<=7500.000000f))
				{
					aMatcenSetEnableState(0, Matcen_indexes[0]);
					aMatcenSetState(0, Matcen_indexes[0]);
					aSoundStopObj(Object_handles[0]);
					aSoundPlayObject(Sound_indexes[3], Object_handles[0], 1.000000f);
					aObjFireWeapon("ImpactMortarExplosion", -1, Object_handles[0]);
					aObjFireWeapon("ImpactMortarExplosion", -1, Object_handles[0]);
					aObjFireWeapon("ImpactMortarExplosion", -1, Object_handles[0]);
					aObjFireWeapon("ImpactMortarExplosion", -1, Object_handles[0]);
					aObjFireWeapon("ImpactMortarExplosion", -1, Object_handles[0]);
					aObjKill(Object_handles[0], 1, 2, 3896060, 3.000000f, 3.000000f);
					aUserFlagSet(0, 1);
					
					// Increment the script action counter
					if(ScriptActionCtr_021 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_021++;
				}
			}
			break;
		case EVT_LEVELSTART:
			{
				tOSIRISEVTLEVELSTART *event_data=&data->evt_levelstart;
 
				ClearGlobalActionCtrs();
				dfInit();
 
				// Script 005: [Level Start] All Variables Initiated
				if(1)
				{
					aSetObjectTimer(Object_handles[0], qRandomValue(7.500000f, 10.000000f), 2);
					aSetLevelTimer(qRandomValue(1.000000f, 2.000000f), 1);
					aAIFlags(1, 196608, Object_handles[1]);
					aAIFlags(1, 196608, Object_handles[2]);
					aAIFlags(1, 196608, Object_handles[3]);
					aAIFlags(1, 196608, Object_handles[4]);
					aAIFlags(1, 196608, Object_handles[5]);
					aAIFlags(1, 196608, Object_handles[6]);
					aAIFlags(1, 196608, Object_handles[7]);
					aAIFlags(1, 196608, Object_handles[8]);
					aAIFlags(1, 196608, Object_handles[9]);
					aCloakObject(Object_handles[0], 99999.000000f);
					aMatcenSetState(1, Matcen_indexes[0]);
					aObjGhostSet(0, Object_handles[10]);
					aObjGhostSet(0, Object_handles[11]);
					aObjGhostSet(1, Object_handles[12]);
					aObjGhostSet(1, Object_handles[13]);
					aObjGhostSet(1, Object_handles[14]);
					aObjGhostSet(1, Object_handles[15]);
					aObjGhostSet(1, Object_handles[16]);
					aObjGhostSet(1, Object_handles[17]);
					aObjGhostSet(1, Object_handles[18]);
					aObjGhostSet(1, Object_handles[19]);
					aObjGhostSet(1, Object_handles[20]);
					aObjGhostSet(1, Object_handles[21]);
					aDoorLockUnlock(1, Door_handles[0]);
					aDoorLockUnlock(1, Door_handles[1]);
					aDoorLockUnlock(1, Door_handles[2]);
					aObjSetShields(Object_handles[22], 225.000000f);
					aObjMakeVulnerable(Object_handles[22]);
					aUserFlagSet(2, 0);
					aUserFlagSet(3, 0);
					aUserFlagSet(0, 0);
					aUserFlagSet(1, 0);
					aObjSetShields(Object_handles[0], 17500.000000f);
					aObjSetShields(Object_handles[23], 7500.000000f);
					
					// Increment the script action counter
					if(ScriptActionCtr_005 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_005++;
				}
 
				// Script 010: [Level Start] Introduction Camera
				if((ScriptActionCtr_010 < 1) && (1==true))
				{
					aCinematicIntro(Path_indexes[0], Message_strings[0], Object_handles[24], Path_indexes[1], 15.000000f);
					
					// Increment the script action counter
					if(ScriptActionCtr_010 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_010++;
				}
			}
			break;
		case EVT_TIMER:
			{
				tOSIRISEVTTIMER *event_data=&data->evt_timer;
 
				// Script 032: [Cloaking Device] Starkiller's Structuring
				if(event_data->id==5)
				{
					if(qUserFlag(2)==1)
					{
						if(qObjEnergy(qObjSavedHandle(0))>=1.000000f)
						{
							if(qUserFlag(4)==0)
							{
								aUserFlagSet(4, 1);
								aCloakObject(qObjSavedHandle(0), 10000.000000f);
							}
							aObjSetEnergy(qObjSavedHandle(0), qMathSubFloat(qObjEnergy(qObjSavedHandle(0)), 0.200000f));
							aSetLevelTimer(0.100000f, 5);
						}
						else {
							aShowHUDMessageObj(Message_strings[2], qObjSavedHandle(0));
							aUnCloakObject(qObjSavedHandle(0));
							aUserFlagSet(4, 0);
						}
					}
					else {
						aUnCloakObject(qObjSavedHandle(0));
						aUserFlagSet(4, 0);
					}
					
					// Increment the script action counter
					if(ScriptActionCtr_032 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_032++;
				}
 
				// Script 022: [Key] Level 2 Unghosted
				if(event_data->id==1)
				{
					aObjGhostSet(0, Object_handles[10]);
					
					// Increment the script action counter
					if(ScriptActionCtr_022 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_022++;
				}
 
				// Script 015: [Reactor] Self-Destruct
				if(event_data->id==0)
				{
					aSoundPlaySteamingText("VoxMN0019Supernova.osf", 1.000000f);
					aObjDestroy(Object_handles[23]);
					aUserFlagSet(3, 1);
					aSetLevelTimer(8.000000f, 3);
					aFadeWhiteAndEndlevel(10.000000f, Message_strings[10]);
					
					// Increment the script action counter
					if(ScriptActionCtr_015 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_015++;
				}
 
				// Script 017: [Reactor] End Level 2
				if((event_data->id==3) && (qUserFlag(3)==1))
				{
					aGoalFailed(Goal_indexes[1], 1);
					aFailLevel();
					
					// Increment the script action counter
					if(ScriptActionCtr_017 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_017++;
				}
			}
			break;
		case EVT_PLAYER_DIES:
			{
				tOSIRISEVTPLAYERDIES *event_data=&data->evt_player_dies;
 
				// Script 031: [Cloaking Device] Terminate Cloak
				if(qHasObjectInInventory(event_data->it_handle, Object_handles[25])==1)
				{
					aUserFlagSet(2, 0);
					
					// Increment the script action counter
					if(ScriptActionCtr_031 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_031++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_09FF::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 029: [Cloaking Device] Collided With
				if(qObjIsPlayer(event_data->it_handle)==1)
				{
					aAddObjectToInventoryNamed(data->me_handle, event_data->it_handle, Message_strings[1], 1);
					aSoundPlay2DObj(Sound_indexes[0], event_data->it_handle, 1.000000f);
					aShowHUDMessageObj(Message_strings[1], event_data->it_handle);
					
					// Increment the script action counter
					if(ScriptActionCtr_029 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_029++;
				}
			}
			break;
		case EVT_INTERVAL:
			{
				tOSIRISEVTINTERVAL *event_data=&data->evt_interval;
 
				// Script 027: [Level Start] Starkiller's (c) Cloaking Device
				if((ScriptActionCtr_027 < 1) && (qObjType(qPlayerClosest(data->me_handle, 1))==4))
				{
					aAddObjectToInventoryNamed(data->me_handle, qPlayerClosest(data->me_handle, 1), Message_strings[1], 1);
					
					// Increment the script action counter
					if(ScriptActionCtr_027 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_027++;
				}
			}
			break;
		case EVT_USE:
			{
				tOSIRISEVTUSE *event_data=&data->evt_use;
 
				// Script 030: [Cloaking Device] Used By Player
				if(1)
				{
					aAddObjectToInventoryNamed(data->me_handle, event_data->it_handle, Message_strings[1], 1);
					aObjSaveHandle(event_data->it_handle, 0);
					aSetLevelTimer(0.100000f, 5);
					if(qUserFlag(2)==1)
					{
						aUserFlagSet(2, 0);
					}
					else {
						aUserFlagSet(2, 1);
					}
					
					// Increment the script action counter
					if(ScriptActionCtr_030 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_030++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_1804::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_DOOR_CLOSE:
			{
				tOSIRISEVTDOORCLOSE *event_data=&data->evt_door_close;
 
				// Script 011: [Door] Airlock 1 Closed
				if(1)
				{
					aRoomSetWind(Room_indexes[0], -1.000000f, 0.000000f, 0.000000f, 0.000000f);
					aRoomSetWind(Room_indexes[1], -1.000000f, 0.000000f, 0.000000f, 0.000000f);
					aRoomSetWind(Room_indexes[2], -1.000000f, 0.000000f, 0.000000f, 0.000000f);
					aRoomSetWind(Room_indexes[3], -1.000000f, 0.000000f, 0.000000f, 0.000000f);
					aTurnOnSpew(Object_handles[12], 0, 7, 0.000000f, 0.000000f, 65536, 0, 2.000000f, 0.100000f, 5.000000f, 5.000000f, 10.000000f, 1, 0);
					aTurnOnSpew(Object_handles[13], 0, 7, 0.000000f, 0.000000f, 65536, 0, 2.000000f, 0.100000f, 5.000000f, 5.000000f, 10.000000f, 1, 0);
					aTurnOnSpew(Object_handles[14], 0, 7, 0.000000f, 0.000000f, 65536, 0, 2.000000f, 0.100000f, 5.000000f, 5.000000f, 10.000000f, 1, 0);
					aTurnOnSpew(Object_handles[15], 0, 7, 0.000000f, 0.000000f, 65536, 0, 2.000000f, 0.100000f, 5.000000f, 5.000000f, 10.000000f, 1, 0);
					aTurnOnSpew(Object_handles[16], 0, 7, 0.000000f, 0.000000f, 65536, 0, 2.000000f, 0.100000f, 5.000000f, 5.000000f, 10.000000f, 1, 0);
					aTurnOnSpew(Object_handles[17], 0, 7, 0.000000f, 0.000000f, 65536, 0, 2.000000f, 0.100000f, 5.000000f, 5.000000f, 10.000000f, 1, 0);
					aDoorLockUnlock(0, Door_handles[3]);
					
					// Increment the script action counter
					if(ScriptActionCtr_011 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_011++;
				}
			}
			break;
		case EVT_DOOR_ACTIVATE:
			{
				tOSIRISEVTDOORACTIVATE *event_data=&data->evt_door_activate;
 
				// Script 009: [Door] Airlock 1 Opened
				if(1)
				{
					aRoomSetWind(Room_indexes[0], -1.000000f, 0.000000f, 0.000000f, 4.000000f);
					aRoomSetWind(Room_indexes[1], -1.000000f, 0.000000f, 0.000000f, 4.000000f);
					aRoomSetWind(Room_indexes[2], -1.000000f, 0.000000f, 0.000000f, 4.000000f);
					aRoomSetWind(Room_indexes[3], -1.000000f, 0.000000f, 0.000000f, 4.000000f);
					aDoorLockUnlock(1, Door_handles[3]);
					
					// Increment the script action counter
					if(ScriptActionCtr_009 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_009++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_0806::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_DOOR_CLOSE:
			{
				tOSIRISEVTDOORCLOSE *event_data=&data->evt_door_close;
 
				// Script 004: [Door] Airlock 2 Closed
				if(1)
				{
					aDoorLockUnlock(0, Door_handles[4]);
					
					// Increment the script action counter
					if(ScriptActionCtr_004 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_004++;
				}
			}
			break;
		case EVT_DOOR_ACTIVATE:
			{
				tOSIRISEVTDOORACTIVATE *event_data=&data->evt_door_activate;
 
				// Script 003: [Door] Airlock 2 Opened
				if(1)
				{
					aDoorLockUnlock(1, Door_handles[4]);
					
					// Increment the script action counter
					if(ScriptActionCtr_003 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_003++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_09FE::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 026: [Switch] Door - L1 Back Access
				if(qObjIsPlayerOrPlayerWeapon(event_data->it_handle)==1)
				{
					if(qUserFlag(1)==0)
					{
						if((qObjAnimFrame(data->me_handle)==0.000000f) || (qObjAnimFrame(data->me_handle)==2.000000f))
						{
							aDoorLockUnlock(0, Door_handles[1]);
							aSoundPlayObject(Sound_indexes[1], data->me_handle, 1.000000f);
							aObjPlayAnim(data->me_handle, 0, 1, 1.000000f, 0);
							aUserFlagSet(1, 1);
							aSetObjectTimer(data->me_handle, 2.000000f, 4);
							aShowHUDMessageObj(Message_strings[3], event_data->it_handle);
						}
						if(qObjAnimFrame(data->me_handle)==1.000000f)
						{
							aDoorLockUnlock(1, Door_handles[1]);
							aSoundPlayObject(Sound_indexes[1], data->me_handle, 1.000000f);
							aObjPlayAnim(data->me_handle, 1, 2, 1.000000f, 0);
							aUserFlagSet(1, 1);
							aSetObjectTimer(data->me_handle, 2.000000f, 4);
							aShowHUDMessageObj(Message_strings[4], event_data->it_handle);
						}
					}
					
					// Increment the script action counter
					if(ScriptActionCtr_026 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_026++;
				}
			}
			break;
		case EVT_TIMER:
			{
				tOSIRISEVTTIMER *event_data=&data->evt_timer;
 
				// Script 028: [Switch] Door - Back Access Timer
				if(event_data->id==4)
				{
					aUserFlagSet(1, 0);
					
					// Increment the script action counter
					if(ScriptActionCtr_028 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_028++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_206E::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 007: [Crate] BS Container 1
				if((ScriptActionCtr_007 < 1) && (qObjIsType(event_data->it_handle, 11)==1))
				{
					aObjDestroy(data->me_handle);
					aObjDestroy(event_data->it_handle);
					
					// Increment the script action counter
					if(ScriptActionCtr_007 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_007++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_1159::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 008: [Crate] Mega Container 1
				if((ScriptActionCtr_008 < 1) && (qObjIsType(event_data->it_handle, 11)==1))
				{
					aObjDestroy(data->me_handle);
					aObjDestroy(event_data->it_handle);
					
					// Increment the script action counter
					if(ScriptActionCtr_008 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_008++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_08F8::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 023: [Crate] EMD Container 1
				if((ScriptActionCtr_023 < 1) && (qObjIsType(event_data->it_handle, 11)==1))
				{
					aObjDestroy(data->me_handle);
					aObjDestroy(event_data->it_handle);
					
					// Increment the script action counter
					if(ScriptActionCtr_023 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_023++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_1160::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 024: [Crate] 4packs Container 1
				if((ScriptActionCtr_024 < 1) && (qObjIsType(event_data->it_handle, 11)==1))
				{
					aObjDestroy(data->me_handle);
					aObjDestroy(event_data->it_handle);
					
					// Increment the script action counter
					if(ScriptActionCtr_024 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_024++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_0A22::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 034: [Mystery Death]
				if(qObjIsPlayer(event_data->it_handle)==true)
				{
					aSoundPlayObject(Sound_indexes[0], Object_handles[32], 1.000000f);
					aAddObjectToInventoryNamed(data->me_handle, event_data->it_handle, Message_strings[5], 1);
					aObjApplyDamage(event_data->it_handle, 200.000000f);
					
					// Increment the script action counter
					if(ScriptActionCtr_034 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_034++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_0943::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 012: [Key] Level 2
				if(qObjIsPlayer(event_data->it_handle)==1)
				{
					aObjectPlayerGiveKey(event_data->it_handle, data->me_handle, 1, Message_strings[6], 1);
					
					// Increment the script action counter
					if(ScriptActionCtr_012 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_012++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_0947::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 019: [Key] Reactor
				if(qObjIsPlayer(event_data->it_handle)==1)
				{
					aObjectPlayerGiveKey(event_data->it_handle, data->me_handle, 2, Message_strings[7], 1);
					
					// Increment the script action counter
					if(ScriptActionCtr_019 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_019++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_2011::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 002: [Reactor] Invulnerability
				if((qObjIsPlayerWeapon(event_data->it_handle)==1) && (qUserFlag(0)==0))
				{
					aObjSetShields(data->me_handle, 5000.000000f);
					if(ScriptActionCtr_002==25)
					{
						aShowHUDMessage(Message_strings[8]);
					}
					
					// Increment the script action counter
					if(ScriptActionCtr_002 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_002++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_1814::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_TIMER:
			{
				tOSIRISEVTTIMER *event_data=&data->evt_timer;
 
				// Script 006: [Mercury Boss] Warping Property
				if((event_data->id==2) && (qUserFlag(0)==0))
				{
					aSetObjectTimer(data->me_handle, qRandomValue(7.500000f, 10.000000f), 2);
					if(qRandomChance(0.250000f)==1)
					{
						aStoreObjectInPositionClipboard(Object_handles[18]);
						aSoundPlayObject(Sound_indexes[2], data->me_handle, 1.000000f);
						aMoveObjectToPositionClipboard(data->me_handle);
						aObjFireWeapon("ImpactMortarExplosion", -1, data->me_handle);
					}
					else {
						if(qRandomChance(0.330000f)==1)
						{
							aStoreObjectInPositionClipboard(Object_handles[19]);
							aSoundPlayObject(Sound_indexes[2], data->me_handle, 1.000000f);
							aMoveObjectToPositionClipboard(data->me_handle);
							aObjFireWeapon("ImpactMortarExplosion", -1, data->me_handle);
						}
						else {
							if(qRandomChance(0.500000f)==1)
							{
								aStoreObjectInPositionClipboard(Object_handles[20]);
								aSoundPlayObject(Sound_indexes[2], data->me_handle, 1.000000f);
								aMoveObjectToPositionClipboard(data->me_handle);
								aObjFireWeapon("ImpactMortarExplosion", -1, data->me_handle);
							}
							else {
								aStoreObjectInPositionClipboard(Object_handles[21]);
								aSoundPlayObject(Sound_indexes[2], data->me_handle, 1.000000f);
								aMoveObjectToPositionClipboard(data->me_handle);
								aObjFireWeapon("ImpactMortarExplosion", -1, data->me_handle);
							}
						}
					}
					
					// Increment the script action counter
					if(ScriptActionCtr_006 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_006++;
				}
			}
			break;
		case EVT_AIN_SEEPLAYER:
			{
				tOSIRISEVTAINOTIFY *event_data=&data->evt_ain_seeplayer;
 
				// Script 025: [Mercury Boss] See Player
				if((ScriptActionCtr_025 < 1) && (qObjIsPlayer(event_data->it_handle)==1))
				{
					aShowColoredHUDMessage(255, 0, 0, Message_strings[11]);
					
					// Increment the script action counter
					if(ScriptActionCtr_025 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_025++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short TriggerScript_0000::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 000: [Vacuum] Main
				if(qObjType(event_data->it_handle)==2)
				{
					aObjKill(event_data->it_handle, 1, 0, 25160, 5.000000f, 10.000000f);
					
					// Increment the script action counter
					if(ScriptActionCtr_000 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_000++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short TriggerScript_0001::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 033: [Vacuum] Back
				if(qObjType(event_data->it_handle)==2)
				{
					aObjKill(event_data->it_handle, 1, 0, 25160, 5.000000f, 10.000000f);
					
					// Increment the script action counter
					if(ScriptActionCtr_033 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_033++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

 
 
/*********************************************************
Script Save Block: DO NOT TOUCH ANYTHING IN THIS BLOCK!!! 
**********************************************************
$$SCRIPT_BLOCK_START
 
VERSION		3
NEXT_ID		63
 
// UserType value blocks
$$UTYPE_VALS_START UserVar
1:Useless
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START UserFlag
0:Is_Mercury_Boss_Dead
1:Is_SwitchL1BA_Deactivated
2:Cloaked_Flag_1
3:Is_Reactor_Nuking
4:Cloaked_Flag_2
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START SpewHandle
0:Oxygen
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START TimerID
0:Reactor_Countdown
1:Key_Hidden
2:Mercury_Warp_Timer
3:Reactor_Nuke
4:Switch_L1BA
5:Cloak_Energy_Drain
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START SavedObjectSlot
0:Cloaked_Handle
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START GoalID
0:GOAL_ID
$$UTYPE_VALS_END
 
 
// Name Lists
$$DOOR_LIST_START
Door - Bay
Door - Level 1 BA
Exit Door
Airlock Door 2
Airlock Door 1
$$DOOR_LIST_END
 
$$OBJECT_LIST_START
Mercury Core Boss
Entrance Turret
Swatter_1
Turret_1
Turret_2
Lance_1
Lance_2
Flak_1
Flak_2
Flak_3
Level 1 Key
Reactor Key
Air 1
Air 2
Air 3
Air 4
Air 5
Air 6
Warp_1
Warp_2
Warp_3
Warp_4
Door - Bay
Reactor
Airlock Door 1
Cloaking Device
Airlock Door 2
Switch - L1BA
BS Container 1
Mega Container 1
EMD Container 1
4pack Container 1
Mystery Death
$$OBJECT_LIST_END
 
$$ROOM_LIST_START
Tunnel_Entrance
Tunnel_Entrance 2
Airlock 1
Airlock Zone
Reactor Chamber
Relay_1
$$ROOM_LIST_END
 
$$TRIGGER_LIST_START
Vacuum_Main
Vacuum_Back
$$TRIGGER_LIST_END
 
$$SOUND_LIST_START
Powerup pickup
AmbSwitch31
RbtMercuryMatcenSpawn
RbtMercuryDeath
$$SOUND_LIST_END
 
$$TEXTURE_LIST_START
$$TEXTURE_LIST_END
 
$$SPECNAME_LIST_START
VOXSelfDestruct.osf
VoxMN0019Supernova.osf
ImpactMortarExplosion
$$SPECNAME_LIST_END
 
$$PATH_LIST_START
Introduction_Camera
Introduction_Player
$$PATH_LIST_END
 
$$MATCEN_LIST_START
Matcen 1
$$MATCEN_LIST_END
 
$$GOAL_LIST_START
Destroy the Reactor
Escape Alive
$$GOAL_LIST_END
 
$$STRM_AUDIO_LIST_START
$$STRM_AUDIO_LIST_END
 
 
// Script Tree Dump
00:5:[Level Start] All Variables Initiated 
	$$CHILD_BLOCK_START
	01:2:0 
	02:6 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aSetObjectTimer 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			06:qRandomValue:Time 
				$$CHILD_BLOCK_START
				10:6:7.500000:LowerLimit 
				10:6:10.000000:UpperLimit 
				$$CHILD_BLOCK_END
			10:10:0:2:TimerID 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			06:qRandomValue:Time 
				$$CHILD_BLOCK_START
				10:6:1.000000:LowerLimit 
				10:6:2.000000:UpperLimit 
				$$CHILD_BLOCK_END
			10:10:0:1:TimerID 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:1:Set/Clear 
			10:15:196608:AIFlags 
			10:1:0:1:Object 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:1:Set/Clear 
			10:15:196608:AIFlags 
			10:1:0:2:Object 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:1:Set/Clear 
			10:15:196608:AIFlags 
			10:1:0:3:Object 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:1:Set/Clear 
			10:15:196608:AIFlags 
			10:1:0:4:Object 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:1:Set/Clear 
			10:15:196608:AIFlags 
			10:1:0:5:Object 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:1:Set/Clear 
			10:15:196608:AIFlags 
			10:1:0:6:Object 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:1:Set/Clear 
			10:15:196608:AIFlags 
			10:1:0:7:Object 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:1:Set/Clear 
			10:15:196608:AIFlags 
			10:1:0:8:Object 
			$$CHILD_BLOCK_END
		08:aAIFlags 
			$$CHILD_BLOCK_START
			10:10:0:1:Set/Clear 
			10:15:196608:AIFlags 
			10:1:0:9:Object 
			$$CHILD_BLOCK_END
		08:aCloakObject 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:6:99999.000000:Seconds 
			$$CHILD_BLOCK_END
		08:aMatcenSetState 
			$$CHILD_BLOCK_START
			10:10:0:1:Activate/Deactivate 
			10:17:0:0:Matcen 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:0:Ghost/Unghost 
			10:1:0:10:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:0:Ghost/Unghost 
			10:1:0:11:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:12:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:13:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:14:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:15:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:16:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:17:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:18:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:19:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:20:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:21:Object 
			$$CHILD_BLOCK_END
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:1:Lock/Unlock 
			10:0:0:0:DoorName 
			$$CHILD_BLOCK_END
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:1:Lock/Unlock 
			10:0:0:1:DoorName 
			$$CHILD_BLOCK_END
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:1:Lock/Unlock 
			10:0:0:2:DoorName 
			$$CHILD_BLOCK_END
		08:aObjSetShields 
			$$CHILD_BLOCK_START
			10:1:0:22:Object 
			10:6:225.000000:Shields 
			$$CHILD_BLOCK_END
		08:aObjMakeVulnerable 
			$$CHILD_BLOCK_START
			10:1:0:22:Object 
			$$CHILD_BLOCK_END
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:2:UserFlag 
			10:5:0:True/False 
			$$CHILD_BLOCK_END
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:3:UserFlag 
			10:5:0:True/False 
			$$CHILD_BLOCK_END
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:0:UserFlag 
			10:5:0:True/False 
			$$CHILD_BLOCK_END
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:1:UserFlag 
			10:5:0:True/False 
			$$CHILD_BLOCK_END
		08:aObjSetShields 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:6:17500.000000:Shields 
			$$CHILD_BLOCK_END
		08:aObjSetShields 
			$$CHILD_BLOCK_START
			10:1:0:23:Object 
			10:6:7500.000000:Shields 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:10:[Level Start] Introduction Camera 
	$$CHILD_BLOCK_START
	01:2:0 
	02:6 
	03:0 
		$$CHILD_BLOCK_START
		05:1 
			$$CHILD_BLOCK_START
			10:5:1:Literal 
			07:0:6 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aCinematicIntro 
			$$CHILD_BLOCK_START
			10:16:0:CameraPath 
			10:8:Introduction:Text 
			10:1:0:24:TotallyNotUsedTarget 
			10:16:1:PlayerPath 
			10:6:15.000000:Seconds 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:27:[Level Start] Starkiller's (c) Cloaking Device 
	$$CHILD_BLOCK_START
	01:1:25 
	02:5 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjType:ObjectType 
				$$CHILD_BLOCK_START
				06:qPlayerClosest:Object 
					$$CHILD_BLOCK_START
					10:1:2:-1:Object 
					10:10:0:1:UserVar 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			07:1:0 
			10:10:0:4:ObjectType 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aAddObjectToInventoryNamed 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			06:qPlayerClosest:PlayerObject 
				$$CHILD_BLOCK_START
				10:1:2:-1:Object 
				10:10:0:1:UserVar 
				$$CHILD_BLOCK_END
			10:8:Cloaking_Device:ItemName 
			10:5:1:Spewable 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:29:[Cloaking Device] Collided With 
	$$CHILD_BLOCK_START
	01:1:25 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayer:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aAddObjectToInventoryNamed 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			10:1:1:-1:PlayerObject 
			10:8:Cloaking_Device:ItemName 
			10:5:1:Spewable 
			$$CHILD_BLOCK_END
		08:aSoundPlay2DObj 
			$$CHILD_BLOCK_START
			10:12:0:Sound 
			10:1:1:-1:PlayerObject 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		08:aShowHUDMessageObj 
			$$CHILD_BLOCK_START
			10:8:Cloaking_Device:Message 
			10:1:1:-1:PlayerObject 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:30:[Cloaking Device] Used By Player 
	$$CHILD_BLOCK_START
	01:1:25 
	02:25 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aAddObjectToInventoryNamed 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			10:1:1:-1:PlayerObject 
			10:8:Cloaking_Device:ItemName 
			10:5:1:Spewable 
			$$CHILD_BLOCK_END
		08:aObjSaveHandle 
			$$CHILD_BLOCK_START
			10:1:1:-1:Object 
			10:10:0:0:SavedObjectSlot 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:0.100000:Time 
			10:10:0:5:TimerID 
			$$CHILD_BLOCK_END
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserFlag:Bool 
					$$CHILD_BLOCK_START
					10:10:0:2:UserFlag 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:1:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aUserFlagSet 
				$$CHILD_BLOCK_START
				10:10:0:2:UserFlag 
				10:5:0:True/False 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:1 
			$$CHILD_BLOCK_START
			08:aUserFlagSet 
				$$CHILD_BLOCK_START
				10:10:0:2:UserFlag 
				10:5:1:True/False 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:32:[Cloaking Device] Starkiller's Structuring 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:5:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserFlag:Bool 
					$$CHILD_BLOCK_START
					10:10:0:2:UserFlag 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:1:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			03:1 
				$$CHILD_BLOCK_START
				05:2 
					$$CHILD_BLOCK_START
					06:qObjEnergy:Float 
						$$CHILD_BLOCK_START
						06:qObjSavedHandle:Object 
							$$CHILD_BLOCK_START
							10:10:0:0:SavedObjectSlot 
							$$CHILD_BLOCK_END
						$$CHILD_BLOCK_END
					07:1:4 
					10:6:1.000000:Literal 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			04:1:0:0 
				$$CHILD_BLOCK_START
				03:1 
					$$CHILD_BLOCK_START
					05:2 
						$$CHILD_BLOCK_START
						06:qUserFlag:Bool 
							$$CHILD_BLOCK_START
							10:10:0:4:UserFlag 
							$$CHILD_BLOCK_END
						07:1:0 
						10:5:0:Bool 
						$$CHILD_BLOCK_END
					$$CHILD_BLOCK_END
				04:1:0:0 
					$$CHILD_BLOCK_START
					08:aUserFlagSet 
						$$CHILD_BLOCK_START
						10:10:0:4:UserFlag 
						10:5:1:True/False 
						$$CHILD_BLOCK_END
					08:aCloakObject 
						$$CHILD_BLOCK_START
						06:qObjSavedHandle:Object 
							$$CHILD_BLOCK_START
							10:10:0:0:SavedObjectSlot 
							$$CHILD_BLOCK_END
						10:6:10000.000000:Seconds 
						$$CHILD_BLOCK_END
					$$CHILD_BLOCK_END
				08:aObjSetEnergy 
					$$CHILD_BLOCK_START
					06:qObjSavedHandle:Object 
						$$CHILD_BLOCK_START
						10:10:0:0:SavedObjectSlot 
						$$CHILD_BLOCK_END
					06:qMathSubFloat:Energy 
						$$CHILD_BLOCK_START
						06:qObjEnergy:Float1 
							$$CHILD_BLOCK_START
							06:qObjSavedHandle:Object 
								$$CHILD_BLOCK_START
								10:10:0:0:SavedObjectSlot 
								$$CHILD_BLOCK_END
							$$CHILD_BLOCK_END
						10:6:0.200000:Float2 
						$$CHILD_BLOCK_END
					$$CHILD_BLOCK_END
				08:aSetLevelTimer 
					$$CHILD_BLOCK_START
					10:6:0.100000:Time 
					10:10:0:5:TimerID 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			04:1:0:1 
				$$CHILD_BLOCK_START
				08:aShowHUDMessageObj 
					$$CHILD_BLOCK_START
					10:8:Cloaked_No_Energy_Left:Message 
					06:qObjSavedHandle:PlayerObject 
						$$CHILD_BLOCK_START
						10:10:0:0:SavedObjectSlot 
						$$CHILD_BLOCK_END
					$$CHILD_BLOCK_END
				08:aUnCloakObject 
					$$CHILD_BLOCK_START
					06:qObjSavedHandle:Object 
						$$CHILD_BLOCK_START
						10:10:0:0:SavedObjectSlot 
						$$CHILD_BLOCK_END
					$$CHILD_BLOCK_END
				08:aUserFlagSet 
					$$CHILD_BLOCK_START
					10:10:0:4:UserFlag 
					10:5:0:True/False 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:1 
			$$CHILD_BLOCK_START
			08:aUnCloakObject 
				$$CHILD_BLOCK_START
				06:qObjSavedHandle:Object 
					$$CHILD_BLOCK_START
					10:10:0:0:SavedObjectSlot 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			08:aUserFlagSet 
				$$CHILD_BLOCK_START
				10:10:0:4:UserFlag 
				10:5:0:True/False 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:31:[Cloaking Device] Terminate Cloak 
	$$CHILD_BLOCK_START
	01:2:0 
	02:31 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qHasObjectInInventory:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Player 
				10:1:0:25:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:2:UserFlag 
			10:5:0:True/False 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:0:[Vacuum] Main 
	$$CHILD_BLOCK_START
	01:0:0 
	02:1 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjType:ObjectType 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:10:0:2:ObjectType 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aObjKill 
			$$CHILD_BLOCK_START
			10:1:1:-1:Object 
			10:10:0:1:DeathDelayType 
			10:10:0:0:DeathExplosionSize 
			10:15:25160:DeathFlags 
			10:6:5.000000:MinDelay 
			10:6:10.000000:MaxDelay 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:33:[Vacuum] Back 
	$$CHILD_BLOCK_START
	01:0:1 
	02:1 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjType:ObjectType 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:10:0:2:ObjectType 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aObjKill 
			$$CHILD_BLOCK_START
			10:1:1:-1:Object 
			10:10:0:1:DeathDelayType 
			10:10:0:0:DeathExplosionSize 
			10:15:25160:DeathFlags 
			10:6:5.000000:MinDelay 
			10:6:10.000000:MaxDelay 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:9:[Door] Airlock 1 Opened 
	$$CHILD_BLOCK_START
	01:1:24 
	02:20 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aRoomSetWind 
			$$CHILD_BLOCK_START
			10:2:0:Room 
			10:6:-1.000000:X 
			10:6:0.000000:Y 
			10:6:0.000000:Z 
			10:6:4.000000:Speed 
			$$CHILD_BLOCK_END
		08:aRoomSetWind 
			$$CHILD_BLOCK_START
			10:2:1:Room 
			10:6:-1.000000:X 
			10:6:0.000000:Y 
			10:6:0.000000:Z 
			10:6:4.000000:Speed 
			$$CHILD_BLOCK_END
		08:aRoomSetWind 
			$$CHILD_BLOCK_START
			10:2:2:Room 
			10:6:-1.000000:X 
			10:6:0.000000:Y 
			10:6:0.000000:Z 
			10:6:4.000000:Speed 
			$$CHILD_BLOCK_END
		08:aRoomSetWind 
			$$CHILD_BLOCK_START
			10:2:3:Room 
			10:6:-1.000000:X 
			10:6:0.000000:Y 
			10:6:0.000000:Z 
			10:6:4.000000:Speed 
			$$CHILD_BLOCK_END
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:1:Lock/Unlock 
			10:0:0:3:DoorName 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:11:[Door] Airlock 1 Closed 
	$$CHILD_BLOCK_START
	01:1:24 
	02:19 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aRoomSetWind 
			$$CHILD_BLOCK_START
			10:2:0:Room 
			10:6:-1.000000:X 
			10:6:0.000000:Y 
			10:6:0.000000:Z 
			10:6:0.000000:Speed 
			$$CHILD_BLOCK_END
		08:aRoomSetWind 
			$$CHILD_BLOCK_START
			10:2:1:Room 
			10:6:-1.000000:X 
			10:6:0.000000:Y 
			10:6:0.000000:Z 
			10:6:0.000000:Speed 
			$$CHILD_BLOCK_END
		08:aRoomSetWind 
			$$CHILD_BLOCK_START
			10:2:2:Room 
			10:6:-1.000000:X 
			10:6:0.000000:Y 
			10:6:0.000000:Z 
			10:6:0.000000:Speed 
			$$CHILD_BLOCK_END
		08:aRoomSetWind 
			$$CHILD_BLOCK_START
			10:2:3:Room 
			10:6:-1.000000:X 
			10:6:0.000000:Y 
			10:6:0.000000:Z 
			10:6:0.000000:Speed 
			$$CHILD_BLOCK_END
		08:aTurnOnSpew 
			$$CHILD_BLOCK_START
			10:1:0:12:Object 
			10:4:0:GunNum 
			10:10:0:7:SpewType 
			10:6:0.000000:Mass 
			10:6:0.000000:Drag 
			10:15:65536:PhysicsFlags 
			10:5:0:IsRealObject 
			10:6:2.000000:BlobLifetime 
			10:6:0.100000:BlobInterval 
			10:6:5.000000:SpewLife 
			10:6:5.000000:BlobSize 
			10:6:10.000000:BlobSpeed 
			10:5:1:Randomize 
			10:10:0:0:SpewHandle 
			$$CHILD_BLOCK_END
		08:aTurnOnSpew 
			$$CHILD_BLOCK_START
			10:1:0:13:Object 
			10:4:0:GunNum 
			10:10:0:7:SpewType 
			10:6:0.000000:Mass 
			10:6:0.000000:Drag 
			10:15:65536:PhysicsFlags 
			10:5:0:IsRealObject 
			10:6:2.000000:BlobLifetime 
			10:6:0.100000:BlobInterval 
			10:6:5.000000:SpewLife 
			10:6:5.000000:BlobSize 
			10:6:10.000000:BlobSpeed 
			10:5:1:Randomize 
			10:10:0:0:SpewHandle 
			$$CHILD_BLOCK_END
		08:aTurnOnSpew 
			$$CHILD_BLOCK_START
			10:1:0:14:Object 
			10:4:0:GunNum 
			10:10:0:7:SpewType 
			10:6:0.000000:Mass 
			10:6:0.000000:Drag 
			10:15:65536:PhysicsFlags 
			10:5:0:IsRealObject 
			10:6:2.000000:BlobLifetime 
			10:6:0.100000:BlobInterval 
			10:6:5.000000:SpewLife 
			10:6:5.000000:BlobSize 
			10:6:10.000000:BlobSpeed 
			10:5:1:Randomize 
			10:10:0:0:SpewHandle 
			$$CHILD_BLOCK_END
		08:aTurnOnSpew 
			$$CHILD_BLOCK_START
			10:1:0:15:Object 
			10:4:0:GunNum 
			10:10:0:7:SpewType 
			10:6:0.000000:Mass 
			10:6:0.000000:Drag 
			10:15:65536:PhysicsFlags 
			10:5:0:IsRealObject 
			10:6:2.000000:BlobLifetime 
			10:6:0.100000:BlobInterval 
			10:6:5.000000:SpewLife 
			10:6:5.000000:BlobSize 
			10:6:10.000000:BlobSpeed 
			10:5:1:Randomize 
			10:10:0:0:SpewHandle 
			$$CHILD_BLOCK_END
		08:aTurnOnSpew 
			$$CHILD_BLOCK_START
			10:1:0:16:Object 
			10:4:0:GunNum 
			10:10:0:7:SpewType 
			10:6:0.000000:Mass 
			10:6:0.000000:Drag 
			10:15:65536:PhysicsFlags 
			10:5:0:IsRealObject 
			10:6:2.000000:BlobLifetime 
			10:6:0.100000:BlobInterval 
			10:6:5.000000:SpewLife 
			10:6:5.000000:BlobSize 
			10:6:10.000000:BlobSpeed 
			10:5:1:Randomize 
			10:10:0:0:SpewHandle 
			$$CHILD_BLOCK_END
		08:aTurnOnSpew 
			$$CHILD_BLOCK_START
			10:1:0:17:Object 
			10:4:0:GunNum 
			10:10:0:7:SpewType 
			10:6:0.000000:Mass 
			10:6:0.000000:Drag 
			10:15:65536:PhysicsFlags 
			10:5:0:IsRealObject 
			10:6:2.000000:BlobLifetime 
			10:6:0.100000:BlobInterval 
			10:6:5.000000:SpewLife 
			10:6:5.000000:BlobSize 
			10:6:10.000000:BlobSpeed 
			10:5:1:Randomize 
			10:10:0:0:SpewHandle 
			$$CHILD_BLOCK_END
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:0:Lock/Unlock 
			10:0:0:3:DoorName 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:3:[Door] Airlock 2 Opened 
	$$CHILD_BLOCK_START
	01:1:26 
	02:20 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:1:Lock/Unlock 
			10:0:0:4:DoorName 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:4:[Door] Airlock 2 Closed 
	$$CHILD_BLOCK_START
	01:1:26 
	02:19 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aDoorLockUnlock 
			$$CHILD_BLOCK_START
			10:10:0:0:Lock/Unlock 
			10:0:0:4:DoorName 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:26:[Switch] Door - L1 Back Access 
	$$CHILD_BLOCK_START
	01:1:27 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayerOrPlayerWeapon:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserFlag:Bool 
					$$CHILD_BLOCK_START
					10:10:0:1:UserFlag 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:0:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			03:1 
				$$CHILD_BLOCK_START
				09:1 
					$$CHILD_BLOCK_START
					05:2 
						$$CHILD_BLOCK_START
						06:qObjAnimFrame:Float 
							$$CHILD_BLOCK_START
							10:1:2:-1:Object 
							$$CHILD_BLOCK_END
						07:1:0 
						10:6:0.000000:Literal 
						$$CHILD_BLOCK_END
					05:2 
						$$CHILD_BLOCK_START
						06:qObjAnimFrame:Float 
							$$CHILD_BLOCK_START
							10:1:2:-1:Object 
							$$CHILD_BLOCK_END
						07:1:0 
						10:6:2.000000:Literal 
						$$CHILD_BLOCK_END
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			04:1:0:0 
				$$CHILD_BLOCK_START
				08:aDoorLockUnlock 
					$$CHILD_BLOCK_START
					10:10:0:0:Lock/Unlock 
					10:0:0:1:DoorName 
					$$CHILD_BLOCK_END
				08:aSoundPlayObject 
					$$CHILD_BLOCK_START
					10:12:1:Sound 
					10:1:2:-1:Object 
					10:9:1.000000:Volume 
					$$CHILD_BLOCK_END
				08:aObjPlayAnim 
					$$CHILD_BLOCK_START
					10:1:2:-1:Object 
					10:4:0:StartFrame 
					10:4:1:EndFrame 
					10:6:1.000000:CycleTime 
					10:5:0:Looping 
					$$CHILD_BLOCK_END
				08:aUserFlagSet 
					$$CHILD_BLOCK_START
					10:10:0:1:UserFlag 
					10:5:1:True/False 
					$$CHILD_BLOCK_END
				08:aSetObjectTimer 
					$$CHILD_BLOCK_START
					10:1:2:-1:Object 
					10:6:2.000000:Time 
					10:10:0:4:TimerID 
					$$CHILD_BLOCK_END
				08:aShowHUDMessageObj 
					$$CHILD_BLOCK_START
					10:8:L1BA_1:Message 
					10:1:1:-1:PlayerObject 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			03:1 
				$$CHILD_BLOCK_START
				05:2 
					$$CHILD_BLOCK_START
					06:qObjAnimFrame:Float 
						$$CHILD_BLOCK_START
						10:1:2:-1:Object 
						$$CHILD_BLOCK_END
					07:1:0 
					10:6:1.000000:Literal 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			04:1:0:0 
				$$CHILD_BLOCK_START
				08:aDoorLockUnlock 
					$$CHILD_BLOCK_START
					10:10:0:1:Lock/Unlock 
					10:0:0:1:DoorName 
					$$CHILD_BLOCK_END
				08:aSoundPlayObject 
					$$CHILD_BLOCK_START
					10:12:1:Sound 
					10:1:2:-1:Object 
					10:9:1.000000:Volume 
					$$CHILD_BLOCK_END
				08:aObjPlayAnim 
					$$CHILD_BLOCK_START
					10:1:2:-1:Object 
					10:4:1:StartFrame 
					10:4:2:EndFrame 
					10:6:1.000000:CycleTime 
					10:5:0:Looping 
					$$CHILD_BLOCK_END
				08:aUserFlagSet 
					$$CHILD_BLOCK_START
					10:10:0:1:UserFlag 
					10:5:1:True/False 
					$$CHILD_BLOCK_END
				08:aSetObjectTimer 
					$$CHILD_BLOCK_START
					10:1:2:-1:Object 
					10:6:2.000000:Time 
					10:10:0:4:TimerID 
					$$CHILD_BLOCK_END
				08:aShowHUDMessageObj 
					$$CHILD_BLOCK_START
					10:8:L1BA_2:Message 
					10:1:1:-1:PlayerObject 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:28:[Switch] Door - Back Access Timer 
	$$CHILD_BLOCK_START
	01:1:27 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:4:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:1:UserFlag 
			10:5:0:True/False 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:7:[Crate] BS Container 1 
	$$CHILD_BLOCK_START
	01:1:28 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsType:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				10:10:0:11:ObjectType 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aObjDestroy 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			$$CHILD_BLOCK_END
		08:aObjDestroy 
			$$CHILD_BLOCK_START
			10:1:1:-1:Object 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:8:[Crate] Mega Container 1 
	$$CHILD_BLOCK_START
	01:1:29 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsType:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				10:10:0:11:ObjectType 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aObjDestroy 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			$$CHILD_BLOCK_END
		08:aObjDestroy 
			$$CHILD_BLOCK_START
			10:1:1:-1:Object 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:23:[Crate] EMD Container 1 
	$$CHILD_BLOCK_START
	01:1:30 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsType:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				10:10:0:11:ObjectType 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aObjDestroy 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			$$CHILD_BLOCK_END
		08:aObjDestroy 
			$$CHILD_BLOCK_START
			10:1:1:-1:Object 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:24:[Crate] 4packs Container 1 
	$$CHILD_BLOCK_START
	01:1:31 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsType:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				10:10:0:11:ObjectType 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aObjDestroy 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			$$CHILD_BLOCK_END
		08:aObjDestroy 
			$$CHILD_BLOCK_START
			10:1:1:-1:Object 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:34:[Mystery Death] 
	$$CHILD_BLOCK_START
	01:1:32 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:1 
			$$CHILD_BLOCK_START
			06:qObjIsPlayer:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:0:6 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aSoundPlayObject 
			$$CHILD_BLOCK_START
			10:12:0:Sound 
			10:1:0:32:Object 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		08:aAddObjectToInventoryNamed 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			10:1:1:-1:PlayerObject 
			10:8:Mystery_Death:ItemName 
			10:5:1:Spewable 
			$$CHILD_BLOCK_END
		08:aObjApplyDamage 
			$$CHILD_BLOCK_START
			10:1:1:-1:Object 
			10:6:200.000000:DamageAmount 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:22:[Key] Level 2 Unghosted 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:1:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:0:Ghost/Unghost 
			10:1:0:10:Object 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:12:[Key] Level 2 
	$$CHILD_BLOCK_START
	01:1:10 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayer:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aObjectPlayerGiveKey 
			$$CHILD_BLOCK_START
			10:1:1:-1:PlayerObject 
			10:1:2:-1:KeyObject 
			10:4:1:KeyNum 
			10:8:Key_Level_Two:KeyName 
			10:10:0:1:Yes/No 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:19:[Key] Reactor 
	$$CHILD_BLOCK_START
	01:1:11 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayer:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aObjectPlayerGiveKey 
			$$CHILD_BLOCK_START
			10:1:1:-1:PlayerObject 
			10:1:2:-1:KeyObject 
			10:4:2:KeyNum 
			10:8:Key_Reactor:KeyName 
			10:10:0:1:Yes/No 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:2:[Reactor] Invulnerability 
	$$CHILD_BLOCK_START
	01:1:23 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		09:0 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qObjIsPlayerWeapon:Bool 
					$$CHILD_BLOCK_START
					10:1:1:-1:Object 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:1:Bool 
				$$CHILD_BLOCK_END
			05:2 
				$$CHILD_BLOCK_START
				06:qUserFlag:Bool 
					$$CHILD_BLOCK_START
					10:10:0:0:UserFlag 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:0:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aObjSetShields 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			10:6:5000.000000:Shields 
			$$CHILD_BLOCK_END
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qTimesScriptExecuted_DALLAS:Integer 
					$$CHILD_BLOCK_START
					10:11:2:ScriptID 
					$$CHILD_BLOCK_END
				07:1:0 
				10:4:25:Integer 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aShowHUDMessage 
				$$CHILD_BLOCK_START
				10:8:Reactor_Invulnerability:Message 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:1:[Reactor] Countdown 
	$$CHILD_BLOCK_START
	01:2:0 
	02:5 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjShields:Float 
				$$CHILD_BLOCK_START
				10:1:0:23:Object 
				$$CHILD_BLOCK_END
			07:1:5 
			10:6:2500.000000:Literal 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aSoundPlaySteamingText 
			$$CHILD_BLOCK_START
			10:13:0:SoundName 
			10:9:0.500000:Volume 
			$$CHILD_BLOCK_END
		08:aMiscViewerShake 
			$$CHILD_BLOCK_START
			06:qRandomValue:Amount 
				$$CHILD_BLOCK_START
				10:6:50.000000:LowerLimit 
				10:6:100.000000:UpperLimit 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		08:aObjSetShields 
			$$CHILD_BLOCK_START
			10:1:0:23:Object 
			10:6:7500.000000:Shields 
			$$CHILD_BLOCK_END
		08:aObjMakeInvuln 
			$$CHILD_BLOCK_START
			10:1:0:23:Object 
			10:4:85:Time 
			$$CHILD_BLOCK_END
		08:aObjSpark 
			$$CHILD_BLOCK_START
			10:1:0:23:Object 
			10:6:100.000000:SparkRate 
			10:6:85.000000:Time 
			$$CHILD_BLOCK_END
		08:aSetObjectOnFire 
			$$CHILD_BLOCK_START
			10:1:0:23:Object 
			10:6:85.000000:Seconds 
			10:6:0.000000:Damage 
			$$CHILD_BLOCK_END
		08:aShowColoredHUDMessage 
			$$CHILD_BLOCK_START
			10:4:255:Red 
			10:4:0:Green 
			10:4:0:Blue 
			10:8:GB_Self_Destruct:Message 
			$$CHILD_BLOCK_END
		08:aRoomSetFog 
			$$CHILD_BLOCK_START
			10:2:4:Room 
			10:6:0.000000:Red 
			10:6:1.000000:Green 
			10:6:0.000000:Blue 
			10:6:1500.000000:Depth 
			$$CHILD_BLOCK_END
		08:aDoorActivate 
			$$CHILD_BLOCK_START
			10:0:0:2:Door 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			06:qRandomValue:Time 
				$$CHILD_BLOCK_START
				10:6:77.000000:LowerLimit 
				10:6:90.000000:UpperLimit 
				$$CHILD_BLOCK_END
			10:10:0:0:TimerID 
			$$CHILD_BLOCK_END
		08:aTimerShow 
			$$CHILD_BLOCK_START
			10:10:0:0:TimerID 
			$$CHILD_BLOCK_END
		08:aRoomSetFuelcen 
			$$CHILD_BLOCK_START
			10:10:0:0:On/Off 
			10:2:5:Room 
			$$CHILD_BLOCK_END
		08:aGoalCompleted 
			$$CHILD_BLOCK_START
			10:18:0:0:LevelGoal 
			10:10:0:1:Completed 
			$$CHILD_BLOCK_END
		08:aGoalEnableDisable 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:18:0:1:LevelGoal 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:15:[Reactor] Self-Destruct 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:0:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aSoundPlaySteamingText 
			$$CHILD_BLOCK_START
			10:13:1:SoundName 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		08:aObjDestroy 
			$$CHILD_BLOCK_START
			10:1:0:23:Object 
			$$CHILD_BLOCK_END
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:3:UserFlag 
			10:5:1:True/False 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:8.000000:Time 
			10:10:0:3:TimerID 
			$$CHILD_BLOCK_END
		08:aFadeWhiteAndEndlevel 
			$$CHILD_BLOCK_START
			10:6:10.000000:Time 
			10:8:Empty:Text 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:16:[Reactor] End Level 1 
	$$CHILD_BLOCK_START
	01:2:0 
	02:5 
	03:0 
		$$CHILD_BLOCK_START
		09:0 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qUserFlag:Bool 
					$$CHILD_BLOCK_START
					10:10:0:3:UserFlag 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:1:Bool 
				$$CHILD_BLOCK_END
			05:2 
				$$CHILD_BLOCK_START
				06:qObjOnTerrain:Bool 
					$$CHILD_BLOCK_START
					06:qPlayerClosest:Object 
						$$CHILD_BLOCK_START
						10:1:0:24:Object 
						10:10:0:1:UserVar 
						$$CHILD_BLOCK_END
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:1:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aGoalCompleted 
			$$CHILD_BLOCK_START
			10:18:0:1:LevelGoal 
			10:10:0:1:Completed 
			$$CHILD_BLOCK_END
		08:aEndLevel 
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:17:[Reactor] End Level 2 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		09:0 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				10:10:2:0:TimerID 
				07:1:0 
				10:10:0:3:TimerID 
				$$CHILD_BLOCK_END
			05:2 
				$$CHILD_BLOCK_START
				06:qUserFlag:Bool 
					$$CHILD_BLOCK_START
					10:10:0:3:UserFlag 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:1:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aGoalFailed 
			$$CHILD_BLOCK_START
			10:18:0:1:LevelGoal 
			10:10:0:1:Failed 
			$$CHILD_BLOCK_END
		08:aFailLevel 
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:25:[Mercury Boss] See Player 
	$$CHILD_BLOCK_START
	01:1:0 
	02:11 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayer:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aShowColoredHUDMessage 
			$$CHILD_BLOCK_START
			10:4:255:Red 
			10:4:0:Green 
			10:4:0:Blue 
			10:8:Supervisor_See:Message 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:6:[Mercury Boss] Warping Property 
	$$CHILD_BLOCK_START
	01:1:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		09:0 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				10:10:2:0:TimerID 
				07:1:0 
				10:10:0:2:TimerID 
				$$CHILD_BLOCK_END
			05:2 
				$$CHILD_BLOCK_START
				06:qUserFlag:Bool 
					$$CHILD_BLOCK_START
					10:10:0:0:UserFlag 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:0:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aSetObjectTimer 
			$$CHILD_BLOCK_START
			10:1:2:-1:Object 
			06:qRandomValue:Time 
				$$CHILD_BLOCK_START
				10:6:7.500000:LowerLimit 
				10:6:10.000000:UpperLimit 
				$$CHILD_BLOCK_END
			10:10:0:2:TimerID 
			$$CHILD_BLOCK_END
		03:1 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				06:qRandomChance:Bool 
					$$CHILD_BLOCK_START
					10:9:0.250000:Probability 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:1:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aStoreObjectInPositionClipboard 
				$$CHILD_BLOCK_START
				10:1:0:18:Object 
				$$CHILD_BLOCK_END
			08:aSoundPlayObject 
				$$CHILD_BLOCK_START
				10:12:2:Sound 
				10:1:2:-1:Object 
				10:9:1.000000:Volume 
				$$CHILD_BLOCK_END
			08:aMoveObjectToPositionClipboard 
				$$CHILD_BLOCK_START
				10:1:2:-1:Object 
				$$CHILD_BLOCK_END
			08:aObjFireWeapon 
				$$CHILD_BLOCK_START
				10:13:2:WeaponName 
				10:4:-1:GunNum 
				10:1:2:-1:Object 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		04:1:0:1 
			$$CHILD_BLOCK_START
			03:1 
				$$CHILD_BLOCK_START
				05:2 
					$$CHILD_BLOCK_START
					06:qRandomChance:Bool 
						$$CHILD_BLOCK_START
						10:9:0.330000:Probability 
						$$CHILD_BLOCK_END
					07:1:0 
					10:5:1:Bool 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			04:1:0:0 
				$$CHILD_BLOCK_START
				08:aStoreObjectInPositionClipboard 
					$$CHILD_BLOCK_START
					10:1:0:19:Object 
					$$CHILD_BLOCK_END
				08:aSoundPlayObject 
					$$CHILD_BLOCK_START
					10:12:2:Sound 
					10:1:2:-1:Object 
					10:9:1.000000:Volume 
					$$CHILD_BLOCK_END
				08:aMoveObjectToPositionClipboard 
					$$CHILD_BLOCK_START
					10:1:2:-1:Object 
					$$CHILD_BLOCK_END
				08:aObjFireWeapon 
					$$CHILD_BLOCK_START
					10:13:2:WeaponName 
					10:4:-1:GunNum 
					10:1:2:-1:Object 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			04:1:0:1 
				$$CHILD_BLOCK_START
				03:1 
					$$CHILD_BLOCK_START
					05:2 
						$$CHILD_BLOCK_START
						06:qRandomChance:Bool 
							$$CHILD_BLOCK_START
							10:9:0.500000:Probability 
							$$CHILD_BLOCK_END
						07:1:0 
						10:5:1:Bool 
						$$CHILD_BLOCK_END
					$$CHILD_BLOCK_END
				04:1:0:0 
					$$CHILD_BLOCK_START
					08:aStoreObjectInPositionClipboard 
						$$CHILD_BLOCK_START
						10:1:0:20:Object 
						$$CHILD_BLOCK_END
					08:aSoundPlayObject 
						$$CHILD_BLOCK_START
						10:12:2:Sound 
						10:1:2:-1:Object 
						10:9:1.000000:Volume 
						$$CHILD_BLOCK_END
					08:aMoveObjectToPositionClipboard 
						$$CHILD_BLOCK_START
						10:1:2:-1:Object 
						$$CHILD_BLOCK_END
					08:aObjFireWeapon 
						$$CHILD_BLOCK_START
						10:13:2:WeaponName 
						10:4:-1:GunNum 
						10:1:2:-1:Object 
						$$CHILD_BLOCK_END
					$$CHILD_BLOCK_END
				04:1:0:1 
					$$CHILD_BLOCK_START
					08:aStoreObjectInPositionClipboard 
						$$CHILD_BLOCK_START
						10:1:0:21:Object 
						$$CHILD_BLOCK_END
					08:aSoundPlayObject 
						$$CHILD_BLOCK_START
						10:12:2:Sound 
						10:1:2:-1:Object 
						10:9:1.000000:Volume 
						$$CHILD_BLOCK_END
					08:aMoveObjectToPositionClipboard 
						$$CHILD_BLOCK_START
						10:1:2:-1:Object 
						$$CHILD_BLOCK_END
					08:aObjFireWeapon 
						$$CHILD_BLOCK_START
						10:13:2:WeaponName 
						10:4:-1:GunNum 
						10:1:2:-1:Object 
						$$CHILD_BLOCK_END
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:21:[Mercury Boss] Death Sequence 
	$$CHILD_BLOCK_START
	01:2:0 
	02:5 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjShields:Float 
				$$CHILD_BLOCK_START
				10:1:0:0:Object 
				$$CHILD_BLOCK_END
			07:1:5 
			10:6:7500.000000:Literal 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aMatcenSetEnableState 
			$$CHILD_BLOCK_START
			10:10:0:0:Enable/Disable 
			10:17:0:0:Matcen 
			$$CHILD_BLOCK_END
		08:aMatcenSetState 
			$$CHILD_BLOCK_START
			10:10:0:0:Activate/Deactivate 
			10:17:0:0:Matcen 
			$$CHILD_BLOCK_END
		08:aSoundStopObj 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aSoundPlayObject 
			$$CHILD_BLOCK_START
			10:12:3:Sound 
			10:1:0:0:Object 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		08:aObjFireWeapon 
			$$CHILD_BLOCK_START
			10:13:2:WeaponName 
			10:4:-1:GunNum 
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aObjFireWeapon 
			$$CHILD_BLOCK_START
			10:13:2:WeaponName 
			10:4:-1:GunNum 
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aObjFireWeapon 
			$$CHILD_BLOCK_START
			10:13:2:WeaponName 
			10:4:-1:GunNum 
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aObjFireWeapon 
			$$CHILD_BLOCK_START
			10:13:2:WeaponName 
			10:4:-1:GunNum 
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aObjFireWeapon 
			$$CHILD_BLOCK_START
			10:13:2:WeaponName 
			10:4:-1:GunNum 
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aObjKill 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:10:0:1:DeathDelayType 
			10:10:0:2:DeathExplosionSize 
			10:15:3896060:DeathFlags 
			10:6:3.000000:MinDelay 
			10:6:3.000000:MaxDelay 
			$$CHILD_BLOCK_END
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:0:UserFlag 
			10:5:1:True/False 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
 
$$SCRIPT_BLOCK_END
*********************************************************/
