/////////////////////////////////////////////////////////////////////
// D.A.L.L.A.S. Generated Level Script - DLL Source File
// 
// Filename:	TFZ.cpp
// Version:	3
/////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "osiris_import.h"
#include "osiris_common.h"
#include "dallasfuncs.cpp"

#ifdef _MSC_VER		//Visual C++ Build
#define STDCALL		__stdcall
#define STDCALLPTR	*STDCALL
#else					//Non-Visual C++ Build
#define STDCALL __attribute__((stdcall))
#define STDCALLPTR	STDCALL*
#endif

#ifdef __cplusplus
extern "C"{
#endif
char		STDCALL InitializeDLL(tOSIRISModuleInit *func_list);
void		STDCALL ShutdownDLL(void);
int		STDCALL GetGOScriptID(char *name,ubyte is_door);
void		STDCALLPTR CreateInstance(int id);
void		STDCALL DestroyInstance(int id,void *ptr);
short	STDCALL CallInstanceEvent(int id,void *ptr,int event,tOSIRISEventInfo *data);
int		STDCALL GetTriggerScriptID(int trigger_room, int trigger_face );
int		STDCALL GetCOScriptList( int **list, int **id_list );
int		STDCALL SaveRestoreState( void *file_ptr, ubyte saving_state );
#ifdef __cplusplus
}
#endif

// =================
// Script ID Numbers
// =================
#define ID_LEVEL_0000			0x000

#define ID_CUSTOM_OBJECT_1807		0x001


// ========================
// Script Class Definitions
// ========================

class BaseScript {
public:
	BaseScript();
	~BaseScript();
	virtual short CallEvent(int event, tOSIRISEventInfo *data);
};

class LevelScript_0000 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

class CustomObjectScript_1807 : public BaseScript {
public:
	short CallEvent(int event, tOSIRISEventInfo *data);
};

// ======================
// Global Action Counters
// ======================

#define MAX_ACTION_CTR_VALUE		100000

int ScriptActionCtr_000 = 0;
int ScriptActionCtr_004 = 0;
int ScriptActionCtr_006 = 0;
int ScriptActionCtr_001 = 0;
int ScriptActionCtr_002 = 0;
int ScriptActionCtr_003 = 0;
int ScriptActionCtr_008 = 0;
int ScriptActionCtr_009 = 0;
int ScriptActionCtr_019 = 0;
int ScriptActionCtr_005 = 0;
int ScriptActionCtr_010 = 0;
int ScriptActionCtr_018 = 0;
int ScriptActionCtr_011 = 0;
int ScriptActionCtr_012 = 0;
int ScriptActionCtr_013 = 0;
int ScriptActionCtr_014 = 0;
int ScriptActionCtr_015 = 0;
int ScriptActionCtr_016 = 0;
int ScriptActionCtr_017 = 0;
int ScriptActionCtr_007 = 0;
 
// ========================================
// Function to Clear Global Action Counters
// ========================================
void ClearGlobalActionCtrs(void)
{
	ScriptActionCtr_000 = 0;
	ScriptActionCtr_004 = 0;
	ScriptActionCtr_006 = 0;
	ScriptActionCtr_001 = 0;
	ScriptActionCtr_002 = 0;
	ScriptActionCtr_003 = 0;
	ScriptActionCtr_008 = 0;
	ScriptActionCtr_009 = 0;
	ScriptActionCtr_019 = 0;
	ScriptActionCtr_005 = 0;
	ScriptActionCtr_010 = 0;
	ScriptActionCtr_018 = 0;
	ScriptActionCtr_011 = 0;
	ScriptActionCtr_012 = 0;
	ScriptActionCtr_013 = 0;
	ScriptActionCtr_014 = 0;
	ScriptActionCtr_015 = 0;
	ScriptActionCtr_016 = 0;
	ScriptActionCtr_017 = 0;
	ScriptActionCtr_007 = 0;
}
 
// ========================================
// Function to Save Global Action Counters
// ========================================
void SaveGlobalActionCtrs(void *file_ptr)
{
	File_WriteInt(ScriptActionCtr_000,file_ptr);
	File_WriteInt(ScriptActionCtr_004,file_ptr);
	File_WriteInt(ScriptActionCtr_006,file_ptr);
	File_WriteInt(ScriptActionCtr_001,file_ptr);
	File_WriteInt(ScriptActionCtr_002,file_ptr);
	File_WriteInt(ScriptActionCtr_003,file_ptr);
	File_WriteInt(ScriptActionCtr_008,file_ptr);
	File_WriteInt(ScriptActionCtr_009,file_ptr);
	File_WriteInt(ScriptActionCtr_019,file_ptr);
	File_WriteInt(ScriptActionCtr_005,file_ptr);
	File_WriteInt(ScriptActionCtr_010,file_ptr);
	File_WriteInt(ScriptActionCtr_018,file_ptr);
	File_WriteInt(ScriptActionCtr_011,file_ptr);
	File_WriteInt(ScriptActionCtr_012,file_ptr);
	File_WriteInt(ScriptActionCtr_013,file_ptr);
	File_WriteInt(ScriptActionCtr_014,file_ptr);
	File_WriteInt(ScriptActionCtr_015,file_ptr);
	File_WriteInt(ScriptActionCtr_016,file_ptr);
	File_WriteInt(ScriptActionCtr_017,file_ptr);
	File_WriteInt(ScriptActionCtr_007,file_ptr);
}
 
// ===========================================
// Function to Restore Global Action Counters
// ===========================================
void RestoreGlobalActionCtrs(void *file_ptr)
{
	ScriptActionCtr_000=File_ReadInt(file_ptr);
	ScriptActionCtr_004=File_ReadInt(file_ptr);
	ScriptActionCtr_006=File_ReadInt(file_ptr);
	ScriptActionCtr_001=File_ReadInt(file_ptr);
	ScriptActionCtr_002=File_ReadInt(file_ptr);
	ScriptActionCtr_003=File_ReadInt(file_ptr);
	ScriptActionCtr_008=File_ReadInt(file_ptr);
	ScriptActionCtr_009=File_ReadInt(file_ptr);
	ScriptActionCtr_019=File_ReadInt(file_ptr);
	ScriptActionCtr_005=File_ReadInt(file_ptr);
	ScriptActionCtr_010=File_ReadInt(file_ptr);
	ScriptActionCtr_018=File_ReadInt(file_ptr);
	ScriptActionCtr_011=File_ReadInt(file_ptr);
	ScriptActionCtr_012=File_ReadInt(file_ptr);
	ScriptActionCtr_013=File_ReadInt(file_ptr);
	ScriptActionCtr_014=File_ReadInt(file_ptr);
	ScriptActionCtr_015=File_ReadInt(file_ptr);
	ScriptActionCtr_016=File_ReadInt(file_ptr);
	ScriptActionCtr_017=File_ReadInt(file_ptr);
	ScriptActionCtr_007=File_ReadInt(file_ptr);
}
 
 
// ===============================================================
// Start of Custom Script Block - DO NOT EDIT ANYTHING BEFORE THIS
// ===============================================================
/**{CUSTOM_SCRIPT_BLOCK_START}** DO NOT EDIT! **/
 
/*
$$ACTION
Custom
Tell [o:Alien Organism] to hunt to [o:Destination Object]
//aAlienOrganismHunt
Tell Alien Organism to hunt to Destination Object
Causes an alien organism (and possibly its squad) to go hunting toward a particular object.

Parameters:
  Alien Organism: the alien that should go hunting
  Destination Object: the object to hunt towards
$$END
*/
/*
void aAlienOrganismHunt(int alien_handle, int dest_handle)
{
	SendCommand(alien_handle,alien_handle,ALIEN_COM_HUNT_TO_OBJ,&dest_handle);
}
*/


/*
$$ACTION
Custom
Tell [o:Alien Organism] to scavenge to [o:Destination Object]
aAlienOrganismScav
Tell Alien Organism to scavenge to Destination Object
Causes an alien organism (and possibly its squad) to go scavenging toward a particular object.

Parameters:
  Alien Organism: the alien that should go scavenging
  Destination Object: the object to scavenge towards
$$END
*/
/*
void aAlienOrganismScav(int alien_handle, int dest_handle)
{
	SendCommand(alien_handle,alien_handle,ALIEN_COM_SCAV_TO_OBJ,&dest_handle);
}
*/
 
/**{CUSTOM_SCRIPT_BLOCK_END}**** DO NOT EDIT! **/
// ============================================================
// End of Custom Script Block - DO NOT EDIT ANYTHING AFTER THIS
// ============================================================
 
 
// =================
// Message File Data
// =================
 
#define MAX_SCRIPT_MESSAGES	256
#define MAX_MSG_FILEBUF_LEN	1024
#define NO_MESSAGE_STRING		"*Message Not Found*"
#define INV_MSGNAME_STRING	"*Message Name Invalid*"
#define WHITESPACE_CHARS	" \t\r\n"
 
// Structure for storing a script message
typedef struct {
	char *name;			// the name of the message
	char *message;		// the actual message text
} tScriptMessage;
 
// Global storage for level script messages
tScriptMessage *message_list[MAX_SCRIPT_MESSAGES];
int num_messages;
 
// ======================
// Message File Functions
// ======================
 
// Initializes the Message List
void InitMessageList(void)
{
	for(int j=0;j<MAX_SCRIPT_MESSAGES;j++)
		message_list[j]=NULL;
	num_messages=0;
}
 
// Clear the Message List
void ClearMessageList(void)
{
	for(int j=0;j<num_messages;j++) {
		free(message_list[j]->name);
		free(message_list[j]->message);
		free(message_list[j]);
		message_list[j]=NULL;
	}
	num_messages=0;
}
 
// Adds a message to the list
int AddMessageToList(char *name, char *msg)
{
	int pos;
 
	// Make sure there is room in the list
	if(num_messages>=MAX_SCRIPT_MESSAGES) return false;
 
	// Allocate memory for this message entry
	pos=num_messages;
	message_list[pos]=(tScriptMessage *)malloc(sizeof(tScriptMessage));
	if(message_list[pos]==NULL) return false;
 
	// Allocate memory for the message name
	message_list[pos]->name=(char *)malloc(strlen(name)+1);
	if(message_list[pos]->name==NULL) {
		free(message_list[pos]);
		return false;
	}
	strcpy(message_list[pos]->name,name);
 
	// Allocate memory for the message name
	message_list[pos]->message=(char *)malloc(strlen(msg)+1);
	if(message_list[pos]->message==NULL) {
		free(message_list[pos]->name);
		free(message_list[pos]);
		return false;
	}
	strcpy(message_list[pos]->message,msg);
	num_messages++;
 
	return true;
}
 
// Removes any whitespace padding from the end of a string
void RemoveTrailingWhitespace(char *s)
{
	int last_char_pos;
 
	last_char_pos=strlen(s)-1;
	while(last_char_pos>=0 && isspace(s[last_char_pos])) {
		s[last_char_pos]='\0';
		last_char_pos--;
	}
}
 
// Returns a pointer to the first non-whitespace char in given string
char *SkipInitialWhitespace(char *s)
{
	while((*s)!='\0' && isspace(*s)) 
		s++;
 
	return(s);
}
 
// Read in the Messages
int ReadMessageFile(char *filename)
{
	void *infile;
	char filebuffer[MAX_MSG_FILEBUF_LEN+1];
	char *line, *msg_start;
	int line_num;
	bool next_msgid_found;
 
	// Try to open the file for loading
	infile=File_Open(filename,"rt");
	if (!infile) return false;
 
	line_num=0;
	next_msgid_found=true;
 
	// Clear the message list
	ClearMessageList();
 
	// Read in and parse each line of the file
	while (!File_eof(infile)) {
 
		// Clear the buffer
		strcpy(filebuffer,"");
 
		// Read in a line from the file
		File_ReadString(filebuffer, MAX_MSG_FILEBUF_LEN, infile);
		line_num++;
 
		// Remove whitespace padding at start and end of line
		RemoveTrailingWhitespace(filebuffer);
		line=SkipInitialWhitespace(filebuffer);
 
		// If line is a comment, or empty, discard it
		if(strlen(line)==0 || strncmp(line,"//",2)==0)
			continue;
 
		if(!next_msgid_found) {		// Parse out the last message ID number
 
			// Grab the first keyword, make sure it's valid
			line=strtok(line,WHITESPACE_CHARS);
			if(line==NULL) continue;
 
			// Grab the second keyword, and assign it as the next message ID
			line=strtok(NULL,WHITESPACE_CHARS);
			if(line==NULL) continue;
 
			next_msgid_found=true;
		}
		else {	// Parse line as a message line
			
			// Find the start of message, and mark it
			msg_start=strchr(line,'=');
			if(msg_start==NULL) continue;
			msg_start[0]='\0';
			msg_start++;
			
			// Add the message to the list
			AddMessageToList(line,msg_start);
		}
	}
	File_Close(infile);
 
	return true;
}
 
// Find a message
char *GetMessage(char *name)
{
	// Make sure given name is valid
	if(name==NULL) return INV_MSGNAME_STRING;
 
	// Search message list for name
	for(int j=0;j<num_messages;j++)
		if(strcmp(message_list[j]->name,name)==0) return(message_list[j]->message);
 
	// Couldn't find it
	return NO_MESSAGE_STRING;
}
 
 
//======================
// Name List Arrays     
//======================
 
#define NUM_DOOR_NAMES		0
char **Door_names=NULL;
int *Door_handles=NULL;
 
#define NUM_OBJECT_NAMES		2
char *Object_names[NUM_OBJECT_NAMES] = {
	"Xhyclirtavix",
	"Rescue Ship"
};
int Object_handles[NUM_OBJECT_NAMES];
 
#define NUM_ROOM_NAMES		3
char *Room_names[NUM_ROOM_NAMES] = {
	"14 - 2",
	"14 - 3",
	"Satellite Inside"
};
int Room_indexes[NUM_ROOM_NAMES];
 
#define NUM_TRIGGER_NAMES		0
char **Trigger_names=NULL;
int *Trigger_indexes=NULL;
int *Trigger_faces=NULL;
int *Trigger_rooms=NULL;
 
#define NUM_SOUND_NAMES		4
char *Sound_names[NUM_SOUND_NAMES] = {
	"AmbExplosionFarD",
	"AmbExplosionFarF",
	"Annihilator Taunt",
	"Annihilator Death"
};
int Sound_indexes[NUM_SOUND_NAMES];
 
#define NUM_TEXTURE_NAMES		1
char *Texture_names[NUM_TEXTURE_NAMES] = {
	"FunkyEffect4"
};
int Texture_indexes[NUM_TEXTURE_NAMES];
 
#define NUM_PATH_NAMES		2
char *Path_names[NUM_PATH_NAMES] = {
	"Introduction Camera",
	"Introduction Player"
};
int Path_indexes[NUM_PATH_NAMES];
 
#define NUM_MATCEN_NAMES		1
char *Matcen_names[NUM_MATCEN_NAMES] = {
	"Matcen 1"
};
int Matcen_indexes[NUM_MATCEN_NAMES];
 
#define NUM_GOAL_NAMES		0
char **Goal_names=NULL;
int *Goal_indexes=NULL;
 
#define NUM_MESSAGE_NAMES		11
char *Message_names[NUM_MESSAGE_NAMES] = {
	"Introduction",
	"GB_Distress_Signal",
	"GB_Escape",
	"GB_GoodBadNews",
	"GB_RescueArrived",
	"Rescue_1",
	"Communication",
	"GB_Rescue_Copy",
	"Rescue_2",
	"GB_Critical",
	"GB_First_Sight"
};
char *Message_strings[NUM_MESSAGE_NAMES];
 
// ===============
// InitializeDLL()
// ===============
char STDCALL InitializeDLL(tOSIRISModuleInit *func_list)
{
	osicommon_Initialize((tOSIRISModuleInit *)func_list);
 
	ClearGlobalActionCtrs();
	dfInit();
	InitMessageList();
 
	// Build the filename of the message file
	char filename[_MAX_PATH+1];
	char english_filename[_MAX_PATH+1];
	int lang_type;
	if(func_list->script_identifier!=NULL) {
		_splitpath(func_list->script_identifier,NULL,NULL,filename,NULL);
		sprintf(english_filename,"%s.msg",filename);
		lang_type=Game_GetLanguage();
		if(lang_type==LANGUAGE_FRENCH) strcat(filename,"_FRN");
		else if(lang_type==LANGUAGE_GERMAN) strcat(filename,"_GER");
		else if(lang_type==LANGUAGE_ITALIAN) strcat(filename,"_ITN");
		else if(lang_type==LANGUAGE_SPANISH) strcat(filename,"_SPN");
		else if(lang_type==LANGUAGE_POLISH) strcat(filename,"_POL");
		strcat(filename,".msg");
	}
	else {
		strcpy(filename,"TFZ.msg");
		lang_type=LANGUAGE_ENGLISH;
	}
	if(!ReadMessageFile(filename)) {
		if(lang_type == LANGUAGE_ENGLISH) {
			mprintf(0,"ERROR: Could not load message file - %s\n",filename);
		}
		else if(!ReadMessageFile(english_filename)) {
			mprintf(0,"ERROR: Could not load message file - %s\n",english_filename);
		}
	}
 
	int j;
 
	// Do Door Index lookups
	for(j=0;j<NUM_DOOR_NAMES;j++) 
		Door_handles[j]=Scrpt_FindDoorName(Door_names[j]);
 
	// Do Object Index lookups
	for(j=0;j<NUM_OBJECT_NAMES;j++) 
		Object_handles[j]=Scrpt_FindObjectName(Object_names[j]);
 
	// Do Room Index lookups
	for(j=0;j<NUM_ROOM_NAMES;j++) 
		Room_indexes[j]=Scrpt_FindRoomName(Room_names[j]);
 
	// Do Trigger Index lookups
	for(j=0;j<NUM_TRIGGER_NAMES;j++) {
		Trigger_indexes[j]=Scrpt_FindTriggerName(Trigger_names[j]);
		Trigger_faces[j]=Scrpt_GetTriggerFace(Trigger_indexes[j]);
		Trigger_rooms[j]=Scrpt_GetTriggerRoom(Trigger_indexes[j]);
	}
 
	// Do Sound Index lookups
	for(j=0;j<NUM_SOUND_NAMES;j++) 
		Sound_indexes[j]=Scrpt_FindSoundName(Sound_names[j]);
 
	// Do Texture Index lookups
	for(j=0;j<NUM_TEXTURE_NAMES;j++) 
		Texture_indexes[j]=Scrpt_FindTextureName(Texture_names[j]);
 
	// Do Path Index lookups
	for(j=0;j<NUM_PATH_NAMES;j++) 
		Path_indexes[j]=Scrpt_FindPathName(Path_names[j]);
 
	// Do Matcen Index lookups
	for(j=0;j<NUM_MATCEN_NAMES;j++) 
		Matcen_indexes[j]=Scrpt_FindMatcenName(Matcen_names[j]);
 
	// Do Goal Index lookups
	for(j=0;j<NUM_GOAL_NAMES;j++) 
		Goal_indexes[j]=Scrpt_FindLevelGoalName(Goal_names[j]);
 
	// Do Message Name lookups
	for(j=0;j<NUM_MESSAGE_NAMES;j++) 
		Message_strings[j]=GetMessage(Message_names[j]);
 
	return 1;
}

// =============
// ShutdownDLL()
// =============
void STDCALL ShutdownDLL(void)
{
	ClearMessageList();
}

// ===============
// GetGOScriptID()
// ===============
int STDCALL GetGOScriptID(char *name,ubyte isdoor)
{
	return -1;
}

// ================
// CreateInstance()
// ================
void STDCALLPTR CreateInstance(int id)
{
	switch(id) {
		case ID_LEVEL_0000:
			return new LevelScript_0000;
			break;
		case ID_CUSTOM_OBJECT_1807:
			return new CustomObjectScript_1807;
			break;
		default:
			mprintf(0,"SCRIPT: Illegal ID (%d)\n",id);
			break;
	}
	return NULL;
}

// =================
// DestroyInstance()
// =================
void STDCALL DestroyInstance(int id,void *ptr)
{
	switch(id) {
		case ID_LEVEL_0000:
			delete ((LevelScript_0000 *)ptr);
		case ID_CUSTOM_OBJECT_1807:
			delete ((CustomObjectScript_1807 *)ptr);
			break;
		default:
			mprintf(0,"SCRIPT: Illegal ID (%d)\n",id);
			break;
	}
}

// ===================
// CallInstanceEvent()
// ===================
short STDCALL CallInstanceEvent(int id,void *ptr,int event,tOSIRISEventInfo *data)
{
	switch(id) {
		case ID_LEVEL_0000:
		case ID_CUSTOM_OBJECT_1807:
			return ((BaseScript *)ptr)->CallEvent(event,data);
			break;
		default:
			mprintf(0,"SCRIPT: Illegal ID (%d)\n",id);
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

// ==================
// SaveRestoreState()
// ==================
int STDCALL SaveRestoreState( void *file_ptr, ubyte saving_state )
{
	return 0;
}

// ====================
// GetTriggerScriptID()
// ====================
int	STDCALL GetTriggerScriptID(int trigger_room,int trigger_face)
{
	return -1;
}

// =================
// GetCOScriptList()
// =================
int	STDCALL GetCOScriptList( int **list, int **id_list )
{
	static int cust_handle_list[1];
	static int cust_id_list[1] = { 
		ID_CUSTOM_OBJECT_1807
	};
 
	// Fill in the custom handle list
	cust_handle_list[0]=Object_handles[0];

	*list = cust_handle_list;
	*id_list = cust_id_list;

	return 1;
}

//=======================
// Script Implementation 
//=======================

BaseScript::BaseScript()
{
}

BaseScript::~BaseScript()
{
}

short BaseScript::CallEvent(int event,tOSIRISEventInfo *data)
{
	mprintf(0,"BaseScript::CallEvent()\n");
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short LevelScript_0000::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_SAVESTATE:
			{
				tOSIRISEVTSAVESTATE *event_data=&data->evt_savestate;
	
				SaveGlobalActionCtrs(event_data->fileptr);
				dfSave(event_data->fileptr);
#ifdef ENABLE_CUSTOM_SAVE_AND_RESTORE
				dsCustomSave(event_data->fileptr);
#endif
			}
			break;
		case EVT_RESTORESTATE:
			{
				tOSIRISEVTRESTORESTATE *event_data=&data->evt_restorestate;
	
				RestoreGlobalActionCtrs(event_data->fileptr);
				dfRestore(event_data->fileptr);
#ifdef ENABLE_CUSTOM_SAVE_AND_RESTORE
				dsCustomRestore(event_data->fileptr);
#endif
			}
			break;
		case EVT_INTERVAL:
			{
				tOSIRISEVTINTERVAL *event_data=&data->evt_interval;
 
				// Script 001: [Cheat Check] Is Xhyclirtavix Dead
				if((ScriptActionCtr_001 < 1) && ((qObjExists(Object_handles[0])==false) && (qUserFlag(0)==0)))
				{
					aFailLevel();
					
					// Increment the script action counter
					if(ScriptActionCtr_001 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_001++;
				}
 
				// Script 008: [Xhyclirtavix] Mine Finished
				if((ScriptActionCtr_008 < 1) && (qObjShields(Object_handles[0])<=7500.000000f))
				{
					aPortalRenderSet(0, 1, Room_indexes[0], 1);
					aSoundPlayObject(Sound_indexes[2], Object_handles[0], 1.000000f);
					aCloakObject(Object_handles[0], 0.010000f);
					aAIGoalGotoRoom(Object_handles[0], Room_indexes[1], 3, 145, 0);
					aShowHUDMessage(Message_strings[2]);
					aUserFlagSet(1, 1);
					
					// Increment the script action counter
					if(ScriptActionCtr_008 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_008++;
				}
 
				// Script 009: [Xhyclirtavix] Goal Escape Finished / Start Terrain
				if((ScriptActionCtr_009 < 1) && (qObjOnTerrain(Object_handles[0])==1))
				{
					aShowHUDMessage(Message_strings[3]);
					aAIClearGoal(3, Object_handles[0]);
					aAIGoalGotoRoom(Object_handles[0], Room_indexes[2], 3, 0, 1);
					aObjSetShields(Object_handles[0], 15000.000000f);
					aSetLevelTimer(qRandomValue(180.000000f, 300.000000f), 5);
					
					// Increment the script action counter
					if(ScriptActionCtr_009 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_009++;
				}
			}
			break;
		case EVT_LEVELSTART:
			{
				tOSIRISEVTLEVELSTART *event_data=&data->evt_levelstart;
 
				ClearGlobalActionCtrs();
				dfInit();
 
				// Script 000: [Level Start] Variables Initiated
				if(1)
				{
					aSetLevelTimer(40.000000f, 0);
					aSetLevelTimer(qRandomValue(5.000000f, 60.000000f), 3);
					aMatcenSetEnableState(1, Matcen_indexes[0]);
					aObjGhostSet(1, Object_handles[0]);
					aObjGhostSet(1, Object_handles[1]);
					aObjSaveHandle(qPlayerClosest(Object_handles[0], 1), 0);
					aAISetMaxSpeed(Object_handles[1], 10.000000f);
					aRainTurnOn(1.000000f);
					aSnowTurnOn(1.000000f);
					aLightningTurnOn(qRandomValue(2.000000f, 3.500000f), 0.500000f);
					aAISetState(0, Object_handles[0]);
					aPortalRenderToggle(1, Room_indexes[0], 1);
					aUserFlagSet(1, 0);
					aUserFlagSet(2, 0);
					aUserFlagSet(0, 0);
					aUserFlagSet(3, 0);
					
					// Increment the script action counter
					if(ScriptActionCtr_000 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_000++;
				}
 
				// Script 004: [Level Start] Introduction Cinematic
				if(1)
				{
					aCinematicIntro(Path_indexes[0], Message_strings[0], Object_handles[0], Path_indexes[1], 30.000000f);
					
					// Increment the script action counter
					if(ScriptActionCtr_004 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_004++;
				}
			}
			break;
		case EVT_TIMER:
			{
				tOSIRISEVTTIMER *event_data=&data->evt_timer;
 
				// Script 006: [Level] Krandathlarquake
				if(event_data->id==3)
				{
					if(1)
					{
						aMiscViewerShake(qRandomValue(25.000000f, 100.000000f));
						aUserVarSet(0, qRandomValue(0.000000f, 1.000000f));
						if(qUserVarValue(0)<0.500000f)
						{
							aUserVarSet(0, 0.000000f);
						}
						if(qUserVarValue(0)>=0.500000f)
						{
							aUserVarSet(0, 1.000000f);
						}
						if(qUserVarValue(0)==1.000000f)
						{
							aSoundPlay2D(Sound_indexes[0], 1.000000f);
						}
						else {
							aSoundPlay2D(Sound_indexes[1], 1.000000f);
						}
						aSetLevelTimer(qRandomValue(5.000000f, 60.000000f), 3);
					}
					
					// Increment the script action counter
					if(ScriptActionCtr_006 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_006++;
				}
 
				// Script 002: [Xhyclirtavix] Awakened
				if((ScriptActionCtr_002 < 1) && (event_data->id==0))
				{
					aObjGhostSet(0, Object_handles[0]);
					aCloakObject(Object_handles[0], 0.010000f);
					aAISetState(1, Object_handles[0]);
					aShowHUDMessage(Message_strings[1]);
					
					// Increment the script action counter
					if(ScriptActionCtr_002 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_002++;
				}
 
				// Script 005: [Xhyclirtavix] Death
				if((ScriptActionCtr_005 < 1) && (event_data->id==1))
				{
					aSoundPlayObject(Sound_indexes[3], Object_handles[0], 1.000000f);
					aObjFireWeapon("Shockwave - Xhyclirtavix", -1, Object_handles[0]);
					aObjFireWeapon("Shockwave - Xhyclirtavix", -1, Object_handles[0]);
					aObjFireWeapon("Shockwave - Xhyclirtavix", -1, Object_handles[0]);
					aObjDelete(Object_handles[0]);
					
					// Increment the script action counter
					if(ScriptActionCtr_005 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_005++;
				}
 
				// Script 018: [Xhyclirtavix] Shockwave Annihilated Player 2
				if((ScriptActionCtr_018 < 1) && (event_data->id==11))
				{
					aFailLevel();
					
					// Increment the script action counter
					if(ScriptActionCtr_018 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_018++;
				}
 
				// Script 011: [Rescue Ship] Arrived Above
				if((ScriptActionCtr_011 < 1) && (event_data->id==5))
				{
					aObjGhostSet(0, Object_handles[1]);
					aShowHUDMessage(Message_strings[4]);
					aSetLevelTimer(5.000000f, 2);
					
					// Increment the script action counter
					if(ScriptActionCtr_011 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_011++;
				}
 
				// Script 012: [Rescue Ship] First Message
				if((ScriptActionCtr_012 < 1) && (event_data->id==2))
				{
					aAddGameMessage(Message_strings[5], Message_strings[6]);
					aSoundPlaySteamingText("VoxRescue1.osf", 0.450000f);
					aSetLevelTimer(7.500000f, 6);
					
					// Increment the script action counter
					if(ScriptActionCtr_012 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_012++;
				}
 
				// Script 013: [Rescue Ship] First Reply
				if((ScriptActionCtr_013 < 1) && (event_data->id==6))
				{
					aShowHUDMessage(Message_strings[7]);
					aSetLevelTimer(3.000000f, 7);
					
					// Increment the script action counter
					if(ScriptActionCtr_013 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_013++;
				}
 
				// Script 014: [Rescue Ship] Second Message
				if((ScriptActionCtr_014 < 1) && (event_data->id==7))
				{
					aAddGameMessage(Message_strings[8], Message_strings[6]);
					aSoundPlaySteamingText("VoxRescue2.osf", 0.450000f);
					aSetLevelTimer(2.500000f, 8);
					
					// Increment the script action counter
					if(ScriptActionCtr_014 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_014++;
				}
 
				// Script 015: [Rescue Ship] Second Reply
				if((ScriptActionCtr_015 < 1) && (event_data->id==8))
				{
					aShowHUDMessage(Message_strings[7]);
					aSetLevelTimer(600.000000f, 9);
					
					// Increment the script action counter
					if(ScriptActionCtr_015 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_015++;
				}
 
				// Script 016: [Rescue Ship] Attack on Xhyclirtavix
				if((ScriptActionCtr_016 < 1) && (event_data->id==9))
				{
					aLightningCreate(Object_handles[1], Object_handles[0], 7.500000f, 1.000000f, 1, Texture_indexes[0], 0.000000f, 0, 0, 255, 0, 0);
					aSetLevelTimer(7.500000f, 10);
					
					// Increment the script action counter
					if(ScriptActionCtr_016 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_016++;
				}
 
				// Script 017: [Rescue Ship] Xhyclirtavix Owned
				if((ScriptActionCtr_017 < 1) && ((event_data->id==10) && (qUserFlag(1)==1)))
				{
					aUserFlagSet(0, 1);
					aAISetState(0, Object_handles[0]);
					aAISetMaxSpeed(Object_handles[0], 0.000000f);
					aObjSpark(Object_handles[0], 100.000000f, 30.000000f);
					aSetObjectOnFire(Object_handles[0], 30.000000f, 0.000000f);
					aTurnOnSpew(Object_handles[0], -1, 7, 0.000000f, 0.000000f, 65536, 0, 1.500000f, 0.150000f, -1.000000f, 4.000000f, 20.000000f, 1, -1);
					aTurnOnSpew(Object_handles[0], 0, 7, 0.000000f, 0.000000f, 65536, 0, 1.500000f, 0.150000f, -1.000000f, 4.000000f, 20.000000f, 1, -1);
					aTurnOnSpew(Object_handles[0], 1, 7, 0.000000f, 0.000000f, 65536, 0, 1.500000f, 0.150000f, -1.000000f, 4.000000f, 20.000000f, 1, -1);
					aSetLevelTimer(30.000000f, 1);
					aTimerShow(1);
					aShowHUDMessage(Message_strings[9]);
					
					// Increment the script action counter
					if(ScriptActionCtr_017 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_017++;
				}
			}
			break;
		case EVT_AIN_GOALCOMPLETE:
			{
				tOSIRISEVTAINOTIFY *event_data=&data->evt_ain_goalcomplete;
 
				// Script 019: [Xhyclirtavix] Goal Tower Finished
				if((ScriptActionCtr_019 < 1) && (event_data->goal_uid==1))
				{
					aAISetTarget(Object_handles[0], qObjSavedHandle(0));
					
					// Increment the script action counter
					if(ScriptActionCtr_019 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_019++;
				}
			}
			break;
		case EVT_PLAYER_DIES:
			{
				tOSIRISEVTPLAYERDIES *event_data=&data->evt_player_dies;
 
				// Script 010: [Xhyclirtavix] Shockwave Annihilated Player 1
				if(qUserFlag(0)==1)
				{
					aSetLevelTimer(0.750000f, 11);
					
					// Increment the script action counter
					if(ScriptActionCtr_010 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_010++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

short CustomObjectScript_1807::CallEvent(int event,tOSIRISEventInfo *data)
{
	switch(event) { 
		case EVT_COLLIDE:
			{
				tOSIRISEVTCOLLIDE *event_data=&data->evt_collide;
 
				// Script 003: [Xhyclirtavix] Defense Plasma System
				if((qObjIsEnergyWeapon(event_data->it_handle)==true) && (qUserFlag(0)==0))
				{
					aObjFireWeapon("Defense Plasma System", -1, data->me_handle);
					
					// Increment the script action counter
					if(ScriptActionCtr_003 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_003++;
				}
			}
			break;
		case EVT_AIN_SEEPLAYER:
			{
				tOSIRISEVTAINOTIFY *event_data=&data->evt_ain_seeplayer;
 
				// Script 007: [GUIDEBOT] Xhyclirtavix Sighted
				if((ScriptActionCtr_007 < 1) && (qObjIsPlayer(event_data->it_handle)==1))
				{
					aShowHUDMessageObj(Message_strings[10], event_data->it_handle);
					
					// Increment the script action counter
					if(ScriptActionCtr_007 < MAX_ACTION_CTR_VALUE) ScriptActionCtr_007++;
				}
			}
			break;
	}
	return CONTINUE_CHAIN|CONTINUE_DEFAULT;
}

 
 
/*********************************************************
Script Save Block: DO NOT TOUCH ANYTHING IN THIS BLOCK!!! 
**********************************************************
$$SCRIPT_BLOCK_START
 
VERSION		3
NEXT_ID		20
 
// UserType value blocks
$$UTYPE_VALS_START UserVar
0:Level_Quake
1:Useless
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START UserFlag
0:Is_Xhyclirtavix_Dead
1:Is_Mine_Finished
2:Is_Terrain_Finished
3:Is_Within_Rescue_Ship
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START SpewHandle
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START TimerID
0:Xhyclirtavix_Sleep_Time
1:Xhyclirtavix_Supernova_Countdown
2:Rescue_Ship_Countdown1
3:Level_Timer_Quake
4:Level_Timer_Windstorm
5:Rescue_Ship_Countdown_Arrived
6:Rescue_Ship_Countdown2
7:Rescue_Ship_Countdown3
8:Rescue_Ship_Countdown4
9:Rescue_Ship_Countdown5
10:Rescue_Ship_Countdown6
11:Failed_Shockwave
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START SavedObjectSlot
0:Player0
$$UTYPE_VALS_END
 
$$UTYPE_VALS_START GoalID
0:GID_Escape
1:GID_Tower
$$UTYPE_VALS_END
 
 
// Name Lists
$$DOOR_LIST_START
$$DOOR_LIST_END
 
$$OBJECT_LIST_START
Xhyclirtavix
Rescue Ship
$$OBJECT_LIST_END
 
$$ROOM_LIST_START
14 - 2
14 - 3
Satellite Inside
$$ROOM_LIST_END
 
$$TRIGGER_LIST_START
$$TRIGGER_LIST_END
 
$$SOUND_LIST_START
AmbExplosionFarD
AmbExplosionFarF
Annihilator Taunt
Annihilator Death
$$SOUND_LIST_END
 
$$TEXTURE_LIST_START
FunkyEffect4
$$TEXTURE_LIST_END
 
$$SPECNAME_LIST_START
Defense Plasma System
Shockwave - Xhyclirtavix
VoxRescue1.osf
VoxRescue2.osf
$$SPECNAME_LIST_END
 
$$PATH_LIST_START
Introduction Camera
Introduction Player
$$PATH_LIST_END
 
$$MATCEN_LIST_START
Matcen 1
$$MATCEN_LIST_END
 
$$GOAL_LIST_START
$$GOAL_LIST_END
 
$$STRM_AUDIO_LIST_START
$$STRM_AUDIO_LIST_END
 
 
// Script Tree Dump
00:0:[Level Start] Variables Initiated 
	$$CHILD_BLOCK_START
	01:2:0 
	02:6 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:40.000000:Time 
			10:10:0:0:TimerID 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			06:qRandomValue:Time 
				$$CHILD_BLOCK_START
				10:6:5.000000:LowerLimit 
				10:6:60.000000:UpperLimit 
				$$CHILD_BLOCK_END
			10:10:0:3:TimerID 
			$$CHILD_BLOCK_END
		08:aMatcenSetEnableState 
			$$CHILD_BLOCK_START
			10:10:0:1:Enable/Disable 
			10:17:0:0:Matcen 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:1:Ghost/Unghost 
			10:1:0:1:Object 
			$$CHILD_BLOCK_END
		08:aObjSaveHandle 
			$$CHILD_BLOCK_START
			06:qPlayerClosest:Object 
				$$CHILD_BLOCK_START
				10:1:0:0:Object 
				10:10:0:1:UserVar 
				$$CHILD_BLOCK_END
			10:10:0:0:SavedObjectSlot 
			$$CHILD_BLOCK_END
		08:aAISetMaxSpeed 
			$$CHILD_BLOCK_START
			10:1:0:1:Object 
			10:6:10.000000:MaxSpeed 
			$$CHILD_BLOCK_END
		08:aRainTurnOn 
			$$CHILD_BLOCK_START
			10:9:1.000000:Density 
			$$CHILD_BLOCK_END
		08:aSnowTurnOn 
			$$CHILD_BLOCK_START
			10:9:1.000000:Density 
			$$CHILD_BLOCK_END
		08:aLightningTurnOn 
			$$CHILD_BLOCK_START
			06:qRandomValue:Seconds 
				$$CHILD_BLOCK_START
				10:6:2.000000:LowerLimit 
				10:6:3.500000:UpperLimit 
				$$CHILD_BLOCK_END
			10:9:0.500000:Probability 
			$$CHILD_BLOCK_END
		08:aAISetState 
			$$CHILD_BLOCK_START
			10:10:0:0:On/Off 
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aPortalRenderToggle 
			$$CHILD_BLOCK_START
			10:4:1:PortalNum 
			10:2:0:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:1:UserFlag 
			10:5:0:True/False 
			$$CHILD_BLOCK_END
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:2:UserFlag 
			10:5:0:True/False 
			$$CHILD_BLOCK_END
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:0:UserFlag 
			10:5:0:True/False 
			$$CHILD_BLOCK_END
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:3:UserFlag 
			10:5:0:True/False 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:4:[Level Start] Introduction Cinematic 
	$$CHILD_BLOCK_START
	01:2:0 
	02:6 
	03:0 
		$$CHILD_BLOCK_START
		05:0 
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aCinematicIntro 
			$$CHILD_BLOCK_START
			10:16:0:CameraPath 
			10:8:Introduction:Text 
			10:1:0:0:TotallyNotUsedTarget 
			10:16:1:PlayerPath 
			10:6:30.000000:Seconds 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:6:[Level] Krandathlarquake 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:3:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		03:1 
			$$CHILD_BLOCK_START
			05:0 
			$$CHILD_BLOCK_END
		04:1:0:0 
			$$CHILD_BLOCK_START
			08:aMiscViewerShake 
				$$CHILD_BLOCK_START
				06:qRandomValue:Amount 
					$$CHILD_BLOCK_START
					10:6:25.000000:LowerLimit 
					10:6:100.000000:UpperLimit 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			08:aUserVarSet 
				$$CHILD_BLOCK_START
				10:10:0:0:UserVar 
				06:qRandomValue:value 
					$$CHILD_BLOCK_START
					10:6:0.000000:LowerLimit 
					10:6:1.000000:UpperLimit 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			03:1 
				$$CHILD_BLOCK_START
				05:2 
					$$CHILD_BLOCK_START
					06:qUserVarValue:Float 
						$$CHILD_BLOCK_START
						10:10:0:0:UserVar 
						$$CHILD_BLOCK_END
					07:1:3 
					10:6:0.500000:Literal 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			04:1:0:0 
				$$CHILD_BLOCK_START
				08:aUserVarSet 
					$$CHILD_BLOCK_START
					10:10:0:0:UserVar 
					10:6:0.000000:value 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			03:1 
				$$CHILD_BLOCK_START
				05:2 
					$$CHILD_BLOCK_START
					06:qUserVarValue:Float 
						$$CHILD_BLOCK_START
						10:10:0:0:UserVar 
						$$CHILD_BLOCK_END
					07:1:4 
					10:6:0.500000:Literal 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			04:1:0:0 
				$$CHILD_BLOCK_START
				08:aUserVarSet 
					$$CHILD_BLOCK_START
					10:10:0:0:UserVar 
					10:6:1.000000:value 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			03:1 
				$$CHILD_BLOCK_START
				05:2 
					$$CHILD_BLOCK_START
					06:qUserVarValue:Float 
						$$CHILD_BLOCK_START
						10:10:0:0:UserVar 
						$$CHILD_BLOCK_END
					07:1:0 
					10:6:1.000000:Literal 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			04:1:0:0 
				$$CHILD_BLOCK_START
				08:aSoundPlay2D 
					$$CHILD_BLOCK_START
					10:12:0:Sound 
					10:9:1.000000:Volume 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			04:1:0:1 
				$$CHILD_BLOCK_START
				08:aSoundPlay2D 
					$$CHILD_BLOCK_START
					10:12:1:Sound 
					10:9:1.000000:Volume 
					$$CHILD_BLOCK_END
				$$CHILD_BLOCK_END
			08:aSetLevelTimer 
				$$CHILD_BLOCK_START
				06:qRandomValue:Time 
					$$CHILD_BLOCK_START
					10:6:5.000000:LowerLimit 
					10:6:60.000000:UpperLimit 
					$$CHILD_BLOCK_END
				10:10:0:3:TimerID 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:1:[Cheat Check] Is Xhyclirtavix Dead 
	$$CHILD_BLOCK_START
	01:2:0 
	02:5 
	03:0 
		$$CHILD_BLOCK_START
		09:0 
			$$CHILD_BLOCK_START
			05:1 
				$$CHILD_BLOCK_START
				06:qObjExists:Bool 
					$$CHILD_BLOCK_START
					10:1:0:0:Object 
					$$CHILD_BLOCK_END
				07:0:7 
				$$CHILD_BLOCK_END
			05:2 
				$$CHILD_BLOCK_START
				06:qUserFlag:Bool 
					$$CHILD_BLOCK_START
					10:10:0:0:UserFlag 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:0:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aFailLevel 
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:2:[Xhyclirtavix] Awakened 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:0:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:0:Ghost/Unghost 
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aCloakObject 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:6:0.010000:Seconds 
			$$CHILD_BLOCK_END
		08:aAISetState 
			$$CHILD_BLOCK_START
			10:10:0:1:On/Off 
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aShowHUDMessage 
			$$CHILD_BLOCK_START
			10:8:GB_Distress_Signal:Message 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:3:[Xhyclirtavix] Defense Plasma System 
	$$CHILD_BLOCK_START
	01:1:0 
	02:0 
	03:0 
		$$CHILD_BLOCK_START
		09:0 
			$$CHILD_BLOCK_START
			05:1 
				$$CHILD_BLOCK_START
				06:qObjIsEnergyWeapon:Bool 
					$$CHILD_BLOCK_START
					10:1:1:-1:Object 
					$$CHILD_BLOCK_END
				07:0:6 
				$$CHILD_BLOCK_END
			05:2 
				$$CHILD_BLOCK_START
				06:qUserFlag:Bool 
					$$CHILD_BLOCK_START
					10:10:0:0:UserFlag 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:0:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aObjFireWeapon 
			$$CHILD_BLOCK_START
			10:13:0:WeaponName 
			10:4:-1:GunNum 
			10:1:2:-1:Object 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:8:[Xhyclirtavix] Mine Finished 
	$$CHILD_BLOCK_START
	01:2:0 
	02:5 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjShields:Float 
				$$CHILD_BLOCK_START
				10:1:0:0:Object 
				$$CHILD_BLOCK_END
			07:1:5 
			10:6:7500.000000:Literal 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aPortalRenderSet 
			$$CHILD_BLOCK_START
			10:10:0:0:Enable/Disable 
			10:4:1:PortalNum 
			10:2:0:Room 
			10:5:1:DoublesidedFlag 
			$$CHILD_BLOCK_END
		08:aSoundPlayObject 
			$$CHILD_BLOCK_START
			10:12:2:Sound 
			10:1:0:0:Object 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		08:aCloakObject 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:6:0.010000:Seconds 
			$$CHILD_BLOCK_END
		08:aAIGoalGotoRoom 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:2:1:Room 
			10:10:0:3:GoalPriority 
			10:15:145:AIGoalFlags 
			10:10:0:0:GoalID 
			$$CHILD_BLOCK_END
		08:aShowHUDMessage 
			$$CHILD_BLOCK_START
			10:8:GB_Escape:Message 
			$$CHILD_BLOCK_END
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:1:UserFlag 
			10:5:1:True/False 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:9:[Xhyclirtavix] Goal Escape Finished / Start Terrain 
	$$CHILD_BLOCK_START
	01:2:0 
	02:5 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjOnTerrain:Bool 
				$$CHILD_BLOCK_START
				10:1:0:0:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aShowHUDMessage 
			$$CHILD_BLOCK_START
			10:8:GB_GoodBadNews:Message 
			$$CHILD_BLOCK_END
		08:aAIClearGoal 
			$$CHILD_BLOCK_START
			10:10:0:3:GoalPriority 
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aAIGoalGotoRoom 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:2:2:Room 
			10:10:0:3:GoalPriority 
			10:15:0:AIGoalFlags 
			10:10:0:1:GoalID 
			$$CHILD_BLOCK_END
		08:aObjSetShields 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:6:15000.000000:Shields 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			06:qRandomValue:Time 
				$$CHILD_BLOCK_START
				10:6:180.000000:LowerLimit 
				10:6:300.000000:UpperLimit 
				$$CHILD_BLOCK_END
			10:10:0:5:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:19:[Xhyclirtavix] Goal Tower Finished 
	$$CHILD_BLOCK_START
	01:2:0 
	02:13 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:1:0:GoalID 
			07:1:0 
			10:10:0:1:GoalID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aAISetTarget 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			06:qObjSavedHandle:Target 
				$$CHILD_BLOCK_START
				10:10:0:0:SavedObjectSlot 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:5:[Xhyclirtavix] Death 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:1:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aSoundPlayObject 
			$$CHILD_BLOCK_START
			10:12:3:Sound 
			10:1:0:0:Object 
			10:9:1.000000:Volume 
			$$CHILD_BLOCK_END
		08:aObjFireWeapon 
			$$CHILD_BLOCK_START
			10:13:1:WeaponName 
			10:4:-1:GunNum 
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aObjFireWeapon 
			$$CHILD_BLOCK_START
			10:13:1:WeaponName 
			10:4:-1:GunNum 
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aObjFireWeapon 
			$$CHILD_BLOCK_START
			10:13:1:WeaponName 
			10:4:-1:GunNum 
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aObjDelete 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:10:[Xhyclirtavix] Shockwave Annihilated Player 1 
	$$CHILD_BLOCK_START
	01:2:0 
	02:31 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qUserFlag:Bool 
				$$CHILD_BLOCK_START
				10:10:0:0:UserFlag 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:0 
		$$CHILD_BLOCK_START
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:0.750000:Time 
			10:10:0:11:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:18:[Xhyclirtavix] Shockwave Annihilated Player 2 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:11:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aFailLevel 
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:11:[Rescue Ship] Arrived Above 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:5:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aObjGhostSet 
			$$CHILD_BLOCK_START
			10:10:0:0:Ghost/Unghost 
			10:1:0:1:Object 
			$$CHILD_BLOCK_END
		08:aShowHUDMessage 
			$$CHILD_BLOCK_START
			10:8:GB_RescueArrived:Message 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:5.000000:Time 
			10:10:0:2:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:12:[Rescue Ship] First Message 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:2:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aAddGameMessage 
			$$CHILD_BLOCK_START
			10:8:Rescue_1:GameMessage 
			10:8:Communication:HUDMessage 
			$$CHILD_BLOCK_END
		08:aSoundPlaySteamingText 
			$$CHILD_BLOCK_START
			10:13:2:SoundName 
			10:9:0.450000:Volume 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:7.500000:Time 
			10:10:0:6:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:13:[Rescue Ship] First Reply 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:6:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aShowHUDMessage 
			$$CHILD_BLOCK_START
			10:8:GB_Rescue_Copy:Message 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:3.000000:Time 
			10:10:0:7:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:14:[Rescue Ship] Second Message 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:7:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aAddGameMessage 
			$$CHILD_BLOCK_START
			10:8:Rescue_2:GameMessage 
			10:8:Communication:HUDMessage 
			$$CHILD_BLOCK_END
		08:aSoundPlaySteamingText 
			$$CHILD_BLOCK_START
			10:13:3:SoundName 
			10:9:0.450000:Volume 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:2.500000:Time 
			10:10:0:8:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:15:[Rescue Ship] Second Reply 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:8:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aShowHUDMessage 
			$$CHILD_BLOCK_START
			10:8:GB_Rescue_Copy:Message 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:600.000000:Time 
			10:10:0:9:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:16:[Rescue Ship] Attack on Xhyclirtavix 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			10:10:2:0:TimerID 
			07:1:0 
			10:10:0:9:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aLightningCreate 
			$$CHILD_BLOCK_START
			10:1:0:1:Object1 
			10:1:0:0:Object2 
			10:6:7.500000:Lifetime 
			10:6:1.000000:Thickness 
			10:4:1:NumTiles 
			10:14:0:Texture 
			10:6:0.000000:SlideTime 
			10:4:0:TimesDrawn 
			10:4:0:Red 
			10:4:255:Green 
			10:4:0:Blue 
			10:5:0:AutoTile 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:7.500000:Time 
			10:10:0:10:TimerID 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:17:[Rescue Ship] Xhyclirtavix Owned 
	$$CHILD_BLOCK_START
	01:2:0 
	02:9 
	03:0 
		$$CHILD_BLOCK_START
		09:0 
			$$CHILD_BLOCK_START
			05:2 
				$$CHILD_BLOCK_START
				10:10:2:0:TimerID 
				07:1:0 
				10:10:0:10:TimerID 
				$$CHILD_BLOCK_END
			05:2 
				$$CHILD_BLOCK_START
				06:qUserFlag:Bool 
					$$CHILD_BLOCK_START
					10:10:0:1:UserFlag 
					$$CHILD_BLOCK_END
				07:1:0 
				10:5:1:Bool 
				$$CHILD_BLOCK_END
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aUserFlagSet 
			$$CHILD_BLOCK_START
			10:10:0:0:UserFlag 
			10:5:1:True/False 
			$$CHILD_BLOCK_END
		08:aAISetState 
			$$CHILD_BLOCK_START
			10:10:0:0:On/Off 
			10:1:0:0:Object 
			$$CHILD_BLOCK_END
		08:aAISetMaxSpeed 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:6:0.000000:MaxSpeed 
			$$CHILD_BLOCK_END
		08:aObjSpark 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:6:100.000000:SparkRate 
			10:6:30.000000:Time 
			$$CHILD_BLOCK_END
		08:aSetObjectOnFire 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:6:30.000000:Seconds 
			10:6:0.000000:Damage 
			$$CHILD_BLOCK_END
		08:aTurnOnSpew 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:4:-1:GunNum 
			10:10:0:7:SpewType 
			10:6:0.000000:Mass 
			10:6:0.000000:Drag 
			10:15:65536:PhysicsFlags 
			10:5:0:IsRealObject 
			10:6:1.500000:BlobLifetime 
			10:6:0.150000:BlobInterval 
			10:6:-1.000000:SpewLife 
			10:6:4.000000:BlobSize 
			10:6:20.000000:BlobSpeed 
			10:5:1:Randomize 
			10:10:0:-1:SpewHandle 
			$$CHILD_BLOCK_END
		08:aTurnOnSpew 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:4:0:GunNum 
			10:10:0:7:SpewType 
			10:6:0.000000:Mass 
			10:6:0.000000:Drag 
			10:15:65536:PhysicsFlags 
			10:5:0:IsRealObject 
			10:6:1.500000:BlobLifetime 
			10:6:0.150000:BlobInterval 
			10:6:-1.000000:SpewLife 
			10:6:4.000000:BlobSize 
			10:6:20.000000:BlobSpeed 
			10:5:1:Randomize 
			10:10:0:-1:SpewHandle 
			$$CHILD_BLOCK_END
		08:aTurnOnSpew 
			$$CHILD_BLOCK_START
			10:1:0:0:Object 
			10:4:1:GunNum 
			10:10:0:7:SpewType 
			10:6:0.000000:Mass 
			10:6:0.000000:Drag 
			10:15:65536:PhysicsFlags 
			10:5:0:IsRealObject 
			10:6:1.500000:BlobLifetime 
			10:6:0.150000:BlobInterval 
			10:6:-1.000000:SpewLife 
			10:6:4.000000:BlobSize 
			10:6:20.000000:BlobSpeed 
			10:5:1:Randomize 
			10:10:0:-1:SpewHandle 
			$$CHILD_BLOCK_END
		08:aSetLevelTimer 
			$$CHILD_BLOCK_START
			10:6:30.000000:Time 
			10:10:0:1:TimerID 
			$$CHILD_BLOCK_END
		08:aTimerShow 
			$$CHILD_BLOCK_START
			10:10:0:1:TimerID 
			$$CHILD_BLOCK_END
		08:aShowHUDMessage 
			$$CHILD_BLOCK_START
			10:8:GB_Critical:Message 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
00:7:[GUIDEBOT] Xhyclirtavix Sighted 
	$$CHILD_BLOCK_START
	01:1:0 
	02:11 
	03:0 
		$$CHILD_BLOCK_START
		05:2 
			$$CHILD_BLOCK_START
			06:qObjIsPlayer:Bool 
				$$CHILD_BLOCK_START
				10:1:1:-1:Object 
				$$CHILD_BLOCK_END
			07:1:0 
			10:5:1:Bool 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	04:0:0:1 
		$$CHILD_BLOCK_START
		08:aShowHUDMessageObj 
			$$CHILD_BLOCK_START
			10:8:GB_First_Sight:Message 
			10:1:1:-1:PlayerObject 
			$$CHILD_BLOCK_END
		$$CHILD_BLOCK_END
	$$CHILD_BLOCK_END
 
$$SCRIPT_BLOCK_END
*********************************************************/
